Package: CAGEfightR
Type: Package
Title: Analysis of Cap Analysis of Gene Expression (CAGE) data using
        Bioconductor
Version: 1.31.0
Author: Malte Thodberg
Maintainer: Malte Thodberg <maltethodberg@gmail.com>
Description: CAGE is a widely used high throughput assay for measuring 
		transcription start site (TSS) activity. CAGEfightR is an R/Bioconductor 
		package for performing a wide range of common data analysis tasks for CAGE and 5'-end data in general. 
		Core functionality includes: import of CAGE TSSs (CTSSs), tag 
		(or unidirectional) clustering for TSS identification, 
		bidirectional clustering for enhancer identification, annotation with 
		transcript and gene models, correlation of TSS and enhancer expression, calculation of TSS shapes, quantification of 
		CAGE expression as expression matrices and genome brower visualization.
URL: https://github.com/MalteThodberg/CAGEfightR
BugReports: https://github.com/MalteThodberg/CAGEfightR/issues
Depends: R (>= 3.5), GenomicRanges (>= 1.61.1), rtracklayer (>=
        1.69.1), SummarizedExperiment (>= 1.39.1)
Imports: pryr(>= 0.1.3), assertthat(>= 0.2.0), methods(>= 3.6.3),
        Matrix(>= 1.2-12), BiocGenerics(>= 0.24.0), S4Vectors(>=
        0.16.0), IRanges(>= 2.12.0), Seqinfo, GenomicFeatures(>=
        1.61.4), GenomicAlignments(>= 1.45.1), BiocParallel(>= 1.12.0),
        GenomicFiles(>= 1.14.0), Gviz(>= 1.22.2), InteractionSet(>=
        1.9.4), GenomicInteractions(>= 1.15.1)
License: GPL-3 + file LICENSE
Encoding: UTF-8
LazyData: true
RoxygenNote: 7.3.2
Suggests: knitr, rmarkdown, BiocStyle, org.Mm.eg.db,
        TxDb.Mmusculus.UCSC.mm9.knownGene
VignetteBuilder: knitr
biocViews: Software, Transcription, Coverage, GeneExpression,
        GeneRegulation, PeakDetection, DataImport, DataRepresentation,
        Transcriptomics, Sequencing, Annotation, GenomeBrowsers,
        Normalization, Preprocessing, Visualization
git_url: https://git.bioconductor.org/packages/CAGEfightR
git_branch: devel
git_last_commit: c45462c
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-11-04
NeedsCompilation: no
Packaged: 2025-11-04 21:37:07 UTC; biocbuild

# CAGEfightR

CAGEfightR is an R-package for analyzing Cap Analysis of Gene Expression (CAGE) data in Bioconductor. 

## Installation

Install the most recent stable version from Bioconductor:

```{r bioconductor, eval=FALSE}
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("CAGEfightR")
```

Or install the development version directly from GitHub using `devtools`:

``` r
# Install CRAN packages and CAGEfightR
devtools::install_github("MalteThodberg/CAGEfightR", build_vignettes = TRUE)
```

When using `devtools` you might need to manually install dependencies from Bioconductor (See `DESRIPTION` for a list of these).

## Examples

See the vignette for an in-depth guide to using `CAGEfightR`!

### Main S4 functions

#' Unidirectional Clustering (Tag Clustering) of pooled CTSSs.
#'
#' Finds unidirectional Tag Clusters (TCs) with a pooled TPM above a certain
#' threshold using a slice-reduce approach. Addtionally calculates the sum and
#' peak position of the TCs.
#'
#' @param object GRanges or RangedSummarizedExperiment: Basepair-wise pooled
#'   CTSS.
#' @param pooledCutoff numeric: Minimum pooled value to be considered as TC.
#' @param mergeDist integer: Merge TCs within this distance.
#' @param ... additional arguments passed to methods.
#'
#' @return GRanges with TPM sum as the score column, and TC peak as the thick
#'   column.
#'
#' @family Clustering functions
#' @export
#' @examples
#' data(exampleCTSSs)
#'
#' # Calculate pooledTPM, using supplied number of total tags
#' exampleCTSSs <- calcTPM(exampleCTSSs,
#'                         inputAssay='counts',
#'                         outputAssay='TPM',
#'                         totalTags='totalTags')
#' exampleCTSSs <- calcPooled(exampleCTSSs, inputAssay='TPM')
#'
#' # Cluster using defaults: slice-threshold of 0 and reduce-distance of 20
#' clusterUnidirectionally(exampleCTSSs)
#'
#' # Use custom thresholds:
#' clusterUnidirectionally(exampleCTSSs, pooledCutoff=1, mergeDist=25)
setGeneric("clusterUnidirectionally", function(object, ...) {
    standardGeneric("clusterUnidirectionally")
})

#' @rdname clusterUnidirectionally
setMethod("clusterUnidirectionally", signature(object = "GRanges"), function(object,
    pooledCutoff = 0, mergeDist = 20L) {
    # Pre-checks
    assert_that(checkPooled(object),
                is.number(pooledCutoff),
                is.count(mergeDist))

    # Split coverage by strand
    message("Splitting by strand...")
    covByStrand <- splitPooled(object)

    message("Slice-reduce to find clusters...")
    # Slice
    peaks_plus <- slice(covByStrand$`+`,
                        lower = pooledCutoff, upper = Inf,
                        includeLower = FALSE, rangesOnly = TRUE)
    peaks_minus <- slice(covByStrand$`-`,
                         lower = pooledCutoff, upper = Inf,
                         includeLower = FALSE, rangesOnly = TRUE)

    # Reduce
    reduced_plus <- reduce(peaks_plus, min.gapwidth = mergeDist)
    reduced_minus <- reduce(peaks_minus, min.gapwidth = mergeDist)

    # # Split coverage by strand
    # message("Splitting by strand...")
    #
    # coverage_stranded <- splitByStrand(object)
    # coverage_plus <- coverage(coverage_stranded$`+`, weight = "score")
    # coverage_minus <- coverage(coverage_stranded$`-`, weight = "score")
    # rm(coverage_stranded)
    #
    # # Peak calling: Find peaks
    # message("Finding tag clusters...")
    # peaks_plus <- slice(coverage_plus, lower = pooledCutoff, upper = Inf, includeLower = FALSE,
    #     rangesOnly = TRUE)
    # peaks_minus <- slice(coverage_minus, lower = pooledCutoff, upper = Inf, includeLower = FALSE,
    #     rangesOnly = TRUE)
    #
    # # Peak calling: Merge nearby peaks
    # reduced_plus <- reduce(peaks_plus, min.gapwidth = mergeDist)
    # reduced_minus <- reduce(peaks_minus, min.gapwidth = mergeDist)

    # Coverage and peaks
    message("Calculating statistics...")
    TCs <- TCstats(coverage_plus = covByStrand$`+`,
                   coverage_minus = covByStrand$`-`,
                   tcs_plus = reduced_plus,
                   tcs_minus = reduced_minus)
    rm(covByStrand)

    # Carry over seqinfo and sort
    message("Preparing output...")
    seqinfo(TCs) <- seqinfo(object)
    TCs <- sort(TCs)

    # Print some basic stats
    message("Tag clustering summary:")
    summarizeWidths(TCs)

    # Return
    TCs
})

#' @rdname clusterUnidirectionally
setMethod("clusterUnidirectionally", signature(object = "RangedSummarizedExperiment"),
    function(object, ...) {
        clusterUnidirectionally(rowRanges(object), ...)
    })

#' @rdname clusterUnidirectionally
setMethod("clusterUnidirectionally", signature(object = "GPos"),
					function(object, ...) {
						clusterUnidirectionally(methods::as(object, "GRanges"), ...)
					})

### Helper functions

TCstats <- function(coverage_plus, coverage_minus, tcs_plus, tcs_minus) {
    # Check classes
    stopifnot(methods::is(coverage_plus, "SimpleRleList"),
    					methods::is(coverage_minus, "SimpleRleList"),
    					methods::is(tcs_plus, "CompressedIRangesList"),
    					methods::is(tcs_minus, "CompressedIRangesList"))

    # Check seqlevels
    stopifnot(length(unique(list(names(coverage_plus),
                                 names(tcs_plus),
                                 names(coverage_minus),
                                 names(tcs_minus)))) == 1)

    # Obtain views
    views_plus <- Views(coverage_plus, tcs_plus)
    views_minus <- Views(coverage_minus, tcs_minus)

    # Calculate Sums
    sum_plus <- unlist(viewSums(views_plus))
    sum_minus <- unlist(viewSums(views_minus))

    # Find peaks
    ranges_plus <- viewRangeMaxs(views_plus)
    ranges_minus <- viewRangeMaxs(views_minus)
    ranges_plus <- resize(unlist(ranges_plus), width = 1, fix = "center")
    ranges_minus <- resize(unlist(ranges_minus), width = 1, fix = "center")

    # Merge into GRanges
    TCs <- c(GRanges(tcs_plus,
                     strand = "+",
                     score = sum_plus,
                     thick = ranges_plus),
             GRanges(tcs_minus,
                     strand = "-",
                     score = sum_minus,
                     thick = ranges_minus))

    # Names as IDs for both ranges and peaks
    TC_ids <- paste0(seqnames(TCs), ":", start(TCs), "-", end(TCs), ";", strand(TCs))
    names(TCs) <- TC_ids
    names(TCs$thick) <- TC_ids

    # Return
    TCs
}

summarizeWidths <- function(gr) {
    # Checks
    stopifnot(methods::is(gr, "GRanges"))

    # Cut up widths
    x <- cut(width(gr), breaks = c(1, 10, 100, 1000, Inf), labels = c(">=1", ">=10",
        ">=100", ">=1000"), include.lowest = TRUE)

    # Get freqs and props
    y <- table(Width = x)
    z <- prop.table(y)

    # Format to data.frame
    w <- merge(as.data.frame(y, responseName = "Count"),
               as.data.frame(z, responseName = "Percent"))

    # Add Total row
    w <- rbind(data.frame(Width = "Total",
                          Count = sum(w$Count),
                          Percent = sum(w$Percent)), w)

    # Reformat to percent
    w$Percent <- paste0(format(w$Percent * 100, digits = 1), " %")

    # To string and message
    s <- paste(utils::capture.output(print(w, row.names = FALSE)), collapse = "\n")
    message(s)
}

#' Identify and quantify Transcription Start Sites (TSSs).
#'
#' A convienient wrapper around calcTPM, calcPooled, tuneTagClustering,
#' clusterUnidirectionally and quantifyClusters.
#'
#' @param object RangedSummarizedExperiment: Location and counts of CTSSs,
#'   usually found by calling quantifyCTSSs.
#'
#' @return RangedSummarizedExperiment containing location and counts of TSSs
#' @family Wrapper functions
#' @export
#' @examples
#' # See the CAGEfightR vignette for an overview!
quickTSSs <- function(object) {
    # Pre-checks
    assert_that(methods::is(object, "RangedSummarizedExperiment"), isDisjoint(object),
        not_empty(seqlengths(object)), noNA(seqlengths(object)), is.element("counts",
            assayNames(object)))

    if (is.null(score(rowRanges(object)))) {
        message(" - Running calcTPM and calcPooled:")
        object <- calcTPM(object)
        invisible(gc())
        object <- calcPooled(object)
        invisible(gc())
    } else {
        message("Using existing score column!")
        assert_that(is.numeric(score(rowRanges(object))))
    }

    # message("\n - Running tuneTagClustering:")
    # tuned <- tuneTagClustering(object, searchMethod = "exponential")
    # invisible(gc())
    # pooledCutoff <- tuned[which.max(tuned$nTCs), 1]
    # message("Optimal pooled cutoff: ", pooledCutoff)

    message("\n - Running clusterUnidirectionally:")
    TCs <- clusterUnidirectionally(object)
    invisible(gc())

    message("\n - Running quantifyClusters:")
    TCs <- quantifyClusters(object, TCs)
    invisible(gc())

    # Return
    TCs
}

#' Identify and quantify enhancers.
#'
#' A convienient wrapper around clusterBidirectionally, subsetByBidirectionality
#' and quantifyClusters.
#'
#' @param object RangedSummarizedExperiment: Location and counts of CTSSs,
#'   usually found by calling quantifyCTSSs.
#'
#' @return RangedSummarizedExperiment containing location and counts of
#'   enhancers.
#' @family Wrapper functions
#' @export
#' @examples
#' # See the CAGEfightR vignette for an overview!
quickEnhancers <- function(object) {
    # Pre-checks
    assert_that(methods::is(object, "RangedSummarizedExperiment"),
                isDisjoint(object),
                not_empty(seqlengths(object)),
                noNA(seqlengths(object)),
                is.element("counts", assayNames(object)))

    if (is.null(score(rowRanges(object)))) {
        message(" - Running calcTPM and calcPooled:")
        object <- calcTPM(object)
        invisible(gc())
        object <- calcPooled(object)
        invisible(gc())
    } else {
        message("Using existing score column!")
        assert_that(is.numeric(score(rowRanges(object))))
    }

    message("\n - Running clusterBidirectionally:")
    enhancers <- clusterBidirectionally(object)
    invisible(gc())

    message("\n - Running subsetByBidirectionality:")
    enhancers <- subsetByBidirectionality(enhancers, object)
    invisible(gc())

    message("\n - Running quantifyClusters:")
    enhancers <- quantifyClusters(object, enhancers)
    invisible(gc())

    # Return
    enhancers
}

#' Identify and quantify genes.
#'
#' A convienient wrapper around assignGeneID, and quantifyGenes. Also removes
#' unstranded features
#'
#' @param object RangedSummarizedExperiment: Location and counts of clusters,
#'   usually found by calling quantifyClusters.
#' @param geneModels TxDb or GRanges: Gene models via a TxDb, or manually
#'   specified as a GRangesList.
#' @param ... additional arguments passed to assignGeneID.
#'
#' @return RangedSummarizedExperiment containing gene expression and clusters
#'   assigned within each gene.
#' @family Wrapper functions
#' @export
#' @examples
#' # See the CAGEfightR vignette for an overview!
quickGenes <- function(object, geneModels=NULL, ...) {
    # Pre-checks
    assert_that(methods::is(object, "RangedSummarizedExperiment"),
                isDisjoint(object),
                is.element("counts", assayNames(object)))

    if (is.null(rowRanges(object)$geneID)) {
        message(" - Running assignGeneID:")
        object <- assignGeneID(object, geneModels=geneModels, ...)
    }else{
        message("Using existing geneID column!")
    }

    message("\n - Removing unstranded clusters...")
    object <- subset(object, strand != "*")

    message("\n - Running quantifyGenes:")
    object <- quantifyGenes(object,
                            genes="geneID",
                            inputAssay="counts")
    invisible(gc())

    # Return
    object
}

#### Stretches ####

#' Find stretches of clusters
#'
#' Finds stretches or groups of clusters along the genome, where each cluster is
#' within a certain distance of the next. Once stretches have been identified,
#' the average pairwise correlation between all clusters in the stretch is
#' calculated. A typical use case is to look for stretches of enhancers, often
#' refered to as "super enhancers".
#'
#' @param object GRanges or RangedSummarizedExperiment: Clusters, possibly with
#'   expression for calculating correlations.
#' @param inputAssay character: Name of assay holding expression values (if
#'   object is a RangedSummarizedExperiment)
#' @param mergeDist integer: Maximum distance between clusters to be merged into
#'   stretches.
#' @param minSize integer: Minimum number of clusters in stretches.
#' @param corFun function: Function for calculating correlations. Should behave
#'   and produce output similar to cor().
#' @param ... additional arguments passed to methods or ultimately corFun.
#'
#' @return A GRanges containing stretches with number of clusters and average
#'   pairwise correlations calculated. The revmap can be used to retrieve the
#'   original clusters (see example below.)
#' @family Spatial functions
#' @export
#'
#' @examples
#' # Calculate TPM values for bidirectional clusters
#' data(exampleBidirectional)
#' BCs <- calcTPM(exampleBidirectional)
#'
#' # Find stretches
#' pearson_stretches <- findStretches(BCs, inputAssay="TPM")
#'
#' # Use Kendall instead of pearson and require bigger stretches
#' kendall_stretches <- findStretches(BCs, inputAssay="TPM",
#'                                    minSize=5, method="kendall")
#'
#' # Use the revmap to get stretches as a GRangesList
#' grl <- extractList(rowRanges(BCs), kendall_stretches$revmap)
#' names(grl) <- names(kendall_stretches)
setGeneric("findStretches", function(object, ...) standardGeneric("findStretches"))

#' @rdname findStretches
setMethod("findStretches", signature = "GRanges",
          definition = function(object, mergeDist=10000L, minSize=3L){
              # Pre-checks
              assert_that(is.count(mergeDist),
                          is.count(minSize))

              # Find stretches
              stretches <- GenomicRanges::reduce(object,
                                                 min.gapwidth=mergeDist,
                                                 ignore.strand=TRUE,
                                                 with.revmap=TRUE)

              # Subset to minimum size
              stretches <- stretches[elementNROWS(stretches$revmap) >= minSize]
              names(stretches) <- as.character(stretches)

              # Count number of clusters
              stretches$nClusters <- elementNROWS(stretches$revmap)

              # Return
              stretches
          })

#' @rdname findStretches
setMethod("findStretches", signature = "RangedSummarizedExperiment",
          definition = function(object, inputAssay, mergeDist=10000L, minSize=3L, corFun=cor, ...){
              assert_that(is.string(inputAssay),
                          inputAssay %in% assayNames(object),
                          is.function(corFun))

              message("Finding stretches...")
              stretches <- findStretches(rowRanges(object),
                                         mergeDist=mergeDist,
                                         minSize=minSize)


              message("Calculating correlations...")
              # Extract and transpose matrices
              aveCors <- extractList(x=assay(object, inputAssay),
                                     i=stretches$revmap)
              aveCors <- endoapply(aveCors, t)

              # Calculate pairwise correlations
              aveCors <- endoapply(aveCors, corFun, ...)

              # Calculate mean (lower part of matrix)
              aveCors <- vapply(aveCors,
                                FUN=function(x) mean(x[lower.tri(x)]),
                                FUN.VALUE = numeric(1))

              # Append and remove
              stretches$aveCor <- aveCors
              rm(aveCors)

              message("# Stretch summary:")
              message("Number of stretches: ", length(stretches))
              message("Total number of clusters inside stretches: ",
                      sum(stretches$nClusters), " / ", length(object))
              message("Minimum clusters: ", min(stretches$nClusters))
              message("Maximum clusters: ", max(stretches$nClusters))
              message("Minimum width: ", min(width(stretches)))
              message("Maximum width: ", max(width(stretches)))
              message("Summary of average pairwise correlations: ")
              tmp <- utils::capture.output(summary(stretches$aveCor))
              message(tmp[1])
              message(tmp[2])

              # Return
              stretches
          })

#### Links ####

# Determine orientation
determineOrientation <- function(gi){
    # Get positions as midpoint
    a <- InteractionSet::anchors(gi)
    a <- lapply(a, granges)
    a <- lapply(a, resize, width=1, fix="center")

    # Switch depending on first strand
    o <- ifelse(strand(a$first) == "+",
                start(a$first) >= start(a$second),
                start(a$first) <= start(a$second))
    o <- ifelse(o, "upstream", "downstream")

    # Return
    o
}

# Helper for bpvec
corHelper <- function(ii, m, corFun, ...){
    suppressWarnings(lapply(ii, function(i) corFun(x=m[i[1],],
                                  y=m[i[2],],
                                  ...)))
}


#' Find nearby pairs of clusters and calculate pairwise correlations.
#'
#' Finds all links or pairs of clusters within a certain distance of each other
#' and then calculates the correlation between them. The links found can be
#' restricted to only be between two classes, for example TSSs to enhancers.
#'
#' @param object GRanges or RangedSummarizedExperiment: Clusters, possibly with
#'   expression for calculating correlations.
#' @param inputAssay character: Name of assay holding expression values (if
#'   object is a RangedSummarizedExperiment)
#' @param maxDist integer: Maximum distance between links.
#' @param directional character: Name of a column in object holding a grouping
#'   of the clusters. This must be a factor with two levels. The first level is
#'   used as the basis for calculating orientation (see below).
#' @param corFun function: Function for calculating pairwise correlations. See
#'   notes for supplying custom functions.
#' @param vals character: Statistics extracted from the results produced by
#'   corFun. See notes for supplying custom functions.
#' @param ... additional arguments passed to methods or ultimately corFun.
#'
#' @return A GInteractions holding the links, along with the distance between
#'   them and correlation estimate and p-value calculated from their expression.
#'   If a directional analysis was performed, the two anchors are always
#'   connecting members of the two classes and the orientation of the second
#'   anchor relative to the first is additionaly calculated (e.g. whether an
#'   enhancers is upstream or downstream of the TSS).
#' @family Spatial functions
#'
#' @details A custom function for calculation correlations can be supplied by
#'   the user. The output of this function must be a named list or vector of
#'   numeric values. The names of the vals to be extracted should be supplied to
#'   vals.
#' @export
#'
#' @examples
#' library(InteractionSet)
#'
#' # Subset to highly expressed unidirectional clusters
#' TCs <- subset(exampleUnidirectional, score > 10)
#'
#' # Find links within a certain distance
#' findLinks(TCs, inputAssay="counts", maxDist=10000L)
#'
#' # To find TSS-to-enhancer type links, first merge the clusters:
#' colData(exampleBidirectional) <- colData(TCs)
#' rowRanges(TCs)$clusterType <- "TSS"
#' rowRanges(exampleBidirectional)$clusterType <- "Enhancer"
#' SE <- combineClusters(TCs, exampleBidirectional, removeIfOverlapping="object1")
#' rowRanges(SE)$clusterType <- factor(rowRanges(SE)$clusterType, levels=c("TSS", "Enhancer"))
#'
#' # Calculate kendall correlations of TPM values:
#' SE <- calcTPM(SE, totalTags="totalTags")
#' findLinks(SE, inputAssay="TPM", maxDist=10000L, directional="clusterType", method="kendall")
setGeneric("findLinks", function(object, ...) standardGeneric("findLinks"))

#' @rdname findLinks
setMethod("findLinks", signature = "GRanges",
          definition = function(object, maxDist=10000L, directional=NULL){
              # Pre-checks
              assert_that(is.count(maxDist))

              # Check if supplied factor
              if(!is.null(directional)){
                  assert_that(is.string(directional),
                              directional %in% colnames(mcols(object)),
                              is.factor(mcols(object)[,directional]),
                              length(levels(mcols(object)[,directional])) == 2)

                  # Grouping factor
                  g <- mcols(object)[,directional]
                  message("Finding directional links from ",
                          levels(g)[1], " to ", levels(g)[2], "...")

                  # Remember original order then split
                  by_dir <- granges(object)
                  by_dir$.id <- seq_len(length(by_dir))
                  by_dir <- split(by_dir, g)

                  # Find hits only between pairs
                  hits <- findOverlaps(by_dir[[1]],
                                       by_dir[[2]],
                                       maxgap=maxDist)

                  # Rebuild with original order
                  links <- InteractionSet::GInteractions(
                      anchor1 = by_dir[[1]]$.id[from(hits)],
                      anchor2 = by_dir[[2]]$.id[to(hits)],
                      regions = object)

                  # Determine orientation
                  links$orientation <- determineOrientation(links)
              }else{
                  message("Finding links...")
                  # Find nearby clusters
                  hits <- findOverlaps(object,
                                       drop.self=TRUE,
                                       drop.redundant=TRUE,
                                       maxgap=maxDist)

                  # Coerce to GI
                  links <- InteractionSet::GInteractions(anchor1 = from(hits),
                                         anchor2 = to(hits),
                                         regions = object)
              }

              # Calculate distance
              links$distance <- InteractionSet::pairdist(links, type="gap")

              # Return
              links
          })

#' @rdname findLinks
setMethod("findLinks", signature = "RangedSummarizedExperiment",
          definition = function(object, inputAssay, maxDist=10000L,
                                directional=NULL, corFun=stats::cor.test,
                                vals=c("estimate", "p.value"), ...){
              # Pre-checks
              assert_that(is.string(inputAssay),
                          inputAssay %in% assayNames(object),
                          is.function(corFun),
                          is.character(vals),
                          length(vals) >= 1)

              # Find links
              links <- findLinks(rowRanges(object),
                                 maxDist=maxDist,
                                 directional=directional)

              message("Calculating ", length(links), " pairwise correlations...")
              # Get pair IDs and matrix
              iii <- Pairs(InteractionSet::anchorIds(links, "first"),
                           InteractionSet::anchorIds(links, "second"))
              iii <- zipup(iii)
              m <- assay(object, inputAssay)

              # Calculate
              # linkwise <- lapply(iii, function(i) corFun(x=m[i[1],],
              #                                           y=m[i[2],],
              #                                           ...))
              linkwise <- BiocParallel::bpvec(X=iii,
                                FUN=corHelper,
                                m=m,
                                corFun=corFun,
                                ...)
              rm(iii, m)

              message("Preparing output...")
              # Extract and transpose
              linkwise <- vapply(linkwise,
                                 FUN=function(o) unlist(o[vals], use.names=FALSE),
                                 FUN.VALUE = numeric(length(vals)))

              # Extract output, will be either vector or matrix
              if(length(vals) == 1){
                  if(is.vector(linkwise)){
                      linkwise <- as.matrix(linkwise)
                  }else{
                      stop("Could not properly format output:\n",
                           "Output was neither a vector nor matrix!")
                  }
              }else{
                  linkwise <- t(linkwise)
              }
              colnames(linkwise) <- vals

              # Append
              mcols(links) <- cbind(mcols(links), linkwise)
              rm(linkwise)

              message("# Link summary:")
              message("Number of links: ", length(links))
              message("Summary of pairwise distance: ")
              tmp <- utils::capture.output(summary(links$distance))
              message(tmp[1])
              message(tmp[2])

              # Return
              links
          })

#' Check if BigWig-files are valid.
#'
#' Checks if a BigWigFile or BigWigFileList is composed of readable files with
#' the proper .bw extension.
#'
#' @param object BigWigFile or BigWigFileList
#'
#' @return TRUE, if any tests fails an error is raised.
#'
#' @family BigWig functions
#' @export
#' @examples
#' # Use the BigWig-files included with the package:
#' data('exampleDesign')
#' bw_plus <- system.file('extdata', exampleDesign$BigWigPlus,
#'                        package = 'CAGEfightR')
#'
#' # Create a named BigWigFileList-object with names
#' bw_plus <- BigWigFileList(bw_plus)
#' names(bw_plus) <- exampleDesign$Name
#'
#' # Check a single BigWigFile:
#' bwValid(bw_plus[[1]])
#'
#' # Check the entire BigWigFileList:
#' bwValid(bw_plus)
setGeneric("bwValid", function(object) {
    standardGeneric("bwValid")
})

#' @rdname bwValid
setMethod("bwValid", signature(object = "BigWigFile"), function(object) {
    # Checks, maybe wrap all of this in it's own function
    assert_that(file.exists(resource(object)),
                has_extension(resource(object), "bw"),
                is.readable(resource(object)))

    # Only returned if all tests pass
    TRUE
})

#' @rdname bwValid
setMethod("bwValid", signature(object = "BigWigFileList"), function(object) {
    # Checks, maybe wrap all of this in it's own function
    assert_that(all(vapply(object, bwValid, logical(1))), !is.null(names(object)))

    # Only returned if all tests pass
    TRUE
})

#' Find a common genome for a series of BigWig files.
#'
#' Finds a common genome for a series of BigWig-files, either using only levels
#' present in all files (intersect) or in any file (union).
#'
#' @param plusStrand BigWigFileList: BigWig files with plus-strand CTSS data.
#' @param minusStrand BigWigFileList: BigWig files with minus-strand CTSS data.
#' @param method character: Either 'intersect' or 'union'.
#'
#' @return Sorted Seqinfo-object.
#' @family BigWig functions
#' @export
#' @examples
#' if (.Platform$OS.type != "windows") {
#' # Use the BigWig-files included with the package:
#' data('exampleDesign')
#' bw_plus <- system.file('extdata', exampleDesign$BigWigPlus,
#'                        package = 'CAGEfightR')
#' bw_minus <- system.file('extdata', exampleDesign$BigWigMinus,
#'                         package = 'CAGEfightR')
#'
#' # Create two named BigWigFileList-objects:
#' bw_plus <- BigWigFileList(bw_plus)
#' bw_minus <- BigWigFileList(bw_minus)
#' names(bw_plus) <- exampleDesign$Name
#' names(bw_minus) <- exampleDesign$Name
#'
#' # Find the smallest common genome (intersect) across the BigWigList-objects:
#' bwCommonGenome(plusStrand=bw_plus, minusStrand=bw_minus, method='intersect')
#'
#' # Find the most inclusive genome (union) across the BigWigList-objects:
#' bwCommonGenome(plusStrand=bw_plus, minusStrand=bw_minus, method='union')
#' }
bwCommonGenome <- function(plusStrand, minusStrand, method = "intersect") {
    assert_that(methods::is(plusStrand, "BigWigFileList"),
                methods::is(minusStrand, "BigWigFileList"),
                is.string(method),
                method %in% c("intersect", "union"))

    # Get seqinfo
    seqInfoPlus <- lapply(plusStrand, seqinfo)
    seqInfoMinus <- lapply(minusStrand, seqinfo)

    # Unique seqinfos
    seqInfo <- unique(c(seqInfoPlus, seqInfoMinus))

    # Sort every element
    seqInfo <- seqInfo[order(vapply(seqInfo, length, numeric(1)))]

    # Merge using either function
    if (method == "intersect") {
        o <- suppressWarnings(Reduce(f = intersect, seqInfo))
    } else if (method == "union") {
        o <- suppressWarnings(Reduce(f = merge, seqInfo))
    }

    # Sort
    o <- sortSeqlevels(o)

    # Return
    o
}

#' Check if BigWig-files are compatible with a given genome.
#'
#' Given a genome, checks whether a series of BigWig-files are compatible by
#' checking if all common seqlevels have equal seqlengths.
#'
#' @param plusStrand BigWigFileList: BigWig files with plus-strand CTSS data.
#' @param minusStrand BigWigFileList: BigWig files with minus-strand CTSS data.
#' @param genome Seqinfo: Genome information.
#'
#' @return TRUE, raises an error if the supplied genome is incompabtible.
#' @family BigWig functions
#' @export
#' @examples
#' if (.Platform$OS.type != "windows") {
#' # Use the BigWig-files included with the package:
#' data('exampleDesign')
#' bw_plus <- system.file('extdata', exampleDesign$BigWigPlus,
#'                        package = 'CAGEfightR')
#' bw_minus <- system.file('extdata', exampleDesign$BigWigMinus,
#'                         package = 'CAGEfightR')
#'
#' # Create two named BigWigFileList-objects:
#' bw_plus <- BigWigFileList(bw_plus)
#' bw_minus <- BigWigFileList(bw_minus)
#' names(bw_plus) <- exampleDesign$Name
#' names(bw_minus) <- exampleDesign$Name
#'
#' # Make a smaller genome:
#' si <- seqinfo(bw_plus[[1]])
#' si <- si['chr18']
#'
#' # Check if it is still compatible:
#' bwGenomeCompatibility(plusStrand=bw_plus, minusStrand=bw_minus, genome=si)
#' }
bwGenomeCompatibility <- function(plusStrand, minusStrand, genome) {
    assert_that(methods::is(plusStrand, "BigWigFileList"),
                methods::is(minusStrand, "BigWigFileList"),
                methods::is(genome, "Seqinfo"))

    # Get seqinfo
    seqInfoPlus <- lapply(plusStrand, seqinfo)
    seqInfoMinus <- lapply(minusStrand, seqinfo)

    # Unique seqinfos
    seqInfos <- unique(c(seqInfoPlus, seqInfoMinus))

    # Check if error is produces
    lapply(seqInfos, merge, y = genome)

    # Return
    TRUE
}

.onLoad <- function(libname, pkgname) {
	op <- options()
	op.CAGEfightR <- list(
		CAGEfightR.round = 9,
		CAGEfightR.plus = "cornflowerblue",
		CAGEfightR.minus = "tomato",
		CAGEfightR.unstranded = "hotpink"
	)
	toset <- !(names(op.CAGEfightR) %in% names(op))
	if(any(toset)) options(op.CAGEfightR[toset])

	invisible()
}

#' Create Genome Browser track of CTSSs.
#'
#' Create a Gviz-track of CTSSs, where Plus/minus strand signal is shown
#' positive/negative. This representation makes it easy to identify
#' bidirectional peaks.
#'
#' @param object GenomicRanges or RangedSummarizedExperiment: Ranges with CTSSs
#'   in the score column.
#' @param plusColor character: Color for plus-strand coverage.
#' @param minusColor character: Color for minus-strand coverage.
#' @param ... additional arguments passed on to DataTrack.
#'
#' @return DataTrack-object.
#' @family Genome Browser functions
#' @export
#' @examples
#' library(Gviz)
#' data(exampleCTSSs)
#' data(exampleUnidirectional)
#' data(exampleBidirectional)
#'
#' # Example uni- and bidirectional clusters
#' TC <- rowRanges(subset(exampleUnidirectional, width>=100)[3,])
#' BC <- rowRanges(exampleBidirectional[3,])
#'
#' # Create pooled track
#' subsetOfCTSSs <- subsetByOverlaps(rowRanges(exampleCTSSs), c(BC, TC, ignore.mcols=TRUE))
#' pooledTrack <- trackCTSS(subsetOfCTSSs)
#'
#' # Plot
#' plotTracks(pooledTrack, from=start(TC)-100, to=end(TC)+100,
#'            chromosome=seqnames(TC), name='TC')
#' plotTracks(pooledTrack, from=start(BC)-100, to=end(BC)+100,
#'            chromosome=seqnames(BC), name='BC')
#'
#' # See vignette for examples on how to combine multiple Gviz tracks
setGeneric("trackCTSS", function(object, ...) {
    standardGeneric("trackCTSS")
})

#' @rdname trackCTSS
#' @export
setMethod("trackCTSS", signature(object = "GRanges"), function(object, plusColor = "cornflowerblue",
    minusColor = "tomato", ...) {
    # Pre-checks
    assert_that(isDisjoint(object), !is.null(score(object)), is.numeric(score(object)),
        not_empty(seqlengths(object)), noNA(seqlengths(object)), is.string(plusColor),
        is.string(minusColor))

    # Vector by strand
    message("Splitting pooled signal by strand...")
    by_strand <- splitByStrand(object)
    plus_coverage <- coverage(by_strand$`+`, weight = "score")
    minus_coverage <- 0 - coverage(by_strand$`-`, weight = "score")
    rm(by_strand)

    # Back to GRanges
    message("Preparing track...")
    names(minus_coverage) <- names(plus_coverage)
    o <- bindAsGRanges(plus = plus_coverage, minus = minus_coverage)

    # Build track
    # o <- Gviz::DataTrack(o, type = "histogram", groups = c("plus", "minus"), col = c(minusColor,
    #     plusColor), ...)
    o <- Gviz::DataTrack(o,
                         type = "histogram",
                         groups = factor(c("plus", "minus"),
                                         levels=c("plus", "minus")),
                         col = c(plusColor, minusColor),
                         ...)

    # Return
    o
})

#' @rdname trackCTSS
#' @export
setMethod("trackCTSS", signature(object = "RangedSummarizedExperiment"), function(object,
    ...) {
    trackCTSS(rowRanges(object), ...)
})

#' @rdname trackCTSS
setMethod("trackCTSS", signature(object = "GPos"), function(object, ...) {
    trackCTSS(methods::as(object, "GRanges"), ...)
})

#' Create genome browser track of clusters.
#'
#' Create a Gviz-track of clusters (unidirectional TCs or bidirectional
#' enhancers), where cluster strand and peak is indicated.
#'
#' @param object GRanges: GRanges with peaks in the thick-column.
#' @param plusColor character: Color for plus-strand features.
#' @param minusColor character: Color for minus-strand features.
#' @param unstrandedColor character: Color for unstranded features.
#' @param ... additional arguments passed on to GeneRegionTrack.
#'
#' @return GeneRegionTrack-object.
#'
#' @family Genome Browser functions
#' @export
#' @examples
#' library(Gviz)
#' data(exampleUnidirectional)
#'
#' # Find some wide unidirectional clusters:
#' TCs <- subset(exampleUnidirectional, width >= 100)
#'
#' # Create track
#' clusters_track <- trackClusters(TCs[1:2,], name='Tag clusters', col=NULL)
#'
#' # Plot
#' plotTracks(clusters_track)
#'
#' # See vignette for examples on how to combine multiple Gviz tracks
setGeneric("trackClusters", function(object, ...) {
    standardGeneric("trackClusters")
})

#' @rdname trackClusters
#' @export
setMethod("trackClusters", signature(object = "GRanges"), function(object,
    plusColor = "cornflowerblue", minusColor = "tomato", unstrandedColor = "hotpink",
    ...) {
    # Pre-checks
    assert_that("thick" %in% colnames(mcols(object)), methods::is(mcols(object)[,
        "thick"], "IRanges"), all(poverlaps(mcols(object)$thick, ranges(object),
        type = "within")), is.string(plusColor), is.string(minusColor), is.string(unstrandedColor))

    # Extract peaks
    message("Setting thick and thin features...")
    insideThick <- swapRanges(object)

    # Remove mcols and add features for thin feature
    names(insideThick) <- NULL
    mcols(insideThick) <- NULL
    insideThick$feature <- ifelse(strand(insideThick) == "+", "thickPlus", "thickMinus")
    insideThick$feature <- ifelse(strand(insideThick) == "*", "thickUnstranded",
        insideThick$feature)

    # Remove peaks from TCs
    outsideThick <- setdiff(object, insideThick)

    # Remove mcols and add features
    mcols(outsideThick) <- NULL
    outsideThick$feature <- ifelse(strand(outsideThick) == "+", "thinPlus", "thinMinus")
    outsideThick$feature <- ifelse(strand(outsideThick) == "*", "thinUnstranded",
        outsideThick$feature)

    # Temporary to GRangesList for easy sorting
    message("Merging and sorting...")
    o <- sort(c(insideThick, outsideThick))
    fo <- findOverlaps(o, object, select = "arbitrary")
    o <- split(o, fo)
    names(o) <- names(object)
    o <- unlist(o)
    rm(object)


    # Add necessary columns for track
    o$transcript <- names(o)
    o$gene <- o$transcript
    o$symbol <- o$transcript

    # Build track
    message("Preparing track...")
    o <- Gviz::GeneRegionTrack(o,
                               thinBoxFeature = c("thinPlus",
                                                  "thinMinus",
                                                  "thinUnstranded"),
                               min.distance = 0,
                               collapse = FALSE,
                               thinPlus = plusColor,
                               thickPlus = plusColor,
                               thinMinus = minusColor,
                               thickMinus = minusColor,
                               thinUnstranded = unstrandedColor,
                               thickUnstranded = unstrandedColor,
                               ...)

    # Return
    o
})

#' @rdname trackClusters
#' @export
setMethod("trackClusters", signature(object = "RangedSummarizedExperiment"), function(object,
    ...) {
    trackClusters(rowRanges(object), ...)
})

#' Create Genome Browser Track of bidirectional balance scores
#'
#' Visualize balance scores used for detectiong of bidirectional sites. Mainly
#' intended as diagnostic tools for expert user.
#'
#' @param object GenomicRanges or RangedSummarizedExperiment: Ranges with CTSSs
#'   in the score column.
#' @param window integer: Width of sliding window used for calculating windowed
#'   sums.
#' @param plusColor character: Color for plus-strand coverage.
#' @param minusColor character: Color for minus-strand coverage.
#' @param balanceColor character: Color for bidirectional balance.
#' @param ... additional arguments passed to DataTrack.
#'
#' @note Potentially consumes a large amount of memory!
#' @return list of 3 DataTracks for upstream, downstream and balance.
#' @family Genome Browser functions
#' @export
#' @examples
#' \dontrun{
#' library(Gviz)
#' data(exampleCTSSs)
#' data(exampleBidirectional)
#'
#' # Calculate pooled CTSSs
#' exampleCTSSs <- calcTPM(exampleCTSSs, totalTags='totalTags')
#' exampleCTSSs <- calcPooled(exampleCTSSs)
#'
#' # Find a bidirectional cluster to plot:
#' BC <- rowRanges(exampleBidirectional[10,])
#' start(BC) <- start(BC) - 250
#' end(BC) <- end(BC) + 250
#' subsetOfCTSSs <- subsetByOverlaps(exampleCTSSs, BC)
#'
#' # Build balance track
#' balance_track <- trackBalance(subsetOfCTSSs)
#'
#' # Plot
#' plotTracks(balance_track, from=start(BC), to=end(BC),
#'            chromosome=seqnames(BC))
#' }
setGeneric("trackBalance", function(object, ...) {
    standardGeneric("trackBalance")
})

#' @rdname trackBalance
#' @export
setMethod("trackBalance", signature(object = "GRanges"), function(object, window = 199,
    plusColor = "cornflowerblue", minusColor = "tomato", balanceColor = "forestgreen",
    ...) {
    # Pre-checks
    assert_that(isDisjoint(object),
                !is.null(score(object)),
                is.numeric(score(object)),
                not_empty(seqlengths(object)),
                noNA(seqlengths(object)),
                is.string(plusColor),
                is.string(minusColor),
                is.string(balanceColor))

    # Get windows
    cw <- coverageWindows(pooled = object,
                          window = window,
                          balanceFun = balanceBC)

    # Assemble tracks
    message("Building tracks...")
    o <- list(downstream = Gviz::DataTrack(bindAsGRanges(plus = cw$PD,
                                                         minus = cw$MD),
                                           name = "Downstream",
                                           type = "l",
                                           groups = factor(c("plus","minus"),
                                                           levels=c("plus",
                                                                    "minus")),
                                           col = c(plusColor, minusColor)),
              upstream = Gviz::DataTrack(bindAsGRanges(plus = cw$PU,
                                                       minus = cw$MU),
                                         name = "Upstream",
                                         type = "l",
                                         groups = factor(c("plus","minus"),
                                                         levels=c("plus",
                                                                  "minus")),
                                         col = c(plusColor, minusColor)))

    if (!is.null(cw$B)) {
        o$balance <- Gviz::DataTrack(GRanges(cw$B),
                                     name = "Balance",
                                     type = "l",
                                     col = balanceColor)
    }

    # Return
    o
})

#' @rdname trackBalance
#' @export
setMethod("trackBalance", signature(object = "GPos"), function(object, ...) {
    trackBalance(methods::as(object, "GRanges"), ...)
})

#' @rdname trackBalance
#' @export
setMethod("trackBalance", signature(object = "RangedSummarizedExperiment"), function(object,
    ...) {
    trackBalance(rowRanges(object), ...)
})

#' Create a genome browser track of links.
#'
#' Create a Gviz-track of links (e.g. between TSSs and enhancers), where arches connect the different pairs of clusters. The height of arches can be set to scale the strength of the interaction (for example indicating higher correlation). This function is a thin wrapper around the InteractionTrack-class from the GenomicInteractions package. Currently, only scaling arch height by p-value is supported.
#'
#' @param object GInteractions: Links or pairs between clusters.
#' @param ... additional arguments passed to InteractionTrack via displayPars.
#'
#' @return InteractionTrack-object from the GenomicInteractions package.
#' @export
#' @family Genome Browser functions
#' @family Spatial functions
#'
#' @examples
#' library(InteractionSet)
#' library(Gviz)
#' library(GenomicInteractions)
#'
#' # Links between highly expressed unidirectional clusters
#' TCs <- subset(exampleUnidirectional, score > 10)
#' TC_links <- findLinks(TCs, inputAssay="counts", maxDist=10000L)
#' link_track <- trackLinks(TC_links, name="TSS links", interaction.measure="p.value")
#'
#' # Plot region
#' plot_region <- GRanges(seqnames="chr18",
#'                        ranges = IRanges(start=start(anchors(TC_links[1],
#'                                                             "first")),
#'                                         end=end(anchors(TC_links[1],
#'                                                         "second"))))
#' # Plot using Gviz
#' plotTracks(link_track,
#'            from=start(plot_region),
#'            to=end(plot_region),
#'            chromosome = as.character(seqnames(plot_region)))
#' # See vignette for examples on how to combine multiple Gviz tracks
trackLinks <- function(object, ...){
    # Pre-checks
    assert_that(methods::is(object, "GInteractions"))

    # Convert to GenomicInteractions
    object <- GenomicInteractions::GenomicInteractions(object)

    # Gather ...
    d <- list(...)

    # Build trakc
    o <- GenomicInteractions::InteractionTrack(object, name=d$name)

    # Pass all dots as display pars
    Gviz::displayPars(o) <- d

    # Return
    o
}

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)

## ----bioconductor, eval=FALSE-------------------------------------------------
# if (!requireNamespace("BiocManager", quietly=TRUE))
#     install.packages("BiocManager")
# BiocManager::install("CAGEfightR")

## ----library, results='hide', message=FALSE-----------------------------------
library(CAGEfightR)

## ----github, eval=FALSE-------------------------------------------------------
# devtools::install_github("MalteThodberg/CAGEfightR")

## ----citation, eval=TRUE------------------------------------------------------
citation("CAGEfightR")

## ----BigWig_files, results="hide", tidy=FALSE---------------------------------
# Load the example data
data("exampleDesign")
head(exampleDesign)

# Locate files on your harddrive
bw_plus <- system.file("extdata", 
                       exampleDesign$BigWigPlus, 
                       package = "CAGEfightR")
bw_minus <- system.file("extdata", 
                        exampleDesign$BigWigMinus,
                        package = "CAGEfightR")

# Create two named BigWigFileList-objects:
bw_plus <- BigWigFileList(bw_plus)
bw_minus <- BigWigFileList(bw_minus)
names(bw_plus) <- exampleDesign$Name
names(bw_minus) <- exampleDesign$Name

## ----quickCTSSs, tidy=FALSE---------------------------------------------------
# Get genome information
genomeInfo <- SeqinfoForUCSCGenome("mm9")

# Quantify CTSSs
CTSSs <- quantifyCTSSs(plusStrand=bw_plus,
                       minusStrand=bw_minus,
                       design=exampleDesign,
                       genome=genomeInfo)

## ----quickTSSs, tidy=FALSE----------------------------------------------------
TSSs <- quickTSSs(CTSSs)

## ----quickEnhancers, tidy=FALSE-----------------------------------------------
enhancers <- quickEnhancers(CTSSs)

## ----quickAnnotate, tidy=FALSE------------------------------------------------
# Use the built in annotation for mm9
library(TxDb.Mmusculus.UCSC.mm9.knownGene)
txdb <- TxDb.Mmusculus.UCSC.mm9.knownGene

# Annotate both TSSs and enhancers
TSSs <- assignTxType(TSSs, txModels=txdb)
enhancers <- assignTxType(enhancers, txModels=txdb)

## ----quickFilter, tidy=FALSE--------------------------------------------------
enhancers <- subset(enhancers, txType %in% c("intergenic", "intron"))

## ----quickCombine, tidy=FALSE-------------------------------------------------
# Add an identifier column
rowRanges(TSSs)$clusterType <- "TSS"
rowRanges(enhancers)$clusterType <- "enhancer"

# Combine TSSs and enhancers, discarding TSSs if they overlap enhancers
RSE <- combineClusters(TSSs, enhancers, removeIfOverlapping="object1")

## ----quickSupport, tidy=FALSE-------------------------------------------------
# Only keep features with more than 0 counts in more than 1 sample:
RSE <- subsetBySupport(RSE,
                       inputAssay = "counts",
                       outputColumn = "support",
                       unexpressed = 0,
                       minSamples = 1)

## ----quickGenes, tidy=FALSE---------------------------------------------------
gene_level <- quickGenes(RSE, geneModels = txdb)

## ----quickLinks, tidy=FALSE---------------------------------------------------
# Set TSSs as reference points
rowRanges(RSE)$clusterType <- factor(rowRanges(RSE)$clusterType,
                                     levels=c("TSS", "enhancer"))

# Find pairs and calculate kendall correlation between them
links <- findLinks(RSE, 
                   inputAssay="counts", 
                   maxDist=5000, 
                   directional="clusterType",
                   method="kendall")

## ----exampleCTSSs, tidy=FALSE-------------------------------------------------
data(exampleCTSSs)
exampleCTSSs

## ----dgCMatrix, tidy=FALSE----------------------------------------------------
head(assay(exampleCTSSs))

## ----GPos, tidy=FALSE---------------------------------------------------------
rowRanges(exampleCTSSs)

## ----calc, tidy=FALSE---------------------------------------------------------
exampleCTSSs <- calcTPM(exampleCTSSs, inputAssay="counts", outputAssay="TPM", outputColumn="subsetTags")

## ----libSizes, tidy=FALSE-----------------------------------------------------
# Library sizes
colData(exampleCTSSs)

# TPM values
head(assay(exampleCTSSs, "TPM"))

## ----preCalcTPM, tidy=FALSE---------------------------------------------------
exampleCTSSs <- calcTPM(exampleCTSSs, 
                        inputAssay="counts", 
                        totalTags="totalTags", 
                        outputAssay="TPM")
head(assay(exampleCTSSs, "TPM"))

## ----pooled, tidy=FALSE-------------------------------------------------------
# Library sizes
exampleCTSSs <- calcPooled(exampleCTSSs, inputAssay="TPM")
rowRanges(exampleCTSSs)

## ----support, tidy=FALSE------------------------------------------------------
# Count number of samples with MORE ( > ) than 0 counts:
exampleCTSSs <- calcSupport(exampleCTSSs, 
                            inputAssay="counts", 
                            outputColumn="support", 
                            unexpressed=0)
table(rowRanges(exampleCTSSs)$support)

## ----subset, tidy=FALSE-------------------------------------------------------
supportedCTSSs <- subset(exampleCTSSs, support > 1)
supportedCTSSs <- calcTPM(supportedCTSSs, totalTags="totalTags")
supportedCTSSs <- calcPooled(supportedCTSSs)

## ----naiveTC, tidy=FALSE------------------------------------------------------
simple_TCs <- clusterUnidirectionally(exampleCTSSs, 
                                     pooledCutoff=0, 
                                     mergeDist=20)

## ----tuning, tidy=FALSE-------------------------------------------------------
# Use a higher cutoff for clustering
higher_TCs <- clusterUnidirectionally(exampleCTSSs, 
                                     pooledCutoff=0.1, 
                                     mergeDist=20)

# Use CTSSs pre-filtered on support. 
prefiltered_TCs <- clusterUnidirectionally(supportedCTSSs, 
                                     pooledCutoff=0, 
                                     mergeDist=20)

## ----TCanatomy, tidy=FALSE----------------------------------------------------
simple_TCs

## ----bidirectionalClustering, tidy=FALSE--------------------------------------
BCs <- clusterBidirectionally(exampleCTSSs, balanceThreshold=0.95)

## ----enhancerAnatomy, tidy=FALSE----------------------------------------------
BCs

## ----bidirectionality, tidy=FALSE---------------------------------------------
# Calculate number of bidirectional samples
BCs <- calcBidirectionality(BCs, samples=exampleCTSSs)

# Summarize
table(BCs$bidirectionality)

## ----subsetBidirectionality, tidy=FALSE---------------------------------------
enhancers <- subset(enhancers, bidirectionality > 0)

## ----exampleClusters, tidy=FALSE----------------------------------------------
# Load the example datasets
data(exampleCTSSs)
data(exampleUnidirectional)
data(exampleBidirectional)

## ----quantifyClusters, tidy=FALSE---------------------------------------------
requantified_TSSs <- quantifyClusters(exampleCTSSs,
                                      clusters=rowRanges(exampleUnidirectional),
                                      inputAssay="counts")
requantified_enhancers <- quantifyClusters(exampleCTSSs,
                                           clusters=rowRanges(exampleBidirectional),
                                           inputAssay="counts")

## ----supportOnCounts, tidy=FALSE----------------------------------------------
# Only keep BCs expressed in more than one sample
supported_enhancers <- subsetBySupport(exampleBidirectional,
                                       inputAssay="counts",
                                       unexpressed=0,
                                       minSamples=1)

## ----supportOnTPM, tidy=FALSE-------------------------------------------------
# Calculate TPM using pre-calculated total tags:
exampleUnidirectional <- calcTPM(exampleUnidirectional, 
                                 totalTags = "totalTags")

# Only TSSs expressed at more than 1 TPM in more than 2 samples
exampleUnidirectional <- subsetBySupport(exampleUnidirectional,
                                         inputAssay="TPM",
                                         unexpressed=1,
                                         minSamples=2)

## ----txdb, tidy=FALSE---------------------------------------------------------
library(TxDb.Mmusculus.UCSC.mm9.knownGene)
txdb <- TxDb.Mmusculus.UCSC.mm9.knownGene
txdb

## ----assignTxID, tidy=FALSE---------------------------------------------------
exampleUnidirectional <- assignTxID(exampleUnidirectional,
                                    txModels=txdb,
                                    outputColumn="txID")

## ----multipleTxs, tidy=FALSE--------------------------------------------------
rowRanges(exampleUnidirectional)[5:6]

## ----assignTxType, tidy=FALSE-------------------------------------------------
exampleUnidirectional <- assignTxType(exampleUnidirectional,
                                      txModels=txdb,
                                      outputColumn="txType")

## ----swappedTxType, tidy=FALSE------------------------------------------------
exampleUnidirectional <- assignTxType(exampleUnidirectional,
                                      txModels=txdb,
                                      outputColumn="peakTxType",
                                      swap="thick")

## ----enhancerTxType, tidy=FALSE-----------------------------------------------
# Annotate with TxTypes
exampleBidirectional <- assignTxType(exampleBidirectional,
                                     txModels=txdb,
                                     outputColumn="txType")

# Only keep intronic and intergenic enhancers
exampleBidirectional <- subset(exampleBidirectional,
                               txType %in% c("intron", "intergenic"))

## ----calcIQR, tidy=FALSE------------------------------------------------------
# Recalculate pooled signal
exampleCTSSs <- calcTPM(exampleCTSSs, totalTags = "totalTags")
exampleCTSSs <- calcPooled(exampleCTSSs)

# Calculate shape
exampleUnidirectional <- calcShape(exampleUnidirectional,
                                   pooled=exampleCTSSs,
                                   outputColumn = "IQR",
                                   shapeFunction = shapeIQR,
                                   lower=0.25, upper=0.75)

## ----histIQR, tidy=FALSE------------------------------------------------------
hist(rowRanges(exampleUnidirectional)$IQR,
     breaks=max(rowRanges(exampleUnidirectional)$IQR),
     xlim=c(0,100), 
     xlab = "IQR", 
     col="red")

## ----customShape, tidy=FALSE--------------------------------------------------
# Write a function that quantifies the lean of a TSS
shapeLean <- function(x, direction){
	# Coerce to normal vector
	x <- as.vector(x)
	
	# Find highest position:
	i <- which.max(x)
	
	# Calculate sum
	i_total <- sum(x)
	
	# Calculate lean fraction
	if(direction == "right"){
		i_lean <- sum(x[i:length(x)])
	}else if(direction == "left"){
		i_lean <- sum(x[1:i])
	}else{
		stop("direction must be left or right!")
	}
	
	# Calculate lean
	o <- i_lean / i_total
	
	# Return
	o
}

# Calculate lean statistics, 
# additional arguments can be passed to calcShape via "..."
exampleUnidirectional <- calcShape(exampleUnidirectional, 
                                   exampleCTSSs,
                                   outputColumn="leanRight", 
                                   shapeFunction=shapeLean,
                                   direction="right")

exampleUnidirectional <- calcShape(exampleUnidirectional, 
                                   exampleCTSSs,
                                   outputColumn="leanLeft", 
                                   shapeFunction=shapeLean,
                                   direction="left")

## ----naiveLinks, tidy=FALSE---------------------------------------------------
library(InteractionSet)
TC_pairs <- findLinks(exampleUnidirectional, 
                      inputAssay="TPM", 
                      maxDist=10000, 
                      method="kendall")

TC_pairs

## ----TCBClinks, tidy=FALSE----------------------------------------------------
# Mark the type of cluster
rowRanges(exampleUnidirectional)$clusterType <- "TSS"
rowRanges(exampleBidirectional)$clusterType <- "enhancer"

# Merge the dataset
colData(exampleBidirectional) <- colData(exampleUnidirectional)
SE <- combineClusters(object1=exampleUnidirectional, 
                      object2=exampleBidirectional,
                      removeIfOverlapping="object1")

# Mark that we consider TSSs as the reference points
rowRanges(SE)$clusterType <- factor(rowRanges(SE)$clusterType,
                                    levels=c("TSS", "enhancer"))

# Recalculate TPM values
SE <- calcTPM(SE, totalTags="totalTags")

# Find link between the groups:
TCBC_pairs <- findLinks(SE, 
                      inputAssay="TPM",
                      maxDist=10000, 
                      directional="clusterType",
                      method="kendall")

TCBC_pairs

## ----superEnhancersGR, tidy=FALSE---------------------------------------------
stretches <- findStretches(exampleBidirectional, 
              inputAssay="counts",
              minSize=3,
              mergeDist=10000,
              method="spearman")
stretches

## ----superEnhancersGRL, tidy=FALSE--------------------------------------------
extractList(rowRanges(exampleBidirectional), stretches$revmap)

## ----geneSetup, tidy=FALSE----------------------------------------------------
# Load example TSS 
data(exampleUnidirectional)

# Keep only TCs expressed at more than 1 TPM in more than 2 samples:
exampleUnidirectional <- calcTPM(exampleUnidirectional, 
                                 totalTags = "totalTags")
exampleUnidirectional <- subsetBySupport(exampleUnidirectional,
                                         inputAssay="TPM",
                                         unexpressed=1,
                                         minSamples=2)

# Use the Bioconductor mm9 UCSC TxXb 
library(TxDb.Mmusculus.UCSC.mm9.knownGene)
txdb <- TxDb.Mmusculus.UCSC.mm9.knownGene

## ----geneModels, tidy=FALSE---------------------------------------------------
exampleUnidirectional <- assignGeneID(exampleUnidirectional,
                                      geneModels=txdb,
                                      outputColumn="geneID")

## ----symbols, tidy=FALSE------------------------------------------------------
# Use Bioconductor OrgDb package
library(org.Mm.eg.db)
odb <- org.Mm.eg.db

# Match IDs to symbols
symbols <- mapIds(odb,
                  keys=rowRanges(exampleUnidirectional)$geneID,
                  keytype="ENTREZID",
                  column="SYMBOL")

# Add to object
rowRanges(exampleUnidirectional)$symbol <- as.character(symbols)

## ----assignMissing, tidy=FALSE------------------------------------------------
exampleUnidirectional <- assignMissingID(exampleUnidirectional,
                                         outputColumn="symbol")

## ----quantifyGenes, tidy=FALSE------------------------------------------------
genelevel <- quantifyGenes(exampleUnidirectional, 
                           genes="geneID", 
                           inputAssay="counts")

## ----geneGRangesList, tidy=FALSE----------------------------------------------
rowRanges(genelevel)

## ----rowData, tidy=FALSE------------------------------------------------------
rowData(genelevel)

## ----calcComposition, tidy=FALSE----------------------------------------------
# Remove TSSs not belonging to any genes
intragenicTSSs <- subset(exampleUnidirectional, !is.na(geneID))

# Calculate composition: 
# The number of samples expressing TSSs above 10% of the total gene expression.
intragenicTSSs <- calcComposition(intragenicTSSs,
                                  outputColumn="composition",
                                  unexpressed=0.1,
                                  genes="geneID")

# Overview of composition values:
table(rowRanges(intragenicTSSs)$composition)

## ----subsetComposition, tidy=FALSE--------------------------------------------
# Remove TSSs with a composition score less than 3
intragenicTSSs <- subset(intragenicTSSs, composition > 2)

## ----GViz, tidy=FALSE---------------------------------------------------------
library(Gviz)

data("exampleCTSSs")
data("exampleUnidirectional")
data("exampleBidirectional")

## ----builtCTSStrack, tidy=FALSE-----------------------------------------------
# Calculate pooled CTSSs
exampleCTSSs <- calcTPM(exampleCTSSs, totalTags="totalTags")
exampleCTSSs <- calcPooled(exampleCTSSs)

# Built the track
pooled_track <- trackCTSS(exampleCTSSs, name="CTSSs")

## ----plotCTSStrack, tidy=FALSE------------------------------------------------
# Plot the main TSS of the myob gene
plotTracks(pooled_track, from=74601950, to=74602100, chromosome="chr18")

## ----clusterTrack, tidy=FALSE-------------------------------------------------
# Remove columns
exampleUnidirectional$totalTags <- NULL
exampleBidirectional$totalTags <- NULL

# Combine TSSs and enhancers, discarding TSSs if they overlap enhancers
CAGEclusters <- combineClusters(object1=exampleUnidirectional, 
                                object2=exampleBidirectional, 
                                removeIfOverlapping="object1")

# Only keep features with more than 0 counts in more than 2 samples
CAGEclusters <- subsetBySupport(CAGEclusters, 
                                inputAssay = "counts", 
                                unexpressed=0, 
                                minSamples=2)

# Build track
cluster_track <- trackClusters(CAGEclusters, name="Clusters", col=NA)

## ----plotClustertrack, tidy=FALSE---------------------------------------------
# Plot the main TSS of the myob gene
plotTracks(cluster_track, from=74601950, to=74602100, chromosome="chr18")

## ----prettybrowser, tidy=FALSE------------------------------------------------
# Genome axis tracks
axis_track <- GenomeAxisTrack()

# Transcript model track
library(TxDb.Mmusculus.UCSC.mm9.knownGene)
txdb <- TxDb.Mmusculus.UCSC.mm9.knownGene
tx_track <- GeneRegionTrack(txdb,
                            chromosome = "chr18",
                            name="Gene Models", 
                            col=NA, 
                            fill="bisque4", 
                            shape="arrow")

# Merge all tracks
all_tracks <- list(axis_track, tx_track, cluster_track, pooled_track)

# Plot the Hdhd2 gene
plotTracks(all_tracks, from=77182700, to=77184000, chromosome="chr18")

# Plot an intergenic enhancer
plotTracks(all_tracks, from=75582473, to=75582897, chromosome="chr18")

## ----prepareLinks, tidy=FALSE-------------------------------------------------
# Unstranded clusters are enhancers
rowRanges(CAGEclusters)$clusterType <- factor(ifelse(strand(CAGEclusters)=="*",
                                              "enhancer", "TSS"),
                                              levels=c("TSS", "enhancer"))

# Find links
links <- findLinks(CAGEclusters, 
                   inputAssay="counts", 
                   directional="clusterType",
                   method="kendall")

# Only look at positive correlation
links <- subset(links, estimate > 0)

## ----plotLinks, tidy=FALSE----------------------------------------------------
# Save as a track
all_tracks$links_track <- trackLinks(links, 
                          name="TSS-enhancer", 
                          col.interactions="black",
                          col.anchors.fill ="dimgray",
                          col.anchors.line = NA,
                          interaction.measure="p.value",
                          interaction.dimension.transform="log",
                          col.outside="grey")

# Plot region around 
plotTracks(all_tracks, 
           from=84255991-1000, 
           to=84255991+1000, 
           chromosome="chr18",
           sizes=c(1, 1, 1, 1, 2))

## ----parallel, tidy=FALSE, eval=FALSE-----------------------------------------
# library(BiocParallel)
# 
# # Setup for parallel execution with 3 threads:
# register(MulticoreParam(workers=3))
# 
# # Disable parallel execution
# register(SerialParam())

## ----sessionInfo, tidy=FALSE--------------------------------------------------
sessionInfo()

#### Main S4 functions ####

#' Determine the optimal pooled threshold for unidirectional tag clustering.
#'
#' This function counts the number of Tag Clusters (TCs) for an series of small
#' incremental pooled cutoffs
#'
#' @param object GenomicRanges or RangedSummarizedExperiment: Pooled CTSS.
#' @param steps integer: Number of thresholds to analyze (in addition to
#'   treshold=0).
#' @param mergeDist integer: Merge TCs within this distance.
#' @param searchMethod character: For advanced user only, see details.
#' @param maxExponent numeric: The maximal threshold to analyse is obtained as
#'   min(score)*2^maxExponent (only used if searchMethod='exponential').
#' @param ... additional arguments passed to methods.
#'
#' @return data.frame with two columns: threshold and nTCs (number of Tag
#'   Clusters)
#' @family Clustering functions
#' @export
#' @examples
#' \dontrun{
#' data(exampleCTSSs)
#'
#' # Calculate pooledTPM, using supplied number of total tags
#' exampleCTSSs <- calcTPM(exampleCTSSs,
#'                         inputAssay='counts',
#'                         outputAssay='TPM',
#'                         totalTags='totalTags')
#' exampleCTSSs <- calcPooled(exampleCTSSs, inputAssay='TPM')
#'
#' # Set backend
#' library(BiocParallel)
#' register(SerialParam())
#'
#' # Find optimal slice-threshold for reduce distance of 20:
#' tuneTagClustering(object=exampleCTSSs)
#' }
setGeneric("tuneTagClustering", function(object, ...) {
    # Deprecation
    .Deprecated(c("clusterUnidirectionality", "subsetBySupport"))
    standardGeneric("tuneTagClustering")
})

#' @rdname tuneTagClustering
setMethod("tuneTagClustering", signature(object = "GRanges"),
          function(object, steps = 10L, mergeDist = 20L,
                   searchMethod = "minUnique", maxExponent = 1) {

    # Pre-checks
    assert_that(checkPooled(object),
                is.count(steps),
                is.numeric(maxExponent),
                is.count(mergeDist))

    # Setup series
    message("Finding thresholds to be tested...")
    if (searchMethod == "exponential") {
        exp_series <- min(score(object)) * 2^seq(from = 0,
                                                 to = maxExponent,
                                                 length.out = steps)
    } else if (searchMethod == "minUnique") {
        steps_series <- seq_len(steps)
        exp_series <- sort(unique(score(object)),
                           partial = steps_series)[steps_series]
        rm(steps_series)
    } else {
        stop("searchMethod must be either exponential or minUnique")
    }

    # Add zero
    exp_series <- c(0, exp_series)

    # Split coverage by strand
    message("Splitting by strand...")
    covByStrand <- splitPooled(object)

    # by_strand <- splitByStrand(object)
    # coverage_plus <- coverage(by_strand$`+`, weight = "score")
    # coverage_minus <- coverage(by_strand$`-`, weight = "score")
    # rm(by_strand)

    # Print some info
    message("Iterating over ", length(exp_series),
            " thresholds using ", BiocParallel::bpworkers(), " worker(s)...")

    # Count
    message("Analyzing plus strand...")
    n_plus <- BiocParallel::bpvec(exp_series, countClusters,
                                  cv = covByStrand$`+`, mergeDist = mergeDist)
    message("Analyzing minus strand...")
    n_minus <- BiocParallel::bpvec(exp_series, countClusters,
                                   cv = covByStrand$`-`, mergeDist = mergeDist)

    # Assemble results
    message("Preparing output...")
    o <- data.frame(threshold = exp_series, nTCs = n_plus + n_minus)

    # Return
    o
})

#' @rdname tuneTagClustering
setMethod("tuneTagClustering", signature(object = "RangedSummarizedExperiment"),
    function(object, ...) {
        tuneTagClustering(rowRanges(object), ...)
    })

#' @rdname tuneTagClustering
setMethod("tuneTagClustering",
          signature(object = "GPos"), function(object, ...) {
    tuneTagClustering(methods::as(object, "GRanges"), ...)
})

#### Helpers ####

countClusters <- function(thresholds, cv, mergeDist = 20L) {
    # Slice
    o <- lapply(thresholds, slice,
                x = cv, includeLower = FALSE,
                upper = Inf, rangesOnly = TRUE)

    # Reduce
    o <- lapply(o, reduce, min.gapwidth = mergeDist)

    # Count
    o <- lapply(o, elementNROWS)

    # Sum
    o <- vapply(o, sum, integer(1))

    # Return
    o
}

bam2bw <- function(i, o_plus, o_minus, minLength,...){
    # Attempt to read into R
    message("Reading BAM-file into memory: ", basename(i))
    o <- import(i, ...)

    # Cut reads and resize
    message("Finding 5'-ends...")
    o <- methods::as(o, "GRanges")
    o <- subset(o, width >= minLength)
    o <- resize(o, width = 1, fix = "start")

    # Count
    message("Locating CTSSs and counting tags...")
    o <- GenomicRanges::reduce(o, min.gapwidth = 0, with.revmap = TRUE)
    o <- methods::as(o, "StitchedGPos")
    score(o) <- elementNROWS(o$revmap)
    o$revmap <- NULL

    # Make sure output is ok
    message("Sorting and checking output...")
    o <- sort(o)
    n_tags <- sum(score(o))
    n_CTSSs <- length(o)

    # Split by strand
    message("Writing and writing BigWig-files...")
    by_strand <- utilsDeStrand(methods::as(o, "GRanges"))
    rm(o)

    # Write to file
    export.bw(object=by_strand$`+`, con=o_plus, format="bw")
    export.bw(object=by_strand$`-`, con=o_minus, format="bw")

    # Return
    c(CTSSs=n_CTSSs, Tags=n_tags)
}

#' Extract CTSSs from BAM-files (EXPERIMENTAL)
#'
#' Function for converting mapped reads in BAM-files to CAGE Transcription Start
#' Sites (CTSSs) in BigWig-files. Currently, this function will simply load a
#' (single-end) BAM-file (respecting a supplied ScanBamParam), optionally remove
#' short tags, and count the number of 5'-ends at each bp. Note, the BAM-file is
#' loaded as a single object, so you must be able to keep at least one complete
#' BAM-file in RAM.
#'
#' @note WARNING: This function is experimental, has not been thoroughly tested,
#'   and will most likely significantly change in upcoming CAGEfightR version.
#'   For comments/question please go to  the CAGEfightR github page.
#'
#' @param input character: Path to input BAM-file
#' @param outputPlus character: Path to output BigWig-file holding CTSSs on the
#'   plus strand.
#' @param outputMinus character: Path to output BigWig-file holding CTSSs on the
#'   minus strand.
#' @param minLength integer: Minimum length of mapped reads.
#' @param ... Additional arguments passed to rtracklayer::import. This will
#'   often include a ScanBamParam
#'
#' @return Number of CTSSs/Tags returned invisibly.
#' @importClassesFrom GenomicAlignments GAlignments
#' @export
#'
#' @examples
#' # TBA
convertBAM2BigWig <- function(input, outputPlus, outputMinus, minLength=1L, ...){
    assert_that(all(checkFileSeries(input)),
                is.character(outputPlus),
                is.character(outputMinus),
                length(input) == length(outputPlus),
                length(input) == length(outputMinus),
                is.count(minLength))

    # Only give warn about improper  extensions
    input_exts <- all(checkExtensions(input, ext="bam"))
    outputPlus_exts <- all(checkExtensions(outputPlus, ext="bw"))
    outputMinus_exts <- all(checkExtensions(outputMinus, ext="bw"))

    if(!input_exts){
        warning("Input BAM files do not all have the proper .bam extension! ",
                "Attempting import anyway...")
    }

    if(!outputPlus_exts | !outputMinus_exts){
        warning("Output BigWig files do not all have the proper .bw extension! ",
                "Attempting import anyway...")
    }

    # Simply loop
    tmp <- BiocParallel::bpmapply(bam2bw,
                                  input,
                                  outputPlus,
                                  outputMinus,
                                  MoreArgs = list(minLength=minLength, ...))

    # Return invisibly
    invisible(tmp)
}

#' Helper for checking pooled signal
#'
#' Checks whether a supplied pooled signal is valid: Single bp disjoint with
#' signal in the score column with supplied genome information.
#'
#' @param object GRanges or GPos: Pooled signal to be checked
#'
#' @return TRUE if object is correct format, otherwise an error is thrown
#' @family Checking functions
#' @export
#'
#' @examples
#' data(exampleCTSSs)
#' checkPooled(rowRanges(exampleCTSSs))
checkPooled <- function(object){
	# Checks
	x <- c(methods::is(object, "GenomicRanges"),
				 isDisjoint(object),
				 all(width(object) == 1),
				 !any(is.na(seqlengths(object))),
				 !is.null(score(object)),
				 is.numeric(score(object)))

	# Message if something is wrong:
	if(!all(x)){
	    stop("The supplied pooled signal is not valid!\n",
	         "A valid pooled signal must obey:\n",
             "- Stored as a GenomicRanges (eg. GRanges or GPos)\n",
             "- All ranges must have width=1 (single bp)\n",
             "- Ranges must be disjoint (non-overlapping)\n",
             "- Signal must be stored in the score metadata colum and be numeric\n",
             "- All seqlevels must have lengths (see seqlengths-function)")
	}

	# Return nothing
	TRUE
}

#' Helper for checking cluster with peaks
#'
#' Checks whether a supplied set of cluster have valid peaks: Whether the thick
#' column contains IRanges all contained within the main ranges.
#'
#' @param object GRanges or GPos: Clusters with peaks to be checked.
#'
#' @return TRUE if object is correct format, otherwise an error is thrown
#' @family Checking functions
#' @export
#'
#' @examples
#' data(exampleUnidirectional)
#' checkPeaked(rowRanges(exampleUnidirectional))
checkPeaked <- function(object){
	# Checks
    x <- c(methods::is(object, "GenomicRanges"),
           !is.null(object$thick),
           methods::is(object$thick, "IRanges"),
           all(poverlaps(mcols(object)$thick,
                         ranges(object),
                         type = "within")))

    # Message if something is wrong:
    if(!all(x)){
        stop("The the supplied regions does not have valid peaks!\n",
             "Valid regions with peaks must obey:\n",
             "- Stored as a GenomicRanges (eg. GRanges or GPos)\n",
             "- Have a metadata column named thick containing an IRanges-object\n",
             "- Main ranges must all contain the inner ranges in thick")
    }

    # Return nothing
    TRUE
}

#' Helper for checking files containing CTSSs
#'
#' Checks whether a file (or GRanges/GPos) contains data formatted in the same
#' manner as CAGE Transcription Start Sites (CTSSs): Each basepair of the genome
#' is associated with a single integer count.
#'
#' @param object BigWigFile, character, GRanges or GPos: Path to the file
#'   storing CTSSs, or an already improted GRanges/GPos.
#'
#' @return TRUE if CTSSs are correctly  formatted, otherwise a (hopefully)
#'   informative error is thrown.
#' @export
#'
#' @note In the case that a character is supplied pointing to a file, checkCTSSs
#'   will not check any extensions, but simply try to read it using
#'   rtracklayer::import. This means that checkCTSSs can technically analyze
#'   BED-files, although CAGEfightR can only import CTSSs from BigWig or
#'   bedGraph files.
#'
#' @examples
#' if (.Platform$OS.type != "windows") {
#' # Load example data
#' data('exampleDesign')
#' bw_plus <- system.file('extdata',
#'                        exampleDesign$BigWigPlus,
#'                        package = 'CAGEfightR')
#' bw_plus <- BigWigFileList(bw_plus)
#'
#' # Check raw file
#' checkCTSSs(bw_plus[[1]])
#'
#' # Import first, then check
#' gr  <- import(bw_plus[[1]])
#' checkCTSSs(gr)
#' }
setGeneric("checkCTSSs", function(object) {
    standardGeneric("checkCTSSs")
})

#' @rdname checkCTSSs
setMethod("checkCTSSs", signature(object = "ANY"), function(object) {
    stop("CTSSs can be checked as: a path to a BigWig/bedGraph file or a GRanges/GPos")
})

#' @rdname checkCTSSs
setMethod("checkCTSSs", signature(object = "GRanges"), function(object) {
    # Warning  for help
    if(length(object) == 0){
        warning("No CTSSs found: There are no ranges in the object!")
    }

    # Give informative error messages
    if(!isDisjoint(object)){
        stop("CTSSs are not disjoint: The ranges should not be overlapping!")
    }

    if(is.null(score(object))){
        stop("CTSSs do not have scores: Missing score column holding integer counts!")
    }

    if(any(score(object) %% 1 != 0)){
        stop("CTSSs do not have integer scores: The score column should contain the discrete number of 5'-ends of reads mapping to each bp!")
    }

    if(any(width(object) != 1)){
        stop("CTSSs are not bp-wise: Each range should be exactly 1 bp wide!\nNote: You can use `convertGRanges2GPos` function to correct for this.")
    }

    if(table(strand(object))["*"] > 0){
        warning("CTSSs are unstranded: CTSSs must be either on the + or - strand. ",
                "This warning can be ignored if a BigWig/bedGraph file was supplied, in which case each strand is stored in a separate file.")
    }

    # Return TRUE if check succeds
    TRUE
})

#' @rdname checkCTSSs
setMethod("checkCTSSs", signature(object = "character"), function(object) {
    # Make sure file is readable
    assert_that(is.string(object),
                file.exists(object),
                is.readable(object))

    # Attempt import
    message("Attempting import of supplied filename...")
    object <- import(object)

    # Check returned GRanges
    checkCTSSs(object)
})

#' @rdname checkCTSSs
setMethod("checkCTSSs", signature(object = "GPos"), function(object) {
    checkCTSSs(methods::as(object, "GRanges"))
})

#' @rdname checkCTSSs
setMethod("checkCTSSs", signature(object = "BigWigFile"), function(object) {
    # Make sure file is readable
    bwValid(object)

    # Attempt import
    object <- import(object)

    # Check returned GRanges
    checkCTSSs(object)
})

#### Range utilities ####

#' Utility: Split Genomic Ranges by strand
#'
#' Utility function that attemps to split genomic ranges by strand with split(object, strand(object))
#'
#' @param object Any object with a split and strand method, e.g. GRanges/GPos
#'
#' @return Object split by strand, e.g. GRangesList.
#' @family Utility functions
#' @export
#' @examples
#' gp <- GPos(seqnames=Rle(c("chr1", "chr2", "chr1"), c(10, 6, 4)),
#'             pos=c(44:53, 5:10, 2:5),
#'             strand=c(rep("+", 10), rep("-", 10)))
#' gr <- as(gp, "GRanges")
#' utilsDeStrand(gp)
#' utilsDeStrand(gr)
utilsDeStrand <- function(object) {
    split(object, strand(object))
}

# Kept here for backwards compatability
extendRanges <- function(object, upstream, downstream) {
    U <- flank(object, width = upstream, start = TRUE)
    D <- flank(object, width = downstream, start = FALSE)
    object <- punion(object, U)
    object <- punion(object, D)
    object
}

#### Counting Utilities ####

# Kept here for backwards compatability
countScoredOverlaps <- function(query, subject) {
    # Solution from bioconductor by M Morgan
    hits <- methods::as(findOverlaps(query = query, subject = subject), "List")
    weightedCount <- sum(extractList(score(subject), hits))

    # Return
    weightedCount
}

#' Utility: Counting overlaps taking into account scores
#'
#' Similar to countOverlaps, but takes the score column into account.
#'
#' @param query same as findOverlaps/countOverlaps
#' @param subject same as findOverlaps/countOverlaps
#' @param ... additional arguments passed to findOverlaps
#'
#' @return vector of number of overlaps weigthed by score column.
#' @seealso \url{https://support.bioconductor.org/p/87736/#87758}
#' @family Utility functions
#' @export
#' @examples
#' gr1 <- GRanges(seqnames="chr1",
#'                ranges=IRanges(start = c(4, 9, 10, 30),
#'                               end = c(4, 15, 20, 31)),
#'                strand="+")
#' gr2 <- GRanges(seqnames="chr1",
#'                ranges=IRanges(start = c(1, 4, 15, 25),
#'                               end = c(2, 4, 20, 26)),
#'                strand=c("+"),
#'                score=c(10, 20, 15, 5))
#' countOverlaps(gr1, gr2)
#' utilsScoreOverlaps(gr1, gr2)
utilsScoreOverlaps <- function(query, subject, ...) {
    # Solution from bioconductor by M Morgan
    o <- findOverlaps(query=query,  subject=subject, ...)
    o <- methods::as(o, "List")
    o <- sum(extractList(score(subject), o))

    # Return
    o
}

#' Utility: Aggregate rows
#'
#' Used by quantifyClusters and quantifyGenes. Wrapper around rowsum with a few
#' improvements: 1) Handles dgCMatrix 2) Suppresses warnings from and discards
#' NAs in grouping 3) Checks if output can be coerced to integer (useful when
#' aggregating a dgCMatrix), 4) For the dgCMatrix case, has the option to keep
#' unused levels and output a sparse matrix.
#'
#' @param x matrix or dgCMatrix: Matrix to be aggregated.
#' @param group factor: Grouping, can cannot NAs which will be discarded.
#' @param drop logical: Whether to drop unused levels (TRUE) or keep assign them
#'   0 (FALSE).
#' @param sparse logical: Whether output should be coerced to a dense matrix.
#'
#' @return matrix (or dgCMatrix if sparse=TRUE)
#'
#' @family Utility functions
#' @export
#' @examples
#' library(Matrix)
#' data("exampleCTSSs")
#' data("exampleUnidirectional")
#'
#' # Sparse and dense examples
#' sparse_matrix <- assay(exampleCTSSs)
#' dense_matrix <- as(sparse_matrix, "matrix")
#'
#' # Groupings
#' grp <- findOverlaps(query = exampleCTSSs,
#'                   subject = exampleUnidirectional,
#'                   select="arbitrary")
#'
#' # Aggregate rows and compare
#' sparse_res <- utilsAggregateRows(sparse_matrix, grp)
#' dense_res <- utilsAggregateRows(dense_matrix, grp)
#' all(sparse_res == dense_res)
#'
#' # Note that storage type was converted to integers!
#' storage.mode(sparse_res)
#' storage.mode(dense_res)
#'
#' # You can also elect to keep a sparse representation
#' utilsAggregateRows(sparse_matrix, grp, sparse = TRUE)
#'
#' #### Examples with unused levels ####
#'
#' # Silly example
#' dense_mat <- replicate(5, runif(10))
#' sparse_mat <- as(dense_mat, "dgCMatrix")
#' fct_unused <- factor(c(1, 1, NA, NA, 3, 3, NA, NA, 5, 5), levels=1:5)
#'
#' # The default is to drop unused levels
#' utilsAggregateRows(dense_mat, fct_unused, drop=TRUE)
#' utilsAggregateRows(sparse_mat, fct_unused, drop=TRUE)
#'
#' # For dgCMatrix, one can elect to retain these:
#' utilsAggregateRows(sparse_mat, fct_unused, drop=FALSE)
#'
#' # For matrix, a warning is produced if either drop or sparse is requested
#' utilsAggregateRows(dense_mat, fct_unused, drop=FALSE)
#' utilsAggregateRows(dense_mat, fct_unused, sparse=TRUE)
setGeneric("utilsAggregateRows", function(x, group, drop=TRUE, sparse=FALSE) {
    standardGeneric("utilsAggregateRows")
})

#' @rdname utilsAggregateRows
#' @export
setMethod("utilsAggregateRows", signature(x = "matrix"),
          function(x, group, drop=TRUE, sparse=FALSE) {
              # Pre-checks
              assert_that(nrow(x) == length(group),
                          is.flag(drop),
                          is.flag(sparse))

              # Drop sparse doesn't work on raw matrix
              if (isFALSE(drop) | isTRUE(sparse)) {
                  warning("Aggregating base::matrix always drops unused levels",
                          " and return a base::matrix!")
              }

              # Aggregate
              o <- suppressWarnings(rowsum(x, group))

              # Discard NAs
              if (anyNA(group)) {
                  o <- o[-nrow(o), ]
              }

              # Try and coerce output
              if(storage.mode(o)  != "integer"){
                  if (all(o == floor(o))){
                      storage.mode(o) <- "integer"
                  }
              }

              # Check output
              group <- factor(group)
              stopifnot(nrow(o) == length(levels(group)),
                        rownames(o) == levels(group))

              # Return
              o
          })

#' @rdname utilsAggregateRows
#' @importClassesFrom Matrix dgCMatrix
#' @export
setMethod("utilsAggregateRows", signature(x = "dgCMatrix"),
          function(x, group, drop=TRUE, sparse=FALSE) {
              # Pre-checks
              assert_that(nrow(x) == length(group),
                          is.flag(drop),
                          is.flag(sparse))

              # Use matrix multiplixation
              o <- Matrix::fac2sparse(group, drop.unused.levels = drop)
              o <- o %*% x

              # Coerce to dense integer matrix
              if(isFALSE(sparse)){
                  o <- methods::as(o, "matrix")
                  if(storage.mode(o)  != "integer"){
                      if (all(o == floor(o))){
                          storage.mode(o) <- "integer"
                      }
                  }
              }

              # Return
              o
          })

#### Annotation utilities ####

#' Utility: Extract annotation hierachy from a TxDb.
#'
#' Used by assignTxType. This function extracts the hierachical annotations used
#' by assignTxType from a TxDb object. If you are annotating many ranges, it can
#' be time saving to built the hierachy first, to avoid processing the TxDb for
#' every assignTxDb call.
#'
#' @param object TxDb: Transcript database
#' @param tssUpstream integer: Distance to extend annotated promoter upstream.
#' @param tssDownstream integer: Distance to extend annotated promoter
#'   downstream.
#' @param proximalUpstream integer: Maximum distance upstream of promoter to be
#'   considered proximal.
#' @param detailedAntisense logical: Wether to mirror all txType categories in
#'   the antisense direction (TRUE) or lump them all together (FALSE).
#'
#' @return GRangesList of annotation hierachy
#' @family Utility functions
#' @seealso assignTxType
#' @export
#'
#' @examples
#' \dontrun{
#' data(exampleUnidirectional)
#'
#' # Obtain transcript models from a TxDb-object:
#' library(TxDb.Mmusculus.UCSC.mm9.knownGene)
#' txdb <- TxDb.Mmusculus.UCSC.mm9.knownGene
#'
#' # Simplify txdb
#' hierachy <- utilsSimplifyTxDb(txdb)
#'
#' # Standard way of calling
#' x <- assignTxType(exampleUnidirectional,
#'                   txModels=txdb)
#'
#' # Calling with premade hierachy
#' y <- assignTxType(exampleUnidirectional, txModels=hierachy)
#'
#' # These are identical
#' stopifnot(all(rowRanges(x)$txType == rowRanges(y)$txType))
#' }
utilsSimplifyTxDb <- function(object,
                              tssUpstream = 100,
                              tssDownstream = 100,
                              proximalUpstream = 1000,
                              detailedAntisense = FALSE){
    # Pre-checks
    assert_that(methods::is(object, "TxDb"),
                is.count(tssUpstream),
                is.count(tssDownstream),
                is.count(proximalUpstream),
                is.flag(detailedAntisense))

    # Build sense hierachy
    hierachy <- GRangesList(
        promoter = granges(trim(promoters(object, upstream = tssUpstream,
                                          downstream = tssDownstream))),
        proximal = granges(trim(promoters(object, upstream = proximalUpstream,
                                          downstream = 0))),
        fiveUTR = granges(unlist(fiveUTRsByTranscript(object))),
        threeUTR = granges(unlist(threeUTRsByTranscript(object))),
        CDS = granges(cds(object)),
        exon = granges(exons(object)),
        intron = granges(unlist(intronsByTranscript(object))))

    # Build antisense hierachy message('Adding antisense categories...')
    if (detailedAntisense) {
        antisense <- invertStrand(hierachy)
        names(antisense) <- paste0("antisense_", names(antisense))
        hierachy <- c(hierachy, antisense)
    } else if (!detailedAntisense) {
        antisense <- invertStrand(granges(transcripts(object)))
        hierachy$antisense <- antisense
    } else {
        stop("detailedAntisense must be either TRUE/FALSE!")
    }

    #  Return
    hierachy
}

#' Swap ranges in a GRanges.
#'
#' Swap out the range of a GRanges-object with another IRanges-object stored
#' inside the same object. I.e., swapping cluster widths with cluster peaks.
#'
#' @param object GRanges or RangedSummarizedExperiment: Primary ranges to be
#'   swapped out.
#' @param inputColumn character: Name of column holding IRanges to be swapped
#'   in.
#' @param outputColumn character or NULL: Name of column to hold swapped out
#'   ranges, if NULL original ranges are not saved.
#' @param ... additional arguments passed to methods.
#'
#' @return GRanges with inputColumn swapped in as ranges.
#'
#' @family Swapping functions
#' @export
#' @examples
#' data(exampleUnidirectional)
#' gr <- rowRanges(exampleUnidirectional)
#'
#' # Swap in peaks as main ranges
#' peaks <- swapRanges(gr)
#' head(width(gr))
#' head(width(peaks))
#'
#' # swapRanges() can also be directly called on a RangedSummarizedExperiment:
#' swapRanges(exampleUnidirectional)
#'
#' # The original can optionally be saved in the output object
#' swapRanges(gr, outputColumn = 'swapped')
setGeneric("swapRanges", function(object, ...) {
    standardGeneric("swapRanges")
})

#' @rdname swapRanges
setMethod("swapRanges", signature(object = "GenomicRanges"), function(object, inputColumn = "thick",
    outputColumn = NULL) {
    # Pre-checks
    assert_that(is.string(inputColumn),
    						is.element(inputColumn, colnames(mcols(object))),
    						methods::is(mcols(object)[, inputColumn], "IRanges"),
    						is.string(outputColumn) | is.null(outputColumn))

    # Warnings
    if (!is.null(outputColumn)) {
        if (outputColumn %in% colnames(mcols(object))) {
            warning("object already has a column named ", outputColumn, " in mcols: It will be overwritten!")
        }
    }

    # Save old range as new column
    onames <- names(object)
    mcols(object)[, outputColumn] <- ranges(object)

    # Switch in the new column
    ranges(object) <- mcols(object)[, inputColumn]

    # Use original names names(object) <- names(mcols(object)[,outputColumn])
    names(object) <- onames

    # Return
    object
})

#' @rdname swapRanges
setMethod("swapRanges", signature(object = "RangedSummarizedExperiment"), function(object,
    ...) {
    rowRanges(object) <- swapRanges(rowRanges(object), ...)
    object
})

#' Swap scores in SummarizedExperiment
#'
#' Take scores for a specific sample and a specific assay and put them into
#' rowData.
#'
#' @param object SummarizedExperiment: CAGE-data
#' @param outputColumn character: Column in rowData to to hold swapped in
#'   scores.
#' @param inputAssay character: Name of assay to take scores from.
#' @param sample character: Name of sample to take scores from.
#'
#' @return SummarizedExperiment with sample scores from inputAssay in rowRata.
#' @family Swapping functions
#' @export
#' @examples
#' data(exampleCTSSs)
#' sample_names <- colnames(exampleCTSSs)
#'
#' # Replace scores with values from the first sample:
#' x <- swapScores(exampleCTSSs, inputAssay='counts', sample=sample_names[1])
#' rowRanges(x)
swapScores <- function(object, outputColumn = "score", inputAssay, sample) {
    assert_that(methods::is(object, "SummarizedExperiment"), is.string(outputColumn),
        is.string(inputAssay), is.element(inputAssay, assayNames(object)), is.string(sample),
        is.element(sample, colnames(object)))

    # Warnings
    if (outputColumn %in% colnames(rowData(object))) {
        warning("object already has a column named ", outputColumn, " in rowData: It will be overwritten!")
    }

    # Swap in new column from assay
    rowData(object)[, outputColumn] <- assay(object, inputAssay)[, sample]

    # Return
    object
}

#### Helper functions ####

# Functions
findBidirRegions <- function(object, window){
	# Pre-checks
	assert_that(methods::is(object, "GRanges"),
							checkPooled(object),
							is.count(window))

	# Reduce and expand
	object <- reduce(object)
	object <- promoters(object, upstream=window-1, downstream = 1)
	object <- reduce(object)

	# Return only ranges on both strand
	object <- splitByStrand(object)
	object <- intersect(x=object$`+`, y=object$`-`,
	                    ignore.strand=TRUE)

	# Expand with quantification window
	object <- object + (window - 1)
	object <- reduce(object)
	object <- trim(object)
	object <- sort(object)

	# Return
	object
}

padlag <- function(r, k = 0, padval=0L) {
    stopifnot(methods::is(r, "Rle"))
    stopifnot(k <= length(r))

    if (k == 0) {
        o <- r
    } else if (k > 0) {
        o <- c(window(r, 1 + k), Rle(values = padval, lengths = abs(k)))
    } else if (k < 0) {
        o <- c(Rle(values = padval, lengths = abs(k)), window(r, 1, length(r) - abs(k)))
    }

    stopifnot(length(r) == length(o))
    o
}

coverageWindows <- function(pooled, window, balanceFun) {
    # Checks never done inside...

    # Obtain shift
    #shift_val <- ceiling(window/2)
    shift_val <- floor(window/2)

    # Split coverage
    message("Splitting by strand...")
    covByStrand <- splitPooled(pooled)

    # Shifted running sums on both strands...
    message("Calculating windowed coverage on plus strand...")
    P <- runsum(covByStrand$`+`, k = window, endrule = "constant")
    PD <- endoapply(P, padlag, k = shift_val)
    PU <- endoapply(P, padlag, k = -shift_val)
    rm(P)

    message("Calculating windowed coverage on minus strand...")
    M <- runsum(covByStrand$`-`, k = window, endrule = "constant")
    MD <- endoapply(M, padlag, k = -shift_val)
    MU <- endoapply(M, padlag, k = shift_val)
    rm(covByStrand, M)

    # Evaluate balance if need
    if (!is.null(balanceFun)) {
        message("Calculating balance score...")
        B <- mendoapply(balanceFun, PD, MD, PU, MU)
    } else {
        B <- NULL
    }

    # Build output
    o <- list(PD = PD, MD = MD, PU = PU, MU = MU, B = B)

    # Return
    o
#
#     # Split into strand
#     covByStrand <- splitByStrand(pooled)
#     rm(pooled)
#
#     message("Calculating windowed coverage on plus strand...")
#     P <- coverage(covByStrand$`+`, weight = "score")
#     P <- round(P, digits = 9)
#     P <- runsum(P, k = window, endrule = "constant")
#     #P[P < 0] <- 0
#     PD <- endoapply(P, padlag, k = shift_val)
#     PU <- endoapply(P, padlag, k = -shift_val)
#     rm(P)
#
#     message("Calculating windowed coverage on minus strand...")
#     M <- coverage(covByStrand$`-`, weight = "score")
#     M <- round(M, digits = 9)
#     M <- runsum(M, k = window, endrule = "constant")
#     #M[M < 0] <- 0
#     MD <- endoapply(M, padlag, k = -shift_val)
#     MU <- endoapply(M, padlag, k = shift_val)
#     rm(covByStrand, M)
#
#     if (!is.null(balanceFun)) {
#         message("Calculating balance score...")
#         B <- mendoapply(BC, PU, PD, MU, MD)
#     } else {
#         B <- NULL
#     }
#
#     # Build output
#     o <- list(PD = PD, MD = MD, PU = PU, MU = MU, B = B)
#
#     # Return
#     o
}

#' Balance statistic: Bhattacharyya coefficient (BC)
#'
#' Calculates the Bhattacharyya coefficient from observed plus/minus
#' upstream/downstream signals to a perfect bidirectional site, where
#' plus-downstream = 50% and minus-downstream = 50%
#'
#' @param PD Plus-Downstream signal
#' @param MD Minus-Downstream signal
#' @param PU Plus-Upstream signal
#' @param MU Plus-Upstream signal
#'
#' @return Balance score of the same class as inputs.
#' @export
#'
#' @examples
#' # Unbalanced
#' balanceBC(2, 3, 1, 0)
#'
#' # Balanced
#' balanceBC(3, 3, 0, 0)
balanceBC <- function(PD, MD, PU, MU){
    # Check all input have the same class
    input_classes <- c(class(PD),
                       class(MD),
                       class(PU),
                       class(MU))
    single_class <- unique(input_classes)
    stopifnot(length(single_class) == 1)

    # Sum of all
    S <- PD + MD + PU + MU

    # Check for negative sums
    if(any(any(S < 0))){
        stop("BC calculation stopped because some sites had negative pooled signal!")
    }

    # Only calcuate downstream arms - rest will be zero
    B <- sqrt((PD / S) * 0.5) + sqrt((MD / S) * 0.5)

    # Remove NAs resulting from division by zero.
    B[is.na(B)] <- 0

    # Checks
    stopifnot(methods::is(B, single_class))

    # Return
    B
}

#' Balance statistic: Andersson's D.
#'
#' Calculates the D-statistics from Andersson et al the observed plus/minus
#' downstream signals. The D statistics is rescaled from -1:1 to 0:1 so it can
#' be used for slice-reduce identification of bidirectional sites.
#'
#' @param PD Plus-Downstream signal
#' @param MD Minus-Downstream signal
#' @param PU Plus-Upstream signal
#' @param MU Plus-Upstream signal
#'
#' @return Balance score of the same class as inputs.
#' @export
#'
#' @examples
#' # Unbalanced
#' balanceD(2, 3, 1, 0)
#'
#' # Balanced
#' balanceD(3, 3, 0, 0)
balanceD <- function(PD, MD, PU, MU){
    # Check all input have the same class
    input_classes <- c(class(PD),
                       class(MD),
                       class(PU),
                       class(MU))
    single_class <- unique(input_classes)
    stopifnot(length(single_class) == 1)

    # Sum of forward reverse
    S <- PD + MD

    # Check for negative sums
    if(any(any(S < 0))){
        stop("D calculation stopped because some sites had negative pooled signal!")
    }

    # Andersson only uses PD/MD.
    #B <- -((PD - MD) / S) + 1
    B <- abs(abs((PD - MD) / S) - 1)


    # Remove NAs resulting from division by zero.
    B[is.na(B)] <- 0

    # Checks
    stopifnot(methods::is(B, single_class))

    # Return
    B
}

BC <- function(plusUpstream, plusDownstream, minusUpstream, minusDownstream) {
    # Check all input have the same class
    input_classes <- c(class(plusUpstream), class(plusDownstream), class(minusUpstream),
        class(minusDownstream))
    single_class <- unique(input_classes)
    stopifnot(length(single_class) == 1)

    # Sum of all
    S <- plusUpstream + plusDownstream + minusUpstream + minusDownstream

    # Check for negative sums
    if(any(any(S < 0))){
    	stop("BC calculation stopped because some sites had negative pooled signal!")
    }

    # Only calcuate downstream arms - rest will be zero
    B <- sqrt((minusDownstream/S) * 0.5) + sqrt((plusDownstream/S) * 0.5)

    # Remove NAs resulting from 0/0
    B[is.na(B)] <- 0

    # Checks
    stopifnot(methods::is(B, single_class))

    # Return
    B
}

#### Main functions ####

#' Bidirectional clustering of pooled CTSSs.
#'
#' Finds sites with (balanced and divergent) bidirectional transcription using
#' sliding windows of summed coverage: The Bhattacharyya coefficient (BC) is
#' used to quantify depature from a perfectly balanced site, and a slice-reduce
#' is used to identify sites.
#'
#' @param object GenomicRanges or RangedSummarizedExperiment: Pooled CTSSs
#'   stored in the score column.
#' @param window integer: Width of sliding window used for calculating window
#'   sums.
#' @param balanceThreshold numeric: Minimum value of the BC to use for
#'   slice-reduce, a value of 1 corresponds to perfectly balanced sites.
#' @param balanceFun function: Advanced users may supply their own function for
#'   calculating the balance score instead of the the default balanceBC. See
#'   details for instructions.
#' @param ... additional arguments passed to methods.
#'
#' @return GRanges with bidirectional sites: Minimum width is 1 + 2*window, TPM
#'   sum (on both strands) in the score column, maximal bidirectional site in
#'   the thick column and maximum balance in the balance column.
#' @family Clustering functions
#'
#' @export
#' @examples
#' \dontrun{
#' data(exampleCTSSs)
#'
#' # Calculate pooledTPM, using supplied number of total tags
#' exampleCTSSs <- calcTPM(exampleCTSSs,
#'                         inputAssay='counts',
#'                         outputAssay='TPM',
#'                         totalTags='totalTags')
#' exampleCTSSs <- calcPooled(exampleCTSSs, inputAssay='TPM')
#'
#' # Cluster using defaults: balance-treshold of 199 and window of 199 bp:
#' clusterBidirectionally(exampleCTSSs)
#'
#' # Use custom thresholds:
#' clusterBidirectionally(exampleCTSSs, balanceThreshold=0.99, window=101)
#' }
setGeneric("clusterBidirectionally", function(object, ...) {
    standardGeneric("clusterBidirectionally")
})

#' @rdname clusterBidirectionally
setMethod("clusterBidirectionally", signature(object = "GRanges"),
          function(object, window = 201,
                   balanceThreshold = 0.95, balanceFun=balanceBC) {
    # Pre-checks
    assert_that(checkPooled(object),
                is.count(window),
                window %% 2 == 1,
                window >= 3,
                is.number(balanceThreshold),
                balanceThreshold >= 0,
                is.function(balanceBC))

	# Pre-filter
	message("Pre-filtering bidirectional candidate regions...")
	bidir_regions <- suppressWarnings(findBidirRegions(object=object,
	                                                   window=window))
	bidir_regions <- subsetByOverlaps(object, bidir_regions)
	message("Retaining for analysis: ",
	        scales::percent(length(bidir_regions) / length(object)))

    # Get windows (message inside coverageWindows)
    cw <- coverageWindows(pooled = bidir_regions,
                          window = window,
                          balanceFun = balanceFun)
    B <- cw$B
    rm(bidir_regions, cw)

    # Prepare for slicing
    if (any(any(B < 0, na.rm = TRUE))) {
        stop("Balance function produced values below 0!",
             "Output values must be in range [0-Inf) to allow for slicing...")
    } else if(any(anyNA(B))){
    	warning("Calculated balance scores contained missing values!",
    	        "replacing these with 0...")
    	B[is.na(B)] <- 0
    }

    message("Slice-reduce to find bidirectional clusters...")
    # Slice
    bidirLoci <- slice(B,
                       lower = balanceThreshold,
                       upper = Inf,
                       includeLower = FALSE,
                       rangesOnly = TRUE)

    # Merge
    mergeDist <- (window - 1) * 2
    bidirLoci <- reduce(bidirLoci, min.gapwidth = mergeDist)
    stopifnot(isDisjoint(bidirLoci))

    # Expand by window size
    bidirLoci <- bidirLoci + (window - 1)
    #start(bidirLoci) <- methods::as(start(bidirLoci) - window, "IntegerList")
    #end(bidirLoci) <- methods::as(end(bidirLoci) + window, "IntegerList")
    stopifnot(isDisjoint(bidirLoci))

    if (!sum(elementNROWS(bidirLoci), na.rm = TRUE) > 0) {
        warning("No bidirectional sites found at the given balance threshold!")
    }

    message("Calculating statistics...")
    # Coverage on both strands
    A <- coverage(object, weight = "score")
    A <- round(A, digits = getOption("CAGEfightR.round"))

    # Views on score and balance
    viewsA <- Views(A, bidirLoci)
    viewsB <- Views(B, bidirLoci)
    rm(A, B)

    # Scores and midpoint
    scores <- viewSums(viewsA)
    peaks <- viewRangeMaxs(viewsB)
    peaks <- resize(x = peaks, width = 1, fix = "center", use.names = FALSE)

    # Maximum balance
    balance <- viewMaxs(viewsB)

    # Assemble output
    o <- GRanges(bidirLoci,
                 score = unlist(scores),
                 thick = unlist(peaks),
                 balance = unlist(balance))
    rm(scores, peaks, balance, viewsA, viewsB)

    # Carry over seqinfo
    message("Preparing output...")
    seqinfo(o) <- seqinfo(object)
    o <- sort(o)

    # Names as IDs for both ranges and peaks
    o_ids <- paste0(seqnames(o), ":", start(o), "-", end(o))
    names(o) <- o_ids
    names(o$thick) <- o_ids
    rm(o_ids)

    # Report summary for width, score and balance
    message("# Bidirectional clustering summary:")
    message("Number of bidirectional clusters: ", length(o))
    message("Maximum balance score: ", max(o$balance))
    message("Minimum balance score: ", min(o$balance))
    message("Maximum width: ", max(width(o)))
    message("Minimum width: ", min(width(o)))

    # Return
    o
})

#' @rdname clusterBidirectionally
setMethod("clusterBidirectionally", signature(object = "GPos"),
					function(object, ...) {
						clusterBidirectionally(methods::as(object, "GRanges"), ...)
					})

#' @rdname clusterBidirectionally
setMethod("clusterBidirectionally", signature(object = "RangedSummarizedExperiment"),
    function(object, ...) {
        clusterBidirectionally(rowRanges(object), ...)
    })

#' Calculate sample-wise bidirectionally of clusters.
#'
#' For each cluster, calculate how many individual samples shows transcription
#' in both directions. This is refered to as the 'bidirectionality'. Clusters
#' must be unstranded (*) and have a midpoint stored in the thick column
#'
#' @param object GenomicRanges or RangedSummarizedExperiment: Unstranded
#'   clusters with midpoints stored in the 'thick' column.
#' @param samples RangedSummarizedExperiment: Sample-wise CTSSs stored as an
#'   assay.
#' @param inputAssay character: Name of assay in samples holding input CTSS
#'   values.
#' @param outputColumn character: Name of column in object to hold
#'   bidirectionality values.
#' @param ... additional arguments passed to methods.
#'
#' @return object returned with bidirectionality scores added in rowData (or
#'   mcols).
#' @family Calculation functions
#' @export
#' @examples
#' data(exampleCTSSs)
#' data(exampleBidirectional)
#'
#' calcBidirectionality(exampleBidirectional, samples=exampleCTSSs)
setGeneric("calcBidirectionality", function(object, ...) {
    standardGeneric("calcBidirectionality")
})

#' @rdname calcBidirectionality
#' @export
setMethod("calcBidirectionality", signature(object = "GRanges"), function(object,
    samples, inputAssay = "counts", outputColumn = "bidirectionality") {
    # Pre-checks
    assert_that(checkPeaked(object),
                all(strand(object) == "*"),
                # Check samples
                methods::is(samples, "RangedSummarizedExperiment"),
                isDisjoint(samples),
                not_empty(seqlengths(samples)),
                noNA(seqlengths(samples)),
                is.string(inputAssay),
                inputAssay %in% assayNames(samples),
                is.string(outputColumn))

    # Warnings
    if (outputColumn %in% colnames(mcols(object))) {
        warning("object already has a column named ",
                outputColumn,
                " in mcols: It will be overwritten!")
    }

    # Extract arms
    arms_plus <- object
    start(arms_plus) <- end(arms_plus$thick)
    strand(arms_plus) <- "+"

    arms_minus <- object
    end(arms_minus) <- start(arms_minus$thick)
    strand(arms_minus) <- "-"

    # Quantify
    mat_plus <- suppressMessages(quantifyClusters(samples, arms_plus, inputAssay = inputAssay))
    mat_plus <- assay(mat_plus, inputAssay) > 0
    mat_minus <- suppressMessages(quantifyClusters(samples, arms_minus, inputAssay = inputAssay))
    mat_minus <- assay(mat_minus, inputAssay) > 0

    # Compare and count
    o <- mat_plus & mat_minus
    rm(mat_plus, mat_minus)
    o <- rowSums(o)

    # Post-checks
    stopifnot(length(o) == length(object), max(o) <= ncol(samples))

    # Add to object
    mcols(object)[, outputColumn] <- o

    # Return
    object
})

#' @rdname calcBidirectionality
#' @export
setMethod("calcBidirectionality", signature(object = "GPos"),
          function(object, ...) {
              calcBidirectionality(methods::as(object, "GRanges"), ...)
          })

#' @rdname calcBidirectionality
#' @export
setMethod("calcBidirectionality", signature(object = "RangedSummarizedExperiment"),
    function(object, ...) {
        rowRanges(object) <- calcBidirectionality(rowRanges(object), ...)
        object
    })

#' Subset by sample-wise bidirectionality of clusters.
#'
#' A convenient wrapper around calcBidirectionality and subset.
#'
#' @param object GRanges or RangedSummarizedExperiment: Unstranded clusters with
#'   peaks stored in the 'thick' column.
#' @param samples RangedSummarizedExperiment: Sample-wise CTSSs stored as an
#'   assay.
#' @param inputAssay character: Name of assay in samples holding input CTSS
#'   values.
#' @param outputColumn character: Name of column in object to hold
#'   bidirectionality values.
#' @param minSamples integer: Only regions with bidirectionality above this
#'   value are retained.
#' @param ... additional arguments passed to methods.
#'
#' @return object with bidirectionality values added as a column, and low
#'   bidirectionaly regions removed.
#'
#' @family Subsetting functions
#' @family Calculation functions
#'
#' @export
#' @examples
#' data(exampleCTSSs)
#' data(exampleBidirectional)
#'
#' # Keep only clusters that are bidirectional in at least one sample:
#' subsetByBidirectionality(exampleBidirectional, samples=exampleCTSSs)
setGeneric("subsetByBidirectionality", function(object, ...) {
    standardGeneric("subsetByBidirectionality")
})

#' @rdname subsetByBidirectionality
#' @export
setMethod("subsetByBidirectionality", signature(object = "GRanges"), function(object,
    samples, inputAssay = "counts", outputColumn = "bidirectionality", minSamples = 0) {
    assert_that(is.number(minSamples))

    # Call function
    message("Calculating bidirectionality...")
    object <- calcBidirectionality(object = object,
                                   samples = samples,
                                   inputAssay = inputAssay,
                                   outputColumn = outputColumn)
    before <- length(object)

    # Subset
    message("Subsetting...")
    object <- object[mcols(object)[, outputColumn] > minSamples, ]
    after <- length(object)
    removed <- before - after

    # Print some info
    message("Removed ", removed,
            " out of ", before,
            " regions (", round(removed/before * 100, digits = 1), "%)")

    # Return
    object
})

#' @rdname subsetByBidirectionality
#' @export
setMethod("subsetByBidirectionality", signature(object = "GPos"),
          function(object, ...) {
              subsetByBidirectionality(methods::as(object, "GRanges"), ...)
          })

#' @rdname subsetByBidirectionality
#' @export
setMethod("subsetByBidirectionality", signature(object = "RangedSummarizedExperiment"),
    function(object, ...) {
        # Force call of GRanges generic
        methods::selectMethod("subsetByBidirectionality", "GRanges")@.Data(object = object,
            ...)
    })

#### Main shape function ####

#' Calculate Tag Cluster shapes
#'
#' Apply a shape-function to the pooled CTSS signal of every Tag Cluster (TC).
#'
#' @param object GenomicRanges or RangedSummarizedExperiment: TCs.
#' @param pooled GenomicRanges or RangedSummarizedExperiment: Pooled CTSS as the
#'   score column.
#' @param outputColumn character: Name of column to hold shape statistics.
#' @param shapeFunction function: Function to apply to each TC (See details).
#' @param ... additional arguments passed to shapeFunction.
#'
#' @return object with calculated shape statistics added as a column in rowData
#'   (or mcols).
#' @family Calculation functions
#' @family Shape functions
#' @export
#' @examples
#' data(exampleCTSSs)
#' data(exampleUnidirectional)
#'
#' # Calculate pooled CTSSs using pre-calculated number of total tags:
#' exampleCTSSs <- calcTPM(exampleCTSSs, totalTags='totalTags')
#' exampleCTSSs <- calcPooled(exampleCTSSs)
#'
#' # Calculate shape statistics
#' calcShape(exampleUnidirectional, pooled=exampleCTSSs,
#'     outputColumn='entropy', shapeFunction=shapeEntropy)
#' calcShape(exampleUnidirectional, pooled=exampleCTSSs, outputColumn='IQR',
#'     shapeFunction=shapeIQR, lower=0.2, upper=0.8)
#'
#' # See the vignette for how to implement custom shape functions!
setGeneric("calcShape", function(object, pooled, ...) {
    standardGeneric("calcShape")
})

#' @rdname calcShape
setMethod("calcShape", signature(object = "GRanges", pooled = "GRanges"),
          function(object, pooled, outputColumn = "IQR",
                   shapeFunction = shapeIQR, ...) {
    # Pre-checks
    assert_that(checkPooled(pooled),
                is.character(outputColumn),
                is.function(shapeFunction),
                identical(seqlengths(object), seqlengths(pooled)))

    # Warnings
    if (outputColumn %in% colnames(mcols(object))) {
        warning("object already has a column named ",
                outputColumn, " in mcols: It will be overwritten!")
    }

    # Names need to be set for sorting later
    if (is.null(names(object))) {
        message("Adding names...")
        names(object) <- paste("TC", seq_along(object))
    }

    # Split by strand
    message("Splitting by strand...")
    covByStrand <- splitPooled(pooled)
    TCsByStrand <- splitByStrand(object)

    #covByStrand <- splitByStrand(pooled)
    #TCsByStrand <- splitByStrand(object)

    # Coverage by strand
    #coverage_plus <- coverage(covByStrand$`+`, weight = "score")
    #coverage_minus <- coverage(covByStrand$`-`, weight = "score")
    #rm(covByStrand)

    # Views
    message("Applying function to each cluster...")
    views_plus <- Views(covByStrand$`+`, methods::as(TCsByStrand$`+`, 'IRangesList'))
    views_minus <- Views(covByStrand$`-`, methods::as(TCsByStrand$`-`, 'IRangesList'))
    rm(covByStrand)

    # Tmp solution circumventing direct use of RangesList
    #views_plus <- Views(coverage_plus, split(ranges(TCsByStrand$`+`), seqnames(TCsByStrand$`+`)))
    #views_minus <- Views(coverage_minus, split(ranges(TCsByStrand$`-`), seqnames(TCsByStrand$`-`)))

    # Applying functions to views
    stat_plus <- viewApply(views_plus, shapeFunction, ...)
    stat_minus <- viewApply(views_minus, shapeFunction, ...)

    # Reset names
    message("Preparing output output...")
    stat_plus <- as.numeric(unlist(stat_plus, use.names = FALSE))
    names(stat_plus) <- names(TCsByStrand$`+`)
    stat_minus <- as.numeric(unlist(stat_minus, use.names = FALSE))
    names(stat_minus) <- names(TCsByStrand$`-`)
    rm(TCsByStrand)

    # Reassemble in same order
    o <- c(stat_plus, stat_minus)
    o <- o[match(names(object), names(o))]
    names(o) <- NULL
    rm(stat_plus, stat_minus)

    # Add to object
    mcols(object)[, outputColumn] <- o

    # Return
    object
})

#' @rdname calcShape
setMethod("calcShape", signature(object = "RangedSummarizedExperiment", pooled = "GRanges"),
    function(object, pooled, ...) {
        rowRanges(object) <- calcShape(rowRanges(object), pooled, ...)
        object
    })

#' @rdname calcShape
setMethod("calcShape", signature(object = "GRanges", pooled = "RangedSummarizedExperiment"),
    function(object, pooled, ...) {
        calcShape(object, rowRanges(pooled), ...)
    })

#' @rdname calcShape
setMethod("calcShape", signature(object = "GRanges", pooled = "GPos"),
					function(object, pooled, ...) {
						calcShape(object, methods::as(pooled, "GRanges"), ...)
					})

#' @rdname calcShape
setMethod("calcShape", signature(object = "RangedSummarizedExperiment", pooled = "RangedSummarizedExperiment"),
    function(object, pooled, ...) {
        rowRanges(object) <- calcShape(rowRanges(object), rowRanges(pooled), ...)
        object
    })

#### Individual shape functions ####

#' Shape statitic: Interquartile range
#'
#' Calculates the interquartile range of a vector.
#'
#' @param x numeric Rle vector: Coverage series.
#' @param lower numeric: Lower quartile.
#' @param upper numeric: Upper quartile.
#'
#' @return Numeric
#' @family Shape functions
#' @export
#' @examples
#' # Hypothetical shard/broad clusters:
#' x_sharp <- Rle(c(1,1,1,4,5,2,1,1))
#' x_broad <- Rle(c(1,2,3,5,4,3,2,1))
#'
#' # Calculate IQR
#' shapeIQR(x_sharp)
#' shapeIQR(x_broad)
#'
#' # See calcShape for more usage examples
shapeIQR <- function(x, lower = 0.25, upper = 0.75) {
    # To normal vector
    x <- as.vector(x)

    # Scale by sum
    x <- x/sum(x)

    # Cumulate sum
    x <- cumsum(x)

    # Find the threshold
    lowerPos <- Position(function(y) y >= lower, x)
    upperPos <- Position(function(y) y >= upper, x)

    # Return difference
    upperPos - lowerPos
}

#' Shape statistic: Shannon Entropy
#'
#' Calculates the Shannon Entropy (base log2) for a vector. Zeros are removed
#' before calculation.
#'
#' @param x numeric Rle vector: Coverage series.
#'
#' @return Numeric.
#' @family Shape functions
#' @export
#' @examples
#' # Hypothetical shard/broad clusters:
#' x_sharp <- Rle(c(1,1,1,4,5,2,1,1))
#' x_broad <- Rle(c(1,2,3,5,4,3,2,1))
#'
#' # Calculate Entropy
#' shapeEntropy(x_sharp)
#' shapeEntropy(x_broad)
#'
#' # See calcShape for more usage examples
shapeEntropy <- function(x) {
    # To normal vector x <- as.vector(x[x > 0])
    x <- as.vector(x)

    # Scale by sum
    x <- x/sum(x)

    # Calculate entropy
    o <- suppressWarnings(-sum(ifelse(x > 0, x * log2(x), 0)))

    # Return
    o
}

#' Shape statistic: Mean
#'
#' Calculates the mean of a vector.
#'
#' @param x numeric Rle vector: Coverage series.
#'
#' @return Numeric
#' @family Shape functions
#' @export
#' @examples
#' # Hypothetical shard/broad clusters:
#' x_sharp <- Rle(c(1,1,1,4,5,2,1,1))
#' x_broad <- Rle(c(1,2,3,5,4,3,2,1))
#'
#' # Calculate mean
#' shapeMean(x_sharp)
#' shapeMean(x_broad)
#'
#' # See calcShape for more usage examples
shapeMean <- function(x){
    x <- as.vector(x)
    stats::weighted.mean(x=seq_along(x), weights=x)
}

isobreak <- function(i, x) {
    # Split into segments x1 <- x[1:i]
    x1 <- x[seq_len(i)]
    x2 <- x[i:length(x)]

    # Reverse second
    x2 <- -x2

    # Fit isotonic
    fit1 <- stats::isoreg(x1)
    fit2 <- stats::isoreg(x2)

    # Extract RSEM
    res1 <- sum(stats::residuals(fit1)^2)
    res2 <- sum(stats::residuals(fit2)^2)

    # Return
    res1 + res2
}

#' Shape statistic: Multimodality
#'
#' @param x numeric Rle vector: Coverage series.
#'
#' @return Numeric.
#' @examples
#' # See calcShape for usage examples
shapeMultimodality <- function(x) {
    # Convert from Rle
    x <- as.vector(x)

    # Isobreak regression for all breakpoints
    o <- vapply(X = seq_along(x), FUN = isobreak, FUN.VALUE = numeric(1), x = x)

    # Best solution
    o <- min(o)

    # Return
    o
}

#' @importFrom methods setClass setGeneric setMethod setRefClass
NULL
#' @import assertthat BiocGenerics S4Vectors IRanges Seqinfo GenomicRanges
#'   rtracklayer GenomicFeatures SummarizedExperiment Gviz
NULL

splitByStrand <- function(object) {
	split(object, strand(object))
}

splitPooled <- function(object){
	# Checks never done inside...

	# Split by strand
	o <- splitByStrand(object)

	# Calculate coverage
	o <- lapply(o, coverage, weight="score")

	# Round to handle floating point errors
	o <- lapply(o, round, digits=getOption("CAGEfightR.round"))

	# Return
	o
}

#### Helpers ####

# Check files series
checkFileSeries <- Vectorize(function(x){
    see_if(is.string(x),
              file.exists(x),
              is.readable(x))
})

# Quick extension checker
checkExtensions <- Vectorize(has_extension, vectorize.args="path")

# Bed to BigWig worker
bed2bw <- function(i, o_plus, o_minus, genome){
    # Checks done outside!

    # Attempt import
    message("Attempting to convert file: ", basename(i))
    gr <- import(i, genome=genome)

    # Check file
    tmp <- checkCTSSs(gr)

    # Split
    by_strand <- splitByStrand(gr)

    # Write to file
    export.bw(object=by_strand$`+`, con=o_plus, format="bw")
    export.bw(object=by_strand$`-`, con=o_minus, format="bw")

    # Return
    tmp
}

# Bed to bedgraph worker
bed2bg <- function(i, o_plus, o_minus){
    # Checks done outside!

    # Attempt import
    message("Attempting to convert file: ", basename(i))
    gr <- import(i)

    # Check file
    tmp <- checkCTSSs(gr)

    # Split
    by_strand <- splitByStrand(gr)

    # Write to file
    export.bedGraph(object=by_strand$`+`, con=o_plus, format="bedGraph")
    export.bedGraph(object=by_strand$`-`, con=o_minus, format="bedGraph")

    # Return
    tmp
}

# Bedgraph to BigWig worker
bg2bw <- function(i, o, genome){
    # Attempt import
    message("Attempting to convert file: ", basename(i))
    gr <- import(i, genome=genome)

    # Set dummy strand and check
    strand(gr) <- "+"
    tmp <- checkCTSSs(gr)

    # Write to file (won't use strand)
    export.bw(object=gr, con=o, format="bw")

    # Return
    tmp
}

# Bedgraph to BigWig worker
bw2bg <- function(i, o){
    # Attempt import
    message("Attempting to convert file: ", basename(i))
    gr <- import(i)

    # Set dummy strand and check
    strand(gr) <- "+"
    tmp <- checkCTSSs(gr)

    # Write to file (won't use strand)
    export.bedGraph(object=gr, con=o, format="bedGraph")

    # Return
    tmp
}

# BigWig/bedgraph to BED worker
bwg2bed <- function(i_plus, i_minus, o){
    # Attempt import of both strands
    message("Attempting to convert files: ",
            basename(i_plus), " & ", basename(i_minus))
    gr_plus <- import(i_plus)
    gr_minus <- import(i_minus)

    # Set strands
    strand(gr_plus) <- "+"
    strand(gr_minus) <- "-"

    # Merge and check
    gr <- c(gr_plus, gr_minus)
    tmp <- checkCTSSs(gr)

    # Write to file (won't use strand)
    export.bed(object=gr, con=o, format="bed")

    # Return
    tmp
}

#### Main ####

#' Convert GRanges with scores to GPos
#'
#' Converts a GRanges to a GPos, correctly expanding the score column. This is
#' useful is nearby CTSSs with the same count are grouped in the same range (see
#' example).
#'
#' @param object GRanges object with a score column
#'
#' @return GPos with score column
#' @export
#'
#' @examples
#' # Example GRanges
#' gr <- GRanges(Rle(c("chr2", "chr2", "chr3", "chr4")),
#'               IRanges(start=c(1, 10, 5, 3),
#'               end=c(5L, 10L, 5L, 4L)),
#'               strand="+",
#'               score=c(2, 1, 3, 11))
#'
#' # Expand to proper GPos / CTSS format:
#' gp <- convertGRanges2GPos(gr)
#'
#' # Double check that the total number of counts remains the same
#' stopifnot(sum(score(gr) * width(gr)) == sum(score(gp)))
convertGRanges2GPos <- function(object){
    # Pre-checks
    assert_that(methods::is(object, "GRanges"),
                isDisjoint(object),
                !is.null(score(object)),
                is.numeric(score(object)))

    # Convert to GPos and expand score
    o <- GPos(object)
    score(o) <- rep(score(object), width(object))

    # Return
    o
}

#' Convert CTSSs stored in different file formats.
#'
#' Collection of functions for converting CTSSs/CTSSs-like data stored in
#' BigWig, bedGraph or BED file formats. BigWig and bedGraph files use a file
#' for each strand, while BED-files stores both strands in a single file. As
#' BigWig files stores info about the chromosome lenghts, conversion from
#' bedGraph/BED to BigWig requires a genome. Note that CAGEfightR will only
#' import BigWig or bedGraph files!
#'
#' @note These functions will warn if input files do not have the correct
#'   extensions (.bw, .bedGraph, .bed), but otherwise simply pass input to
#'   rtracklayer::import. This makes them able to handle compressed files (like
#'   .gz). The same applies to the genome argument, which can also be the name
#'   of a UCSC genome.
#'
#' @param input charater: Path to input files holding CTSSs on both strands.
#' @param inputPlus character: Path to input files holding CTSSs on plus strand.
#' @param inputMinus character: Path to input files holding CTSSs on minus strand.
#' @param output charater: Path to output files holding CTSSs on both strands.
#' @param outputPlus character: Path to output files holding CTSSs on plus strand.
#' @param outputMinus character: Path to output files holding CTSSs on minus strand.
#' @param genome Seqinfo or character: Genome info passed to rtracklayer::import  (see note).
#'
#' @return TRUE returned invisibly if conversion(s) was succesful, otherwise an error is raised.
#' @export
#'
#' @examples
#' \dontrun{
#' # Find paths to BigWig files
#' data('exampleDesign')
#' bw_plus <- system.file('extdata', exampleDesign$BigWigPlus,
#'                        package = 'CAGEfightR')
#' bw_minus <- system.file('extdata', exampleDesign$BigWigMinus,
#'                         package = 'CAGEfightR')
#'
#' # Designate paths to new files
#' n_samples <- length(bw_plus)
#' beds <- replicate(n=n_samples, tempfile(fileext=".bed"))
#' bg_plus <- replicate(n=n_samples, tempfile(fileext="_plus.bedGraph"))
#' bg_minus <- replicate(n=n_samples, tempfile(fileext="_minus.bedGraph"))
#' conv_plus <- replicate(n=n_samples, tempfile(fileext="_plus.bw"))
#' conv_minus <- replicate(n=n_samples, tempfile(fileext="_minus.bw"))
#'
#' # Convert BigWig to BED
#' convertBigWig2BED(inputPlus=bw_plus,
#'                   inputMinus=bw_minus,
#'                   output=beds)
#'
#' # Convert BED to bedGraph
#' convertBED2BedGraph(input=beds,
#'                     outputPlus=bg_plus,
#'                     outputMinus=bg_minus)
#'
#' # Convert BED to bedGraph
#' mm9 <- SeqinfoForUCSCGenome("mm9")
#' convertBED2BigWig(input=beds,
#'                   outputPlus=conv_plus,
#'                   outputMinus=conv_minus,
#'                   genome=mm9)
#'
#' # Check it's still the same data
#' x <- import(bw_plus[1])
#' y <- import(bg_plus[1])
#' z <- import(conv_plus[1])
#' all(x == y)
#' all(x == z)
#' sum(score(x)) ==  sum(score(y))
#' sum(score(x)) ==  sum(score(z))
#' }
convertBED2BigWig <- function(input, outputPlus, outputMinus, genome){
    assert_that(all(checkFileSeries(input)),
                is.character(outputPlus),
                is.character(outputMinus),
                length(input) == length(outputPlus),
                length(input) == length(outputMinus))

    # Only give warn about improper  extensions
    input_exts <- all(checkExtensions(input, ext="bed"))
    outputPlus_exts <- all(checkExtensions(outputPlus, ext="bw"))
    outputMinus_exts <- all(checkExtensions(outputMinus, ext="bw"))

    if(!input_exts){
        warning("Input BED files do not all have the proper .bed extension! ",
                "Attempting import anyway...")
    }

    if(!outputPlus_exts | !outputMinus_exts){
        warning("Output BigWig files do not all have the proper .bw extension! ",
                "Attempting import anyway...")
    }

    # Check genome as well
    if(!methods::is(genome, "Seqinfo")){
        warning("Supplied genome is not a Seqinfo object! ",
                "Attempting import anyway...")
    }

    # Simply loop
    tmp <- BiocParallel::bpmapply(bed2bw,
                                  input,
                                  outputPlus,
                                  outputMinus,
                                  MoreArgs = list(genome = genome))

    # Return invisibly
    invisible(tmp)
}

#' @rdname convertBED2BigWig
#' @export
convertBED2BedGraph <- function(input, outputPlus, outputMinus){
    assert_that(all(checkFileSeries(input)),
                is.character(outputPlus),
                is.character(outputMinus),
                length(input) == length(outputPlus),
                length(input) == length(outputMinus))

    # Only give warn about improper  extensions
    input_exts <- all(checkExtensions(input, ext="bed"))
    outputPlus_exts <- all(checkExtensions(outputPlus, ext="bedGraph"))
    outputMinus_exts <- all(checkExtensions(outputMinus, ext="bedGraph"))

    if(!input_exts){
        warning("Input BED files do not all have the proper .bed extension! ",
                "Attempting import anyway...")
    }

    if(!outputPlus_exts | !outputMinus_exts){
        warning("Output bedGraph files do not all have the proper .bedGraph extension! ",
                "Attempting import anyway...")
    }

    # Simply loop
    tmp <- BiocParallel::bpmapply(bed2bg, input, outputPlus, outputMinus)

    # Return invisibly
    invisible(tmp)
}

#' @rdname convertBED2BigWig
#' @export
convertBedGraph2BigWig <- function(input, output, genome){
    assert_that(all(checkFileSeries(input)),
                is.character(output),
                length(input) == length(output))

    # Only give warn about improper  extensions
    input_exts <- all(checkExtensions(input, ext="bedgraph"))
    output_exts <- all(checkExtensions(output, ext="bw"))

    if(!input_exts){
        warning("Input bedGraph files do not all have the proper .bedGraph extension! ",
                "Attempting import anyway...")
    }

    if(!output_exts){
        warning("Output BigWig files do not all have the proper .bw extension! ",
                "Attempting import anyway...")
    }

    # Check genome as well
    if(!methods::is(genome, "Seqinfo")){
        warning("Supplied genome is not a Seqinfo object! ",
                "Attempting import anyway...")
    }


    # Simply loop
    tmp <-  BiocParallel::bpmapply(bg2bw,
                                   input,
                                   output,
                                   MoreArgs = list(genome = genome))

    # Return invisibly
    invisible(tmp)
}

#' @rdname convertBED2BigWig
#' @export
convertBigWig2BedGraph <- function(input, output){
    assert_that(all(checkFileSeries(input)),
                is.character(output),
                length(input) == length(output))

    # Only give warn about improper  extensions
    input_exts <- all(checkExtensions(input, ext="bw"))
    output_exts <- all(checkExtensions(output, ext="bedGraph"))

    if(!input_exts){
        warning("Input BigWig files do not all have the proper .bw extension! ",
                "Attempting import anyway...")
    }

    if(!output_exts){
        warning("Output bedGraph files do not all have the proper .bedGraph extension! ",
                "Attempting import anyway...")
    }

    # Simply loop
    tmp <-  BiocParallel::bpmapply(bw2bg,
                                   input,
                                   output)

    # Return invisibly
    invisible(tmp)
}

#' @rdname convertBED2BigWig
#' @export
convertBigWig2BED <- function(inputPlus, inputMinus, output){
    assert_that(all(checkFileSeries(inputPlus)),
                all(checkFileSeries(inputMinus)),
                is.character(output),
                length(inputPlus) == length(output),
                length(inputMinus) == length(output))

    # Only give warn about improper  extensions
    inputPlus_exts <- all(checkExtensions(inputPlus, ext="bw"))
    inputMinus_exts <- all(checkExtensions(inputMinus, ext="bw"))
    output_exts <- all(checkExtensions(output, ext="bed"))

    if(!inputPlus_exts | !inputMinus_exts){
        warning("Input BigWig files do not all have the proper .bw extension! ",
                "Attempting import anyway...")
    }

    if(!output_exts){
        warning("Output BED files do not all have the proper .bed extension! ",
                "Attempting import anyway...")
    }

    # Simply loop
    tmp <-  BiocParallel::bpmapply(bwg2bed,
                                   inputPlus,
                                   inputMinus,
                                   output)

    # Return invisibly
    invisible(tmp)
}

#' @rdname convertBED2BigWig
#' @export
convertBedGraph2BED <- function(inputPlus, inputMinus, output){
    assert_that(all(checkFileSeries(inputPlus)),
                all(checkFileSeries(inputMinus)),
                is.character(output),
                length(inputPlus) == length(output),
                length(inputMinus) == length(output))

    # Only give warn about improper  extensions
    inputPlus_exts <- all(checkExtensions(inputPlus, ext="bedGraph"))
    inputMinus_exts <- all(checkExtensions(inputMinus, ext="bedGraph"))
    output_exts <- all(checkExtensions(output, ext="bed"))

    if(!inputPlus_exts | !inputMinus_exts){
        warning("Input BigWig files do not all have the proper .bedGraph extension! ",
                "Attempting import anyway...")
    }

    if(!output_exts){
        warning("Output BED files do not all have the proper .bed extension! ",
                "Attempting import anyway...")
    }

    # Simply loop
    tmp <-  BiocParallel::bpmapply(bwg2bed,
                                   inputPlus,
                                   inputMinus,
                                   output)

    # Return invisibly
    invisible(tmp)
}

#' Example CAGE Data
#'
#' Subset of the CAGE dataset from the paper 'Identification of Gene
#' Transcription Start Sites and Enhancers Responding to Pulmonary Carbon
#' Nanotube Exposure in Vivo'. CTSS data from subsets of chr18 and chr19 across
#' 3 mouse (mm9 ) samples are included. Datasets can be loaded with the data
#' function.
#'
#' @format Example data from various stages of CAGEfightR: \describe{
#'   \item{exampleDesign}{DataFrame: Description of samples, including .bw
#'   filenames} \item{exampleCTSS}{RangedSummarizedExperiment: CTSSs}
#'   \item{exampleUnidirectional}{RangedSummarizedExperiment: Unidirectional or
#'   Tag Clusters}
#'   \item{exampleBidirectionalCluster}{RangedSummarizedExperiment:
#'   Bidirectional clusters} \item{exampleGenes}{RangedSummarizedExperiment:
#'   Genes} }
#' @source \url{http://pubs.acs.org/doi/abs/10.1021/acsnano.6b07533}
#' @examples
#' data(exampleDesign)
#' data(exampleCTSSs)
#' data(exampleUnidirectional)
#' data(exampleBidirectional)
#' data(exampleGenes)
"exampleDesign"

#' @rdname exampleDesign
"exampleCTSSs"

#' @rdname exampleDesign
"exampleUnidirectional"

#' @rdname exampleDesign
"exampleBidirectional"

#' @rdname exampleDesign
"exampleGenes"

#' Subset by support across samples
#'
#' A convienient wrapper around calcSupport and subset.
#'
#' @param object RangedSummarizedExperiment: CAGE data quantified at CTSS,
#'   cluster or gene-level.
#' @param inputAssay character: Name of assay holding input expression values.
#' @param outputColumn character: Name of column in rowRanges to hold support
#'   values.
#' @param unexpressed numeric: Support will be calculated based on features
#'   larger than this cutoff.
#' @param minSamples numeric: Only features with support in more than this
#'   number of samples will be kept.
#'
#' @return RangedSummarizedExperiment with support added as a column in
#'   rowRanges and features with less support than minSamples removed.
#'
#' @family Subsetting functions
#' @family Calculation functions
#'
#' @importClassesFrom Matrix dgCMatrix
#' @export
#' @examples
#' data(exampleBidirectional)
#'
#' # Keep clusters with at least one tag in two samples
#' subsetBySupport(exampleBidirectional)
#'
#' # Keep clusters with at least two tags in four samples
#' subsetBySupport(exampleBidirectional, unexpressed=1, minSamples=2)
subsetBySupport <- function(object, inputAssay = "counts", outputColumn = "support", 
    unexpressed = 0, minSamples = 1) {
    # Pre-checks
    assert_that(is.numeric(minSamples))
    
    # Call function
    message("Calculating support...")
    object <- calcSupport(object = object, inputAssay = inputAssay, outputColumn = outputColumn, 
        unexpressed = unexpressed)
    before <- nrow(object)
    
    # Subset
    message("Subsetting...")
    object <- object[rowData(object)[, outputColumn] > minSamples, ]
    after <- nrow(object)
    removed <- before - after
    
    # Print some info
    message("Removed ", removed, " out of ", before, " regions (", round(removed/before * 
        100, digits = 1), "%)")
    
    # Return
    object
}

#' Subset by composition across samples
#'
#' A convenient wrapper around calcComposition and subset.
#'
#' @param object RangedSummarizedExperiment: CAGE data quantified at CTSS,
#'   cluster or gene-level.
#' @param inputAssay character: Name of assay holding input expression values.
#' @param outputColumn character: Name of column in rowRanges to hold
#'   composition values.
#' @param unexpressed numeric: Composition will be calculated based on features
#'   larger than this cutoff.
#' @param genes character: Name of column in rowData holding genes (NAs are not
#'   allowed.)
#' @param minSamples numeric: Only features with composition in more than this
#'   number of samples will be kept.
#'
#' @return RangedSummarizedExperiment with composition values added as a column
#'   in rowData and features with less composition than minSamples removed.
#' @family Subsetting functions
#' @family Calculation functions
#'
#' @export
#' @examples
#' data(exampleUnidirectional)
#'
#' # Annotate clusters with geneIDs:
#' library(TxDb.Mmusculus.UCSC.mm9.knownGene)
#' txdb <- TxDb.Mmusculus.UCSC.mm9.knownGene
#'
#' exampleUnidirectional <- assignGeneID(exampleUnidirectional,
#'                                       geneModels=txdb,
#'                                       outputColumn='geneID')
#' exampleUnidirectional <- subset(exampleUnidirectional, !is.na(geneID))
#'
#' # Keep only clusters more than 10% in more than one sample:
#' calcComposition(exampleUnidirectional)
#'
#' # Keep only clusters more than 5% in more than 2 samples:
#' subsetByComposition(exampleUnidirectional, unexpressed = 0.05, minSamples=2)
subsetByComposition <- function(object, inputAssay = "counts", outputColumn = "composition", 
    unexpressed = 0.1, genes = "geneID", minSamples = 1) {
    # Pre-checks
    assert_that(is.numeric(minSamples))
    
    # Call function
    message("Calculating composition...")
    object <- calcComposition(object = object, inputAssay = inputAssay, outputColumn = outputColumn, 
        unexpressed = unexpressed, genes = genes)
    before <- nrow(object)
    
    # Subset
    message("Subsetting...")
    object <- object[rowData(object)[, outputColumn] > minSamples, ]
    after <- nrow(object)
    removed <- before - after
    
    # Print some info
    message("Removed ", removed, " out of ", before, " regions (", round(removed/before * 
        100, digits = 1), "%)")
    
    # Return
    object
}

symmetricPercentiles <- function(r, prop) {
    # Convert to normal vector
    r <- as.vector(r)

    # Calculate proportions
    r_sum <- sum(r)
    r_prop <- r/r_sum

    # Cumulate sum from either side
    f_cum <- cumsum(r_prop)
    r_cum <- rev(cumsum(rev(r_prop)))

    # Trim both sides
    half_prop <- prop/2
    left <- Position(function(x) x >= half_prop, f_cum, right = FALSE, nomatch = 1)
    right <- Position(function(x) x >= half_prop, r_cum, right = TRUE, nomatch = length(r))

    # Return range
    c(left, right)
}

asymmetricPercentiles <- function(r, prop) {
    # Convert to normal vector
    r <- as.vector(r)

    # Calculate proportions
    r_sum <- sum(r)
    r_prop <- r/r_sum

    # Sort be minimum cumsum from either side
    f_cum <- cumsum(r_prop)
    r_cum <- rev(cumsum(rev(r_prop)))
    min_cum <- pmin(f_cum, r_cum)
    o_cum <- order(min_cum)

    # Order original proportions and cut
    r_ord <- cumsum(r_prop[o_cum])
    left <- Position(function(x) x > prop, r_ord, right = FALSE, nomatch = 1)
    o_out <- o_cum[left:length(r_ord)]

    # Return range
    range(o_out)
}

#' Trim width of TCs to expression percentiles
#'
#' Given a set of TCs and genome-wide CTSS coverage, reduce the width of TC
#' until a certain amount of expression has been removed.
#'
#' @param object GenomicRanges or RangedSummarizedExperiment: TCs to be trimmed.
#' @param pooled GenomicRanges or RangedSummarizedExperiment: CTSS coverage.
#' @param percentile numeric: Fraction of expression to remove from TCs.
#' @param symmetric logical: Whether to trim the same amount from both edges of
#'   the TC (TRUE) or always trim from the least expressed end (FALSE).
#' @param ... additional arguments passed to methods.
#'
#' @return GRanges with trimmed TCs, including recalculated peaks and scores.
#' @family Clustering functions
#' @family Trimming functions
#' @export
#' @examples
#' data(exampleCTSSs)
#' data(exampleBidirectional)
#'
#' # Calculate pooled CTSSs
#' exampleCTSSs <- calcTPM(exampleCTSSs, totalTags='totalTags')
#' exampleCTSSs <- calcPooled(exampleCTSSs)
#'
#' # Choose a few wide clusters:
#' TCs <- subset(exampleUnidirectional, width >= 100)
#'
#' # Symmetric trimming (same percentage from each side):
#' TCs_sym <- trimToPercentiles(TCs, pooled=exampleCTSSs, symmetric=FALSE)
#'
#' # Assymmetric trimming (always trim from lowest side):
#' TCs_asym <- trimToPercentiles(TCs, pooled=exampleCTSSs, symmetric=TRUE)
#'
#' # Compare the two results sets of widths:
#' summary(width(TCs_sym) - width(TCs_asym))
setGeneric("trimToPercentiles", function(object, pooled, ...) {
    standardGeneric("trimToPercentiles")
})

#' @rdname trimToPercentiles
setMethod("trimToPercentiles", signature(object = "GRanges", pooled = "GRanges"),
    function(object, pooled, percentile = 0.1, symmetric = FALSE) {
        # Pre-checks
        assert_that(checkPooled(pooled),
                    percentile > 0 & percentile <= 1,
                    is.logical(symmetric),
                    identical(seqlengths(object), seqlengths(pooled)))

        # Split by strand
        message("Splitting by strand...")
        covByStrand <- splitPooled(pooled)
        TCsByStrand <- splitByStrand(object)

        # coverage_stranded <- splitByStrand(pooled)
        # coverage_plus <- coverage(coverage_stranded$`+`, weight = "score")
        # coverage_minus <- coverage(coverage_stranded$`-`, weight = "score")
        # tcs_stranded <- splitByStrand(object)
        # rm(coverage_stranded)

        # Convert to IRangesList
        irl_plus <- methods::as(TCsByStrand$`+`,'IRangesList')
        irl_minus <- methods::as(TCsByStrand$`-`,'IRangesList')

        # Tempoary workwaround
        # irl_plus <- split(ranges(tcs_stranded$`+`), seqnames(tcs_stranded$`+`))
        # irl_minus <- split(ranges(tcs_stranded$`-`), seqnames(tcs_stranded$`-`))
        # rm(tcs_stranded)

        # Obtain views
        # views_plus <- Views(coverage_plus, irl_plus)
        # views_minus <- Views(coverage_minus, irl_minus)

        # Views
        views_plus <- Views(covByStrand$`+`, irl_plus)
        views_minus <- Views(covByStrand$`-`, irl_minus)

        # Extract Adjustments
        if (symmetric) {
            message(paste0("Symmetric trimming to percentile: ",
                           percentile * 100, "%"))
            adjust_plus <- viewApply(views_plus, symmetricPercentiles,
                                     prop = percentile, simplify = FALSE)
            adjust_minus <- viewApply(views_minus, symmetricPercentiles,
                                      prop = percentile, simplify = FALSE)
        } else if (!symmetric) {
            message(paste0("Asymmetric trimming to percentile: ",
                           percentile * 100, "%"))
            adjust_plus <- viewApply(views_plus, asymmetricPercentiles,
                                     prop = percentile, simplify = FALSE)
            adjust_minus <- viewApply(views_minus, asymmetricPercentiles,
                                      prop = percentile, simplify = FALSE)
        } else {
            stop("Additional percentile functions not yet implemented!")
        }
        rm(views_plus, views_minus)

        # Adjustments as IntegerLists
        message("Adjusting ranges...")
        left_plus <- methods::as(lapply(adjust_plus, function(x) lapply(x, function(x) x[1])),
            "IntegerList")
        right_plus <- methods::as(lapply(adjust_plus, function(x) lapply(x, function(x) x[2])),
            "IntegerList")
        left_minus <- methods::as(lapply(adjust_minus, function(x) lapply(x, function(x) x[1])),
            "IntegerList")
        right_minus <- methods::as(lapply(adjust_minus, function(x) lapply(x, function(x) x[2])),
            "IntegerList")

        # Narrow ranges
        irl_plus <- narrow(irl_plus, start = left_plus, end = right_plus)
        irl_minus <- narrow(irl_minus, start = left_minus, end = right_minus)
        rm(left_plus, right_plus, left_minus, right_minus)

        # Calculate new stats
        message("Calculating new stats...")
        trimmedTCs <- TCstats(coverage_plus = covByStrand$`+`,
                              coverage_minus = covByStrand$`-`,
                              tcs_plus = irl_plus,
                              tcs_minus = irl_minus)
        rm(covByStrand, irl_plus, irl_minus)

        # Carry over seqinfo and sort
        message("Preparing output...")
        seqinfo(trimmedTCs) <- seqinfo(object)
        trimmedTCs <- sort(trimmedTCs)

        # Print some basic stats
        message("Tag clustering summary:")
        summarizeWidths(trimmedTCs)

        # Return
        trimmedTCs
    })

#' @rdname trimToPercentiles
setMethod("trimToPercentiles", signature(object = "GRanges", pooled = "GPos"),
          function(object, pooled, ...) {
              trimToPercentiles(object, methods::as(pooled, "GRanges"), ...)
          })

#' @rdname trimToPercentiles
setMethod("trimToPercentiles", signature(object = "RangedSummarizedExperiment", pooled = "GenomicRanges"),
    function(object, pooled, ...) {
        trimToPercentiles(rowRanges(object), pooled, ...)
    })

#' @rdname trimToPercentiles
setMethod("trimToPercentiles", signature(object = "GRanges", pooled = "RangedSummarizedExperiment"),
    function(object, pooled, ...) {
        trimToPercentiles(object, rowRanges(pooled), ...)
    })

#' @rdname trimToPercentiles
setMethod("trimToPercentiles", signature(object = "RangedSummarizedExperiment", pooled = "RangedSummarizedExperiment"),
    function(object, pooled, ...) {
        trimToPercentiles(rowRanges(object), rowRanges(pooled), ...)
    })

#' Trim width of TCs by distance from TC peak
#'
#' Trim the width of TCs by distance from the TC peaks.
#'
#' @param object GenomicRanges or RangedSummarizedExperiment: Tag clusters.
#' @param pooled GenomicRanges or RangedSummarizedExperiment: Basepair-wise
#'   pooled CTSS (stored in the score column).
#' @param upstream integer: Maximum upstream distance from TC peak.
#' @param downstream integer: Maximum downstream distance from TC peak.
#' @param ... additional arguments passed to methods.
#'
#' @return data.frame with two columns: threshold and nTCs (number of Tag
#'   Clusters)
#' @family Clustering functions
#' @family Trimming functions
#' @export
#' @examples
#' data(exampleCTSSs)
#' data(exampleBidirectional)
#'
#' # Calculate pooled CTSSs
#' exampleCTSSs <- calcTPM(exampleCTSSs, totalTags='totalTags')
#' exampleCTSSs <- calcPooled(exampleCTSSs)
#'
#' # Choose a few wide clusters:
#' TCs <- subset(exampleUnidirectional, width >= 100)
#'
#' # Trim to +/- 10 bp of TC peak
#' trimToPeak(TCs, pooled=exampleCTSSs, upstream=10, downstream=10)
setGeneric("trimToPeak", function(object, pooled, ...) {
    standardGeneric("trimToPeak")
})

#' @rdname trimToPeak
setMethod("trimToPeak", signature(object = "GRanges", pooled = "GRanges"),
    function(object, pooled, upstream, downstream) {
        # Pre-Checks
        assert_that(checkPeaked(object),
                    checkPooled(pooled),
                    is.count(upstream),
                    is.count(downstream),
                    identical(seqlengths(object), seqlengths(pooled)))

        # Extract peaks
        message("Trimming TCs around peaks...")
        peaks <- swapRanges(object)

        # Expand peaks
        expanded <- promoters(peaks,
                              upstream = upstream,
                              downstream = downstream)

        # Intersect to obtain filtered peaks.
        ranges(peaks) <- pintersect(ranges(object), ranges(expanded))

        # Split by strand
        message("Splitting by strand...")
        covByStrand <- splitPooled(pooled)
        TCsByStrand <- splitByStrand(peaks)

         # coverage_stranded <- splitByStrand(pooled)
        # coverage_plus <- coverage(coverage_stranded$`+`, weight = "score")
        # coverage_minus <- coverage(coverage_stranded$`-`, weight = "score")
        # tcs_stranded <- splitByStrand(peaks)
        # rm(coverage_stranded, peaks)

        # Convert to IRangesList
        irl_plus <- methods::as(TCsByStrand$`+`,'IRangesList')
        irl_minus <- methods::as(TCsByStrand$`-`,'IRangesList')
        rm(TCsByStrand)

        # irl_plus <- split(ranges(tcs_stranded$`+`), seqnames(tcs_stranded$`+`))
        # irl_minus <- split(ranges(tcs_stranded$`-`), seqnames(tcs_stranded$`-`))
        # rm(tcs_stranded)

        # Calculate new stats
        message("Calculating new stats...")
        trimmedTCs <- TCstats(coverage_plus = covByStrand$`+`,
                              coverage_minus = covByStrand$`-`,
                              tcs_plus = irl_plus,
                              tcs_minus = irl_minus)
        rm(covByStrand, irl_plus, irl_minus)

        # Carry over seqinfo and sort
        message("Preparing output...")
        seqinfo(trimmedTCs) <- seqinfo(object)
        trimmedTCs <- sort(trimmedTCs)

        # Print some basic stats
        message("Tag clustering summary:")
        summarizeWidths(trimmedTCs)

        # Return
        trimmedTCs
    })

#' @rdname trimToPeak
setMethod("trimToPeak", signature(object = "GRanges", pooled = "GPos"),
          function(object, pooled, ...) {
              trimToPeak(object, methods::as(pooled, "GRanges"), ...)
          })

#' @rdname trimToPeak
setMethod("trimToPeak", signature(object = "RangedSummarizedExperiment", pooled = "GenomicRanges"),
    function(object, pooled, ...) {
        trimToPeak(rowRanges(object), pooled, ...)
    })

#' @rdname trimToPeak
setMethod("trimToPeak", signature(object = "GRanges", pooled = "RangedSummarizedExperiment"),
    function(object, pooled, ...) {
        trimToPeak(object, rowRanges(pooled), ...)
    })

#' @rdname trimToPeak
setMethod("trimToPeak", signature(object = "RangedSummarizedExperiment", pooled = "RangedSummarizedExperiment"),
    function(object, pooled, ...) {
        trimToPeak(rowRanges(object), rowRanges(pooled), ...)
    })

#' Calculate support of CAGE data.
#'
#' Calculate the number of samples expression a feature above a certain level.
#' This number is refered to as the 'support'.
#'
#' @param object RangedSummarizedExperiment: CAGE data quantified at CTSS,
#'   cluster or gene-level.
#' @param inputAssay character: Name of assay holding input expression values.
#' @param outputColumn character: Name of column in rowRanges to hold support
#'   values.
#' @param unexpressed numeric: Support will be calculated based on features
#'   larger than this cutoff.
#'
#' @importClassesFrom Matrix dgCMatrix
#' @return object with support added as a column in rowRanges.
#' @family Calculation functions
#' @export
#' @examples
#' data(exampleUnidirectional)
#'
#' # Count samples with at at least a single tags
#' exampleUnidirectional <- calcSupport(exampleUnidirectional,
#'                                      inputAssay='counts',
#'                                      unexpressed=0)
#'
#' # Count number of samples with more than 1 TPM and save as a new column.
#' exampleUnidirectional <- calcTPM(exampleUnidirectional,
#'                                  totalTags = 'totalTags')
#' exampleUnidirectional <- calcSupport(exampleUnidirectional,
#'                                      inputAssay='TPM',
#'                                      unexpressed=1,
#'                                      outputColumn='TPMsupport')
calcSupport <- function(object, inputAssay = "counts", outputColumn = "support",
    unexpressed = 0) {
    # Prechecks
    assert_that(methods::is(object, "SummarizedExperiment"), is.string(inputAssay),
        inputAssay %in% assayNames(object), is.string(outputColumn), is.number(unexpressed))

    if (outputColumn %in% colnames(rowData(object))) {
        warning("object already has a column named ", outputColumn, " in rowData: It will be overwritten!")
    }

    # Calculate support
    rowData(object)[, outputColumn] <- as.integer(Matrix::rowSums(assay(object, inputAssay) >
        unexpressed))

    # Return
    object
}

#' Calculate the total number of CAGE tags across samples.
#'
#' For each CAGE library, calculate the total number of tags.
#'
#' @param object RangedSummarizedExperiment: CAGE data quantified at CTSS,
#'   cluster or gene-level.
#' @param inputAssay character: Name of assay holding input expression values.
#' @param outputColumn character: Name of column in colData to hold number of
#'   total tags.
#'
#' @importClassesFrom Matrix dgCMatrix
#' @return object with total tags per library added as a column in
#'   colData.
#' @family Calculation functions
#' @export
#' @examples
#' data(exampleUnidirectional)
#' calcTotalTags(exampleUnidirectional)
calcTotalTags <- function(object, inputAssay = "counts", outputColumn = "totalTags") {
    # Prechecks
    assert_that(methods::is(object, "RangedSummarizedExperiment"),
    						not_empty(object),
    						inputAssay %in% assayNames(object),
    						is.string(inputAssay),
    						is.string(outputColumn))

    if (outputColumn %in% colnames(colData(object))) {
        warning("object already has a column named ", outputColumn, " in colData: It will be overwritten!")
    }

    # Calculate colSums
    colData(object)[, outputColumn] <- Matrix::colSums(assay(object, inputAssay))

    # Return
    object
}

#' Calculate CAGE Tags-Per-Million (TPM)
#'
#' Normalize CAGE-tag counts into TPM values.
#'
#' @param object RangedSummarizedExperiment: CAGE data quantified at CTSS,
#'   cluster or gene-level.
#' @param inputAssay character: Name of assay holding input expression values.
#' @param outputAssay character: Name of assay to hold TPM values.
#' @param totalTags character or NULL: Column in colData holding the total
#'   number of tags for each samples. If NULL, this will be calculated using
#'   calcTotalTags.
#' @param outputColumn character: Name of column in colData to hold number of
#'   total tags, only used if totalTags is NULL.
#'
#' @return object with TPM-values added as a new assay. If totalTags is NULL,
#'   total tags added as a column in colData.
#' @family Calculation functions
#'
#' @importClassesFrom Matrix dgCMatrix
#' @export
#' @examples
#' data(exampleUnidirectional)
#'
#' # Calculate TPM:
#' calcTPM(exampleUnidirectional)
#'
#' # Use pre-calculated total number of tags:
#' calcTPM(exampleUnidirectional,
#'         outputAssay='TPMsupplied',
#'         totalTags='totalTags')
calcTPM <- function(object, inputAssay = "counts", outputAssay = "TPM", totalTags = NULL,
    outputColumn = "totalTags") {
    # Prechecks
    assert_that(methods::is(object, "RangedSummarizedExperiment"),
    						not_empty(object),
    						is.string(inputAssay),
    						inputAssay %in% assayNames(object),
    						is.string(outputAssay))

    if (is.null(totalTags)) {
        message("Calculating library sizes...")
        object <- calcTotalTags(object = object, inputAssay = inputAssay, outputColumn = outputColumn)
        totalTags <- outputColumn
    } else if (is.string(totalTags)) {
        message("Using supplied library sizes...")
        assert_that(totalTags %in% colnames(colData(object)), is.numeric(colData(object)[,
            totalTags]), all(colData(object)[, totalTags] >= 0))
    } else {
        stop("totalTags should NULL or a column in colData!")
    }

    if (outputAssay %in% assayNames(object)) {
        warning("object already has an assay named ", outputAssay, ": It will be overwritten!")
    }

    # Scale counts to TPM
    message("Calculating TPM...")
    assay(object, outputAssay) <- Matrix::t(Matrix::t(assay(object, inputAssay))/(colData(object)[,
        totalTags]/1000000))

    # Return
    object
}

#' Calculate pooled expression across all samples.
#'
#' Sum expression of features across all samples to obtain a 'pooled' signal.
#'
#' @param object RangedSummarizedExperiment: CAGE data quantified at CTSS,
#'   cluster or gene-level.
#' @param inputAssay character: Name of assay holding input expression values.
#' @param outputColumn character: Name of column in rowRanges to hold pooled
#'   expression.
#'
#' @importClassesFrom Matrix dgCMatrix
#' @return object with pooled expression added as a column
#'   in rowRanges.
#' @family Calculation functions
#' @export
#' @examples
#' data(exampleCTSSs)
#'
#' # Calculate TPM using supplied total number of tags:
#' exampleCTSSs <- calcTPM(exampleCTSSs, totalTags='totalTags')
#'
#' # Sum TPM values over samples:
#' calcPooled(exampleCTSSs)
calcPooled <- function(object, inputAssay = "TPM", outputColumn = "score") {
    # Prechecks
    assert_that(methods::is(object, "RangedSummarizedExperiment"),
    						not_empty(object),
    						is.string(inputAssay),
    						inputAssay %in% assayNames(object),
    						is.string(outputColumn))

    if (outputColumn %in% colnames(rowData(object))) {
        warning("object already has a column named ", outputColumn, " in rowData: It will be overwritten!")
    }

    # Calculate colSums
    rowData(object)[, outputColumn] <- Matrix::rowSums(assay(object, inputAssay))

    # Return
    object
}

#' Calculate composition of CAGE data.
#'
#' For every feature, count in how many samples it is expressed above a certain
#' fraction (e.g. 10 percent) within a grouping, usually genes. This count is
#' refered to as the 'composition' value.
#'
#' @param object RangedSummarizedExperiment: CAGE data quantified at CTSS,
#'   cluster or gene-level.
#' @param inputAssay character: Name of assay holding input expression values.
#' @param outputColumn character: Name of column in rowRanges to hold
#'   composition values.
#' @param unexpressed numeric: Composition will be calculated based on features
#'   larger than this cutoff.
#' @param genes character: Name of column in rowData holding genes (NAs are not
#'   currently allowed.)
#'
#' @return object with composition added as a column in rowData.
#' @family Calculation functions
#' @export
#' @examples
#' data(exampleUnidirectional)
#'
#' # Annotate clusters with geneIDs:
#' library(TxDb.Mmusculus.UCSC.mm9.knownGene)
#' txdb <- TxDb.Mmusculus.UCSC.mm9.knownGene
#' exampleUnidirectional <- assignGeneID(exampleUnidirectional,
#'                                       geneModels=txdb,
#'                                       outputColumn='geneID',
#'                                       swap='thick')
#'
#' # Calculate composition values:
#' exampleUnidirectional <- subset(exampleUnidirectional, !is.na(geneID))
#' calcComposition(exampleUnidirectional)
#'
#' # Use a lower threshold
#' calcComposition(exampleUnidirectional,
#'                 unexpressed=0.05,
#'                 outputColumn='lenientComposition')
calcComposition <- function(object, inputAssay = "counts", outputColumn = "composition",
    unexpressed = 0.1, genes = "geneID") {
    assert_that(methods::is(object, "SummarizedExperiment"), is.string(inputAssay),
        inputAssay %in% assayNames(object), is.string(outputColumn), is.number(unexpressed),
        unexpressed >= 0 & unexpressed <= 1, is.string(genes), is.element(genes,
            colnames(rowData(object))), is.character(rowData(object)[, genes]), noNA(rowData(object)[,
            genes]))

    if (outputColumn %in% colnames(rowData(object))) {
        warning("object already has a column named ", outputColumn, " in rowData: It will be overwritten!")
    }

    # Extract gene-wise matrices
    L <- splitAsList(x = assay(object, inputAssay), f = rowData(object)[, genes],
        drop = FALSE)

    # Scale and find high compositions Note: Scale always coerces to a base::matrix!
    L <- endoapply(L, function(x) scale(x, center = FALSE, scale = Matrix::colSums(x)) >
        unexpressed)

    # Calculate count high compositions
    L <- endoapply(L, rowSums, na.rm = TRUE)

    # Back to integer vector
    L <- unsplit(L, f = rowData(object)[, genes], drop = FALSE)
    L <- as.integer(L)

    # Post-checks
    stopifnot(length(L) == nrow(object), noNA(L))

    # Append
    rowData(object)[, outputColumn] <- L

    # Return
    object
}

#### Mappers ####

bg_mapper <- function(file, seqinfo, strand = "*"){
    # Import
    o <- import.bedGraph(file, genome=seqinfo)

    # Instead of conversion, stop if not proper CTSSs-like
    stopifnot(all(width(o) == 1))
    # o <- as(o, "StitchedGPos")
    # score(o) <- as.integer(score(o))

    # Set strand
    strand(o) <- strand

    # Return
    o
}

bw_mapper <- function(range, file, seqinfo, strand = "*"){
  # Prune levels
  pruned <- range
  seqlevels(pruned, pruning.mode = "coarse") <- seqlevels(file)

  # Check if there is nothing to import
  if(length(pruned) == 0){
    o <- GRanges(seqinfo=seqinfo)
    score(o) <- numeric()
  }else{
    # Import
    o <- import.bw(con=file,
                   format="bigwig",
                   which=pruned,
                   as="GRanges")

    # Instead of conversion, stop if not proper CTSSs-like
    stopifnot(all(width(o) == 1))

    # Force seqlevels and strand
    seqlevels(o) <- seqlevels(seqinfo)
    seqinfo(o) <- seqinfo
    strand(o) <- strand
  }

  # Return
  o
}

bw_mapper2 <- function(range, file, seqinfo, strand = "*"){
    # Import
    o <- suppressWarnings(import.bw(con=file,
                                    format="bigwig",
                                    which=range,
                                    as="GRanges"))

    # Instead of conversion, stop if not proper CTSSs-like
    stopifnot(all(width(o) == 1))
    # o <- as(o, "StitchedGPos")
    # score(o) <- as.integer(score(o)) # Not used by dgC anyway

    # Force seqlevels and strand
    seqlevels(o) <- seqlevels(seqinfo)
    seqinfo(o) <- seqinfo
    strand(o) <- strand

    # Return
    o
}

#### Reducers ####

gf_reducer2 <- function(mapped){
    # Make table of j = sample indicies
    o <- unlist(GRangesList(mapped), use.names=FALSE)
    o$j <- rep(seq_along(mapped), elementNROWS(mapped))

    # Find unique sites
    unique_pos <- granges(o)
    unique_pos <- unique(unique_pos)
    unique_pos <- sort(unique_pos)

    # Overlap to get i = position indices
    o$i <- match(o, unique_pos)

    # Determine the shape of the sparse matrix
    mat_dim <- c(length(unique_pos), length(mapped))
    mat_names <- list(NULL, names(mapped))

    # Build sparse matrix
    if (length(o) > 0) {
      o <- Matrix::sparseMatrix(i = o$i,
                                     j = o$j,
                                     x = score(o),
                                     dims = mat_dim,
                                     dimnames = mat_names)
    } else {
      # Simply create an empty matrix
      o <- Matrix::sparseMatrix(i = integer(0),
                                j = integer(0),
                                x = integer(0),
                                dims = c(0, mat_dim[2]),
                                dimnames = mat_names)
    }

    # # Simplify so sparse matrix encoding
    # indices <- as.matrix(mcols(indices)[,c("i", "j", "score")])
    # rle_dim <- c(length(unique_pos), length(mapped))
    # o <- indices[,1:2]
    # o <- SparseArraySeed(dim=rle_dim,
    #                      aind=o,
    #                      nzdata=indices[,3])
    #
    # # To DataFrame of Rles via RleMatrix
    # # o <- as(o, "RleMatrix")
    # o <- DelayedArray(o)
    # o <- as(o, "DataFrame")

    # Build RSE
    o <- SummarizedExperiment(assays=list(counts=o),
                              rowRanges=unique_pos)
    colnames(o) <- names(mapped)

    # Return
    o
}

gf_wrapper2 <- function(files, ranges, seqinfo, strand) {
    # Run GenomicFiles
    o <- GenomicFiles::reduceByRange(ranges = ranges,
                                     files = files,
                                     MAP = pryr::partial(bw_mapper,
                                                         seqinfo = seqinfo,
                                                         strand = strand),
                                     REDUCE = gf_reducer2,
                                     iterate = FALSE)

    # Merge output
    #message("Attempting to bind chunks...")
    o <- do.call(rbind, o)

    # Return
    o
}

#### Other helpers ####

setGeneric("cleanDesign", function(design, SampleIDs) {
    standardGeneric("cleanDesign")
})

setMethod("cleanDesign", signature(design = "NULL"), function(design, SampleIDs) {
    DataFrame(row.names = SampleIDs)
})

setMethod("cleanDesign", signature(design = "DataFrame"), function(design, SampleIDs) {
    assert_that(nrow(design) == length(SampleIDs),
                all(rownames(design) == SampleIDs))
    design
})

setMethod("cleanDesign", signature(design = "data.frame"), function(design, SampleIDs) {
    assert_that(nrow(design) == length(SampleIDs),
                all(rownames(design) == SampleIDs))
    methods::as(design, "DataFrame")
})

setMethod("cleanDesign", signature(design = "ANY"), function(design, SampleIDs) {
    stop("design must either NULL or a DataFrame-/data.frame-object!")
})

# pseudoSparsity <- function(x){
#     stopifnot(methods::is(x, "DataFrame"))
#
#     # Find non-zero
#     o <- vapply(X=x,
#                 FUN=function(x) sum(x == 0),
#                 FUN.VALUE=integer(1))
#
#     # Calc sparsity
#     o <- sum(o) / (ncol(x) * nrow(x))
#
#     # Return
#     o
# }

# clean_design <- function(ids, design=NULL){
#     # Decide what to
#     if (is.null(design)) {
#         design <- DataFrame(row.names = ids)
#     } else if (methods::is(design, "DataFrame")) {
#         assert_that(all(rownames(design) == ids))
#     } else if (is.data.frame(design)) {
#         assert_that(all(rownames(design) == ids))
#         design <- methods::as(design, "DataFrame")
#     } else {
#         stop("design must either NULL or a DataFrame-/data.frame-object!")
#     }
#
#     # Return
# }

#### Main function ####

#' Quantify CAGE Transcriptions Start Sites (CTSSs)
#'
#' This function reads in CTSS count data from a series of BigWig-files (or bedGraph-files) and
#' returns a CTSS-by-library count matrix. For efficient processing, the count
#' matrix is stored as a sparse matrix (dgCMatrix from the Matrix package), and CTSSs are compressed to a GPos object if possible.
#'
#' @param plusStrand BigWigFileList or character: BigWig/bedGraph files with plus-strand CTSS data.
#' @param minusStrand BigWigFileList or character: BigWig/bedGraph files with minus-strand CTSS data.
#' @param design DataFrame or data.frame: Additional information on samples which will be added to the ouput
#' @param genome Seqinfo: Genome information. If NULL the smallest common genome
#'   will be found using bwCommonGenome when BigWig-files are analyzed.
#' @param nTiles integer: Number of genomic tiles to parallelize over.
#' @param ... additional arguments passed to methods.
#'
#' @return RangedSummarizedExperiment, where assay is a sparse matrix
#'   (dgCMatrix) of CTSS counts and design stored in colData.
#' @family Quantification functions
#' @importClassesFrom Matrix dgCMatrix
#' @export
#' @examples
#' \dontrun{
#' # Load the example data
#' data('exampleDesign')
#' # Use the BigWig-files included with the package:
#' bw_plus <- system.file('extdata', exampleDesign$BigWigPlus,
#'                        package = 'CAGEfightR')
#' bw_minus <- system.file('extdata', exampleDesign$BigWigMinus,
#'                         package = 'CAGEfightR')
#'
#' # Create two named BigWigFileList-objects:
#' bw_plus <- BigWigFileList(bw_plus)
#' bw_minus <- BigWigFileList(bw_minus)
#' names(bw_plus) <- exampleDesign$Name
#' names(bw_minus) <- exampleDesign$Name
#'
#' # Quantify CTSSs, by default this will use the smallest common genome:
#' CTSSs <- quantifyCTSSs(plusStrand=bw_plus,
#'                        minusStrand=bw_minus,
#'                        design=exampleDesign)
#'
#' # Alternatively, a genome can be specified:
#' si <- seqinfo(bw_plus[[1]])
#' si <- si['chr18']
#' CTSSs_subset <- quantifyCTSSs(plusStrand=bw_plus,
#'                        minusStrand=bw_minus,
#'                        design=exampleDesign,
#'                        genome=si)
#'
#' # Quantification can be speed up by using multiple cores:
#' library(BiocParallel)
#' register(MulticoreParam(workers=3))
#' CTSSs_subset <- quantifyCTSSs(plusStrand=bw_plus,
#'                        minusStrand=bw_minus,
#'                        design=exampleDesign,
#'                        genome=si)
#'
#' # CAGEfightR also support bedGraph files, first BigWig is converted
#' bg_plus <- replicate(n=length(bw_plus), tempfile(fileext="_plus.bedGraph"))
#' bg_minus <- replicate(n=length(bw_minus), tempfile(fileext="_minus.bedGraph"))
#' names(bg_plus) <- names(bw_plus)
#' names(bg_minus) <- names(bw_minus)
#'
#' convertBigWig2BedGraph(input=sapply(bw_plus, resource), output=bg_plus)
#' convertBigWig2BedGraph(input=sapply(bw_minus, resource), output=bg_minus)
#'
#' # Then analyze: Note a genome MUST be supplied here!
#' si <- bwCommonGenome(bw_plus, bw_minus)
#' CTSSs_via_bg <- quantifyCTSSs(plusStrand=bg_plus,
#'                         minusStrand=bg_minus,
#'                         design=exampleDesign,
#'                         genome=si)
#'
#' # Confirm that the two approaches yield the same results
#' all(assay(CTSSs_via_bg) == assay(CTSSs))
#' }
setGeneric("quantifyCTSSs", function(plusStrand, minusStrand, design=NULL, genome=NULL, ...) {
    standardGeneric("quantifyCTSSs")
})

#' @rdname quantifyCTSSs
#' @export
setMethod("quantifyCTSSs",
          signature(plusStrand = "BigWigFileList",
                    minusStrand = "BigWigFileList"),
  function(plusStrand, minusStrand, design=NULL, genome=NULL, nTiles=1L) {
      # Pre-checks
      assert_that(length(plusStrand) == length(minusStrand),
                  bwValid(plusStrand),
                  bwValid(minusStrand),
                  !is.null(names(plusStrand)),
                  !is.null(names(minusStrand)),
                  all(names(plusStrand) == names(minusStrand)),
                  is.count(nTiles))

      # Set design
      message("Checking design...")
      design <- cleanDesign(design, SampleIDs=names(plusStrand))

      # Aquire seqinfo if missing.
      if (is.null(genome)) {
          message("Finding common genome...")
          genome <- bwCommonGenome(plusStrand, minusStrand, method = "intersect")
      } else if (methods::is(genome, "Seqinfo")) {
          message("Checking supplied genome compatibility...")
          bwGenomeCompatibility(plusStrand, minusStrand, genome)
      } else {
          stop("genome must either NULL or a Seqinfo-object!")
      }

      # Setup tiles and workers
      grl <- tileGenome(genome, ntile=nTiles)
      n_workers <- BiocParallel::bpworkers()
      n_workers <- ifelse(is.numeric(n_workers), n_workers, 1)

      message("Iterating over ", length(grl),
              " genomic tiles in ", length(plusStrand),
              " samples using ", n_workers, " worker(s)...")

      # Load data
      message("Importing CTSSs from plus strand...")
      plus_strand <- gf_wrapper2(files = plusStrand,
                                 ranges = grl,
                                 seqinfo = genome,
                                 strand = "+")

      message("Importing CTSSs from minus strand...")
      minus_strand <- gf_wrapper2(files = minusStrand,
                                  ranges = grl,
                                  seqinfo = genome,
                                  strand = "-")

      # Merge and format
      message("Merging strands...")
      o <- rbind(plus_strand, minus_strand)
      rm(plus_strand, minus_strand)

      # Attach design
      colData(o) <- design

      message("Formatting output...")
      # Calculate sparsity before seed
      zero_frac <- 1 - (Matrix::nnzero(assay(o)) / length(assay(o)))

      # Wrap in DelayedArray
      #assay(o) <- DelayedArray(assay(o))

      # Convert to GPos if possible:
      if(length(o) < .Machine$integer.max){
        rowRanges(o) <- methods::as(rowRanges(o), "StitchedGPos")
      }

      # Attach design

      # Sparsity
      #  Convert to appropriate seed
      # message("Formatting to specified seed...")
      # if(seed == "DataFrame"){
      #   assays(o) <- List(counts=DelayedArray(assay(o)))
      # }else if(seed == "dgCMatrix"){
      #   assays(o) <- List(counts=DelayedArray(assay(o)))
      #   assay(o) <- DelayedArray(as(assay(o), "dgCMatrix"))
      # }else if(seed == "RleMatrix"){
      #   assays(o) <- List(counts=RleArray(assay(o))) # Chunk by column
      # }else if(seed == "RleMatrix2"){
      #   assays(o) <- List(counts=as(assay(o), "RleMatrix")) # High compression
      # }else if(seed == "SparseArraySeed"){
      #   assays(o) <- List(counts=DelayedArray(assay(o)))
      #   assay(o) <- DelayedArray(as(assay(o), "SparseArraySeed"))
      # }else{
      #   warning("Did not wrap seed in DelayedArray!")
      # }

      # Calculate sparsity
      #pseudo_sparsity <- pseudoSparsity(assay(o))

      # Final conversion
      #assays(o) <- List(counts=assayCompression(assay(o, "counts")))

      # # Calculate sparsity
      # sparse_percent <- vapply(X=assay(o),
      #                          FUN=function(x) sum(x == 0),
      #                          FUN.VALUE=integer(1))
      # sparse_percent <- sum(sparse_percent) / (ncol(o) * nrow(o))

      # Final conversion
      # if(assayStorage == "RleMatrix"){
      #     assays(o) <- List(counts=RleArray(assay(o, "counts")))
      # }else if(assayStorage == "DelayedArray") {
      #     assays(o) <- List(counts=DelayedArray(assay(o, "counts")))
      # }else if(assayStorage == "DataFrame") {
      #     warning("Output is a simple DataFrame of Rle's: ",
      #     "This is mainly intended for debugging and will not work with remaining CAGEfightR functions!")
      # }else{
      #     stop("assayStorage must be in: RleMatrix, DelayedArray, DataFrame")
      # }

      # Post warnings
      if(!length(plusStrand) == ncol(o)){
        warning("Output has the wrong dimensions! ",
                "Check input files with checkCTSSs.")
      }

      if(!identical(seqinfo(o), genome)){
        warning("Seqinfo was not properly set on output! ",
                "Check input files with checkCTSSs")
      }

      # Basic Summary
      message("### CTSS summary ###")
      message("Number of samples: ", ncol(o))
      message("Number of CTSSs: ", format(nrow(o) / 1e6L, digits = 4), " millions")
      message("Sparsity: ", format(zero_frac * 100, digits=4), " %")
      #message("Type of DelayedArray seed: dgCMatrix")
      message("Type of rowRanges: ", class(rowRanges(o)))
      message("Final object size: ", utils::capture.output(pryr::object_size(o)))

      # Return
      o
})

#' @rdname quantifyCTSSs
#' @export
setMethod("quantifyCTSSs",
          signature(plusStrand = "character",
                    minusStrand = "character"),
          function(plusStrand, minusStrand, design=NULL, genome=NULL) {
              # Pre-checks
              assert_that(all(checkFileSeries(plusStrand)),
                          all(checkFileSeries(minusStrand)),
                          all(checkExtensions(plusStrand, "bedGraph")),
                          all(checkExtensions(minusStrand, "bedGraph")),
                          length(plusStrand) == length(minusStrand),
                          !is.null(names(plusStrand)),
                          !is.null(names(minusStrand)),
                          all(names(plusStrand) == names(minusStrand)),
                          methods::is(genome, "Seqinfo"))

              # Set design
              message("Checking design...")
              design <- cleanDesign(design, SampleIDs=names(plusStrand))

              # Setup tiles and workers
              n_workers <- BiocParallel::bpworkers()
              n_workers <- ifelse(is.numeric(n_workers), n_workers, 1)

              message("Iterating over ", length(plusStrand),
                      " samples using ", n_workers, " worker(s)...")

              # Load data
              message("Importing CTSSs from plus strand...")
              plus_strand <- BiocParallel::bplapply(plusStrand,
                                                    bg_mapper,
                                                    seqinfo=genome,
                                                    strand="+")
              plus_strand <- gf_reducer2(plus_strand)

              message("Importing CTSSs from minus strand...")
              minus_strand <- BiocParallel::bplapply(minusStrand,
                                                    bg_mapper,
                                                    seqinfo=genome,
                                                    strand="-")
              minus_strand <- gf_reducer2(minus_strand)

              # Merge and format
              message("Merging strands...")
              o <- rbind(plus_strand, minus_strand)
              rm(plus_strand, minus_strand)

              # Attach design
              colData(o) <- design

              message("Formatting output...")
              # Calculate sparsity before seed
              zero_frac <- 1 - (Matrix::nnzero(assay(o)) / length(assay(o)))

              # Wrap in DelayedArray
              #assay(o) <- DelayedArray(assay(o))

              # Convert to GPos if possible:
              if(length(o) < .Machine$integer.max){
                rowRanges(o) <- methods::as(rowRanges(o), "StitchedGPos")
              }

              # Basic Summary
              message("### CTSS summary ###")
              message("Number of samples: ", ncol(o))
              message("Number of CTSSs: ", format(nrow(o) / 1e6L, digits = 4), " millions")
              message("Sparsity: ", format(zero_frac * 100, digits=4), " %")
              #message("Type of DelayedArray seed: dgCMatrix")
              message("Type of rowRanges: ", class(rowRanges(o)))
              message("Final object size: ", utils::capture.output(pryr::object_size(o)))

              # Return
              o
})

#### Helpers ####

checkGenomes <- function(x, y){
    tmp <- checkCompatibleSeqinfo(x,  y)
    methods::is(tmp, "Seqinfo")
}

#### txType ####

#' Annotate ranges with transcript type.
#'
#' Annotate a set of ranges in a GRanges object with transcript type (txType)
#' based on their genic context. Transcripts are obtained from a TxDb object,
#' but can alternatively be specified manually as a GRangesList.
#'
#' @param object GRanges or RangedSummarizedExperiment: Ranges to be annotated.
#' @param txModels TxDb or GRangesList: Transcript models via a TxDb, or
#'   manually specified as a GRangesList.
#' @param outputColumn character: Name of column to hold txType values.
#' @param swap character or NULL: If not NULL, use another set of ranges
#'   contained in object to calculate overlaps, for example peaks in the thick
#'   column.
#' @param tssUpstream integer: Distance to extend annotated promoter upstream.
#' @param tssDownstream integer: Distance to extend annotated promoter
#'   downstream.
#' @param proximalUpstream integer: Maximum distance upstream of promoter to be
#'   considered proximal.
#' @param detailedAntisense logical: Wether to mirror all txType categories in
#'   the antisense direction (TRUE) or lump them all together (FALSE).
#' @param noOverlap character: In case categories are manually supplied with as
#'   a GRangesList, what to call regions with no overlap.
#' @param ... additional arguments passed to methods.
#'
#' @return object with txType added as factor column in rowData (or mcols)
#'
#' @family Annotation functions
#' @export
#' @examples
#' \dontrun{
#' data(exampleUnidirectional)
#'
#' # Obtain transcript models from a TxDb-object:
#' library(TxDb.Mmusculus.UCSC.mm9.knownGene)
#' txdb <- TxDb.Mmusculus.UCSC.mm9.knownGene
#'
#' # Assign txIDs
#' assignTxType(exampleUnidirectional,
#'              txModels=txdb)
#'
#' # Assign txIDs using only TC peaks:
#' exampleUnidirectional <- assignTxType(exampleUnidirectional,
#'                                       txModels=txdb,
#'                                       swap='thick')
#'
#' # The 'promoter' and 'proximal' category boundaries can be changed:
#' assignTxType(exampleUnidirectional,
#'              txModels=txdb,
#'              swap='thick',
#'              tssUpstream=50,
#'              tssDownstream=50,
#'              proximalUpstream=100)
#'
#' # Annotation using complete antisense categories:
#' exampleUnidirectional <- assignTxType(exampleUnidirectional,
#'                                     txModels=txdb,
#'                                     outputColumn='txTypeExtended',
#'                                     swap='thick',
#'                                     detailedAntisense=TRUE)
#'
#' # The output is always a factor added as a column:
#' summary(rowRanges(exampleUnidirectional)$txType)
#' summary(rowRanges(exampleUnidirectional)$txTypeExtended)
#'
#' # To avoid using a TxDb-object, a GRangesList can be supplied:
#' custom_hierarchy <- GRangesList(promoters=granges(promoters(txdb)),
#'                                 exons=granges(exons(txdb)))
#' assignTxType(exampleUnidirectional,
#'              txModels=custom_hierarchy,
#'              outputColumn='customType',
#'              swap='thick',
#'              noOverlap = 'intergenic')
#' }
setGeneric("assignTxType", function(object, txModels, ...) {
    standardGeneric("assignTxType")
})

#' @rdname assignTxType
setMethod("assignTxType", signature(object = "GenomicRanges", txModels = "GenomicRangesList"),
    function(object, txModels, outputColumn = "txType", swap = NULL, noOverlap = "intergenic") {
        # Pre-checks
        assert_that(!is.null(names(txModels)),
                    is.string(outputColumn),
                    is.string(noOverlap),
                    checkGenomes(object, txModels))
                    #identical(seqlengths(object), seqlengths(txModels)))

        # Warnings
        if (outputColumn %in% colnames(mcols(object))) {
            warning("object already has a column named ",
                    outputColumn,
                    " in mcols: It will be overwritten!")
        }

        # Find overlaps
        if (is.null(swap)) {
            message("Finding hierachical overlaps...")
            hits <- findOverlaps(object, txModels)
        } else {
            message("Finding hierachical overlaps with swapped ranges...")
            hits <- findOverlaps(swapRanges(object, inputColumn = swap), txModels)
        }

        # Choose highest in hierachy
        hits <- breakTies(hits, method = "first")

        # Extract corresponding categories
        hits <- methods::as(hits, "List")
        hits <- extractList(names(txModels), hits)
        hits <- as.character(hits)

        # Replace NAs and format as factor
        hits <- ifelse(is.na(hits), noOverlap, hits)
        hits <- factor(hits, levels = c(names(txModels), noOverlap))

        # Append to object
        mcols(object)[, outputColumn] <- hits

        # Summarise annotation
        s <- as.data.frame(table(hits))
        colnames(s) <- c("txType", "count")
        s$percentage <- round((s$count / sum(s$count)) * 100, digits = 1)
        s <- paste(utils::capture.output(print(s)), collapse = "\n")
        message("### Overlap summary: ###")
        message(s)

        # Return
        object
    })

#' @rdname assignTxType
setMethod("assignTxType",
          signature(object = "RangedSummarizedExperiment",
                    txModels = "GenomicRangesList"),
    function(object, txModels, ...) {
        rowRanges(object) <- assignTxType(rowRanges(object),
                                          txModels = txModels,
            ...)

        # Return
        object
    })

#' @rdname assignTxType
setMethod("assignTxType", signature(object = "GenomicRanges", txModels = "TxDb"),
    function(object, txModels, outputColumn = "txType", swap = NULL,
             tssUpstream = 100, tssDownstream = 100, proximalUpstream = 1000,
             detailedAntisense = FALSE) {
        # Pre-checks
        assert_that(is.count(tssUpstream),
                    is.count(tssDownstream),
                    is.count(proximalUpstream),
                    is.flag(detailedAntisense),
                    checkGenomes(object, txModels))

        # Hierachy
        hierachy <- utilsSimplifyTxDb(object=txModels,
                                      tssUpstream=tssUpstream,
                                      tssDownstream=tssDownstream,
                                      proximalUpstream=proximalUpstream,
                                      detailedAntisense=detailedAntisense)

        # Build sense hierachy
        # hierachy <- GRangesList(promoter = granges(trim(promoters(txModels, upstream = tssUpstream,
        #     downstream = tssDownstream))), proximal = granges(trim(promoters(txModels,
        #     upstream = proximalUpstream, downstream = 0))), fiveUTR = granges(unlist(fiveUTRsByTranscript(txModels))),
        #     threeUTR = granges(unlist(threeUTRsByTranscript(txModels))), CDS = granges(cds(txModels)),
        #     exon = granges(exons(txModels)), intron = granges(unlist(intronsByTranscript(txModels))))
        #
        # Build sense hierachy message('Extracting txType categories...') hierachy <-
        # List(promoter=trim(promoters(txModels, upstream=tssUpstream,
        # downstream=tssDownstream)), proximal=trim(promoters(txModels,
        # upstream=proximalUpstream, downstream=0)),
        # fiveUTR=fiveUTRsByTranscript(txModels),
        # threeUTR=threeUTRsByTranscript(txModels), CDS=cds(txModels),
        # exon=exons(txModels), intron=intronsByTranscript(txModels)) # Coerce to
        # GRangesList #message('Coercing to GRangesList...') hierachy <- lapply(hierachy,
        # unlist) hierachy <- lapply(hierachy, granges) hierachy <- GRangesList(hierachy)

        # Build antisense hierachy message('Adding antisense categories...')
        # if (detailedAntisense) {
        #     antisense <- invertStrand(hierachy)
        #     names(antisense) <- paste0("antisense_", names(antisense))
        #     hierachy <- c(hierachy, antisense)
        # } else if (!detailedAntisense) {
        #     antisense <- invertStrand(granges(transcripts(txModels)))
        #     hierachy$antisense <- antisense
        # } else {
        #     stop("detailedAntisense must be either TRUE/FALSE!")
        # }
        # rm(antisense)

        # Overlap
        object <- assignTxType(object = object,
                               txModels = hierachy,
                               outputColumn = outputColumn,
                               swap = swap,
                               noOverlap = "intergenic")

        # Return
        object
    })

#' @rdname assignTxType
setMethod("assignTxType", signature(object = "RangedSummarizedExperiment", txModels = "TxDb"),
    function(object, txModels, ...) {
        rowRanges(object) <- assignTxType(rowRanges(object), txModels = txModels,
            ...)

        # Return
        object
    })

#### geneID ####

#' Annotate ranges with gene ID.
#'
#' Annotate a set of ranges in a GRanges object with gene IDs (i.e. Entrez Gene
#' Identifiers) based on their genic context. Features overlapping multiple
#' genes are resolved by distance to the nearest TSS. Genes are obtained from a
#' TxDb object, or can manually supplied as a GRanges.
#'
#' @param object GRanges or RangedSummarizedExperiment: Ranges to be annotated.
#' @param geneModels TxDb or GRanges: Gene models via a TxDb, or manually
#'   specified as a GRangesList.
#' @param outputColumn character: Name of column to hold geneID values.
#' @param swap character or NULL: If not NULL, use another set of ranges
#'   contained in object to calculate overlaps, for example peaks in the thick
#'   column.
#' @param upstream integer: Distance to extend annotated promoter upstream.
#' @param downstream integer: Distance to extend annotated promoter downstream.
#' @param ... additional arguments passed to methods.
#'
#' @return object with geneID added as a column in rowData (or mcols).
#'
#' @family Annotation functions
#' @export
#' @examples
#' data(exampleUnidirectional)
#'
#' # Obtain gene models from a TxDb-object:
#' library(TxDb.Mmusculus.UCSC.mm9.knownGene)
#' txdb <- TxDb.Mmusculus.UCSC.mm9.knownGene
#'
#' # Assign geneIDs
#' assignGeneID(exampleUnidirectional,
#'              geneModels=txdb,
#'              outputColumn='geneID')
#'
#' # Assign geneIDs using only TC peaks:
#' assignGeneID(exampleUnidirectional,
#'              geneModels=txdb,
#'              outputColumn='geneID',
#'              swap='thick')
setGeneric("assignGeneID", function(object, geneModels, ...) {
    standardGeneric("assignGeneID")
})

#' @rdname assignGeneID
setMethod("assignGeneID", signature(object = "GenomicRanges", geneModels = "GenomicRanges"),
    function(object, geneModels, outputColumn = "geneID", swap = NULL, upstream = 1000,
        downstream = 100) {
        # Pre-checks
        assert_that(!is.null(names(geneModels)),
                    is.string(outputColumn),
                    is.number(upstream),
                    is.number(downstream),
                    checkGenomes(object, geneModels))
                    #identical(seqlengths(object), seqlengths(geneModels)))

        # Warnings
        if (outputColumn %in% colnames(mcols(object))) {
            warning("object already has a column named ",
                    outputColumn,
                    " in mcols: It will be overwritten!")
        }

        # Extract anchor points
        message("Overlapping while taking distance to nearest TSS into account...")
        extendedGeneModels <- punion(geneModels,
                                     promoters(geneModels,
                                               upstream = upstream,
                                               downstream = downstream))
        extendedGeneModels <- trim(extendedGeneModels)
        TSSs <- resize(geneModels, width = 1, fix = "start")

        # Find overlaps
        if (is.null(swap)) {
            message("Finding hierachical overlaps...")
            hits <- findOverlaps(object, extendedGeneModels)
        } else {
            message("Finding hierachical overlaps with swapped ranges...")
            hits <- findOverlaps(swapRanges(object, inputColumn = swap),
                                 extendedGeneModels)
        }

        # Calculate distances to TSSs
        mcols(hits)$distance <- distance(Pairs(object, TSSs, hits = hits))
        rm(TSSs, extendedGeneModels)

        # Resolve by distance to nearest TSS by split apply, THIS CAN BE UPDATED IN NEXT
        # VERSION OF S4Vectors!
        hits <- hits[which.min(splitAsList(mcols(hits)$distance, queryHits(hits)),
            global = TRUE)]

        # Extract ids
        hits <- methods::as(hits, "List")
        hits <- extractList(names(geneModels), hits)
        hits <- as.character(hits)
        stopifnot(length(hits) == length(object))

        # Append to object
        mcols(object)[, outputColumn] <- hits

        # Return
        message("### Overlap Summary: ###")
        message("Features overlapping genes: ",
                round(mean(!is.na(hits)) * 100, digits = 2),
                " %")
        message("Number of unique genes: ", length(unique(na.omit(hits))))

        # Return
        object
    })

#' @rdname assignGeneID
setMethod("assignGeneID", signature(object = "RangedSummarizedExperiment", geneModels = "GenomicRanges"),
    function(object, geneModels, ...) {
        rowRanges(object) <- assignGeneID(rowRanges(object),
                                          geneModels = geneModels,
                                          ...)

        # Return
        object
    })

#' @rdname assignGeneID
setMethod("assignGeneID", signature(object = "GenomicRanges", geneModels = "TxDb"),
    function(object, geneModels, outputColumn = "geneID", swap = NULL, upstream = 1000,
        downstream = 100) {
        # Pre-checks
        assert_that(is.string(outputColumn),
                    is.number(upstream),
                    is.number(downstream),
                    checkGenomes(object, geneModels))
            #identical(seqlengths(object), seqlengths(geneModels)))

        # Extract anchor points
        message("Extracting genes...")
        as_gr <- genes(geneModels)

        # Overlap
        object <- assignGeneID(object,
                               geneModels = as_gr,
                               outputColumn = outputColumn,
                               swap = swap,
                               upstream = upstream,
                               downstream = downstream)

        # Return
        object
    })

#' @rdname assignGeneID
setMethod("assignGeneID", signature(object = "RangedSummarizedExperiment", geneModels = "TxDb"),
    function(object, geneModels, ...) {
        rowRanges(object) <- assignGeneID(rowRanges(object),
                                          geneModels = geneModels,
                                          ...)

        # Return
        object
    })

#### txID ####

#' Annotate ranges with transcript ID.
#'
#' Annotate a set of ranges in a GRanges object with transcript IDs based on
#' their genic context. All overlapping transcripts are returned. Transcripts
#' are obtained from a TxDb object, or can manually supplied as a GRanges.
#'
#' @param object GRanges or RangedSummarizedExperiment: Ranges to be annotated.
#' @param txModels TxDb or GRanges: Transcript models via a TxDb, or manually
#'   specified as a GRanges.
#' @param outputColumn character: Name of column to hold txID values.
#' @param swap character or NULL: If not NULL, use another set of ranges
#'   contained in object to calculate overlaps, for example peaks in the thick
#'   column.
#' @param upstream integer: Distance to extend annotated promoter upstream.
#' @param downstream integer: Distance to extend annotated promoter downstream.
#' @param ... additional arguments passed to methods.
#'
#' @return object with txID added as a column in rowData (or mcols)
#'
#' @family Annotation functions
#' @export
#' @examples
#' data(exampleUnidirectional)
#'
#' # Obtain transcript models from a TxDb-object:
#' library(TxDb.Mmusculus.UCSC.mm9.knownGene)
#' txdb <- TxDb.Mmusculus.UCSC.mm9.knownGene
#'
#' # Assign txIDs
#' assignTxID(exampleUnidirectional,
#'            txModels=txdb,
#'            outputColumn='geneID')
#'
#' # Assign txIDs using only TC peaks:
#' assignTxID(exampleUnidirectional,
#'              txModels=txdb,
#'              outputColumn='geneID',
#'              swap='thick')
setGeneric("assignTxID", function(object, txModels, ...) {
    standardGeneric("assignTxID")
})

#' @rdname assignTxID
setMethod("assignTxID", signature(object = "GenomicRanges", txModels = "GenomicRanges"),
    function(object, txModels, outputColumn = "txID", swap = NULL) {
        # Pre-checks
        assert_that(!is.null(names(txModels)),
                    is.string(outputColumn),
                    checkGenomes(object, txModels))
                    #identical(seqlengths(object), seqlengths(txModels)))

        # Warnings
        if (outputColumn %in% colnames(mcols(object))) {
            warning("object already has a column named ",
                    outputColumn,
                    " in mcols: It will be overwritten!")
        }

        # Find overlaps
        if (is.null(swap)) {
            message("Finding hierachical overlaps...")
            hits <- findOverlaps(object, txModels)
        } else {
            message("Finding hierachical overlaps with swapped ranges...")
            hits <- findOverlaps(swapRanges(object, inputColumn = swap),
                                 txModels)
        }

        # Count unique transcrips for later
        nTxs <- length(unique(to(hits)))

        # Extract names
        hits <- methods::as(hits, "List")
        hits <- extractList(names(txModels), hits)
        hits <- paste(hits, collapse = ";")
        hits <- ifelse(hits == "", NA, hits)

        # Checks
        stopifnot(length(hits) == length(object), is.character(hits))

        # Append to object
        mcols(object)[, outputColumn] <- hits

        # Return
        message("### Overlap Summary: ###")
        message("Features overlapping transcripts: ",
                round(mean(!is.na(hits)) * 100, digits = 2),
                " %")
        message("Number of unique transcripts: ", nTxs)

        # Return
        object
    })

#' @rdname assignTxID
setMethod("assignTxID", signature(object = "RangedSummarizedExperiment", txModels = "GenomicRanges"),
    function(object, txModels, ...) {
        rowRanges(object) <- assignTxID(rowRanges(object),
                                        txModels = txModels,
                                        ...)

        # Return
        object
    })

#' @rdname assignTxID
setMethod("assignTxID", signature(object = "GenomicRanges", txModels = "TxDb"),
          function(object, txModels, outputColumn = "txID", swap = NULL, upstream = 1000, downstream = 0) {
    # Pre-checks
    assert_that(is.string(outputColumn),
                is.number(upstream),
                upstream >= 0,
                is.number(downstream),
                downstream >= 0,
                checkGenomes(object, txModels))
                #identical(seqlengths(object), seqlengths(txModels)))

    # Extract anchor points
    message("Extracting transcripts...")
    txs <- transcripts(txModels, columns = "tx_name")
    names(txs) <- txs$tx_name
    txs <- punion(txs, promoters(txs, upstream = upstream, downstream = downstream))
    txs <- trim(txs)

    # Overlap
    object <- assignTxID(object, txModels = txs, outputColumn = outputColumn)

    # Return
    object
})

#' @rdname assignTxID
setMethod("assignTxID", signature(object = "RangedSummarizedExperiment", txModels = "TxDb"),
    function(object, txModels, ...) {
        rowRanges(object) <- assignTxID(rowRanges(object), txModels = txModels, ...)

        # Return
        object
    })

#### NAs ####

#' Annotate ranges with missing IDs.
#'
#' This function can relabel ranges with missing IDs (i.e. returned by
#' assignTxID and assignGeneID), in case they need to be retained for further
#' analysis.
#'
#' @param object character, GRanges or RangedSummarizedExperiment: IDs to have
#'   NAs replaces with new IDs.
#' @param outputColumn character: Name of column to hold txID values.
#' @param prefix character: New name to assign to ranges with missing IDs, in
#'   the style prefix1, prefix2, etc.
#' @param ... additional arguments passed to methods.
#'
#' @return object with NAs replaced in outputColumn
#'
#' @family Annotation functions
#' @export
#' @examples
#' data(exampleUnidirectional)
#'
#' # Obtain gene models from a TxDb-object:
#' library(TxDb.Mmusculus.UCSC.mm9.knownGene)
#' txdb <- TxDb.Mmusculus.UCSC.mm9.knownGene
#'
#' # Assign geneIDs using only TC peaks:
#' exampleUnidirectional <- assignGeneID(exampleUnidirectional,
#'                                       geneModels=txdb,
#'                                       outputColumn='geneID',
#'                                       swap='thick')
#'
#' # Replace NAs with 'Novel'
#' assignMissingID(exampleUnidirectional)
#'
#' # Replace NAs with 'NovelTSS'
#' assignMissingID(exampleUnidirectional, prefix = 'NovelTSS')
setGeneric("assignMissingID", function(object, ...) {
    standardGeneric("assignMissingID")
})

#' @rdname assignMissingID
setMethod("assignMissingID", signature(object = "character"), function(object, prefix = "Novel") {
    # Pre-checks
    assert_that(is.string(prefix))

    missingIDs <- is.na(object)
    totalMissing <- sum(missingIDs)
    object[missingIDs] <- paste0(prefix, seq_len(totalMissing))

    message("Assigned ", totalMissing, " missing IDs")
    object
})

#' @rdname assignMissingID
setMethod("assignMissingID", signature(object = "GenomicRanges"), function(object,
    outputColumn = "geneID", prefix = "Novel") {
    # Pre-checks
    assert_that(is.string(outputColumn),
                outputColumn %in% colnames(mcols(object)))

    # Replace
    mcols(object)[, outputColumn] <- assignMissingID(mcols(object)[, outputColumn],
        prefix = prefix)

    # Return
    object
})

#' @rdname assignMissingID
setMethod("assignMissingID", signature(object = "RangedSummarizedExperiment"), function(object,
    outputColumn = "geneID", prefix = "Novel") {
    rowRanges(object) <- assignMissingID(rowRanges(object), outputColumn = outputColumn,
        prefix = prefix)

    # Return
    object
})

# setGeneric("rowsum2", function(x, group, ...) {
#     standardGeneric("rowsum2")
# })
#
# setMethod("rowsum2", signature(x = "matrix", group = "factor"), function(x, group,
#     drop = TRUE, sparse = FALSE) {
#     # Pre-checks
#     stopifnot(nrow(x) == length(group), length(sparse) == 1, length(drop) == 1)
#
#     if (!drop | sparse) {
#         warning("Aggregating base::matrix always drops unused levels", " and return a base::matrix!")
#     }
#
#     # Aggregate
#     o <- suppressWarnings(rowsum(x, group))
#
#     # Discard NAs
#     if (anyNA(group)) {
#         o <- o[-nrow(o), ]
#     }
#
#     # Check output dimensions and names match
#     group <- factor(group)
#     stopifnot(nrow(o) == length(levels(group)), rownames(o) == levels(group))
#
#     # Return
#     o
# })
#
# setMethod("rowsum2", signature(x = "dgCMatrix", group = "factor"), function(x, group,
#     drop = FALSE, sparse = FALSE) {
#     # Pre-checks
#     stopifnot(nrow(x) == length(group), length(sparse) == 1, length(drop) == 1)
#
#
#     # Aggregate
#     o <- aggregate.Matrix2(x = x, groupings = group, drop.unused.levels = drop)
#
#     # Discard NAs
#     if (anyNA(group)) {
#         o <- o[-nrow(o), ]
#     }
#
#     # To matrix
#     if (!sparse) {
#         # To matrix
#         o <- Matrix::as.matrix(o)
#
#         # Compress to integer if possible
#         if (all(o == floor(o))) {
#             storage.mode(o) <- "integer"
#         }
#     }
#
#     # Post-checks
#     if (drop) {
#         stopifnot(nrow(o) <= length(levels(group)), all(rownames(o) %in% levels(group)))
#     } else {
#         stopifnot(nrow(o) == length(levels(group)), setequal(rownames(o), levels(group)),
#             all(rownames(o) == levels(group)))
#     }
#
#     # Return
#     o
# })
#
# aggregate.Matrix2 <- function(x, groupings = NULL, form = NULL, fun = "sum", drop.unused.levels = TRUE,
#     ...) {
#     if (!methods::is(x, "Matrix"))
#         x <- Matrix::Matrix(Matrix::as.matrix(x), sparse = TRUE)
#     if (fun == "count")
#         x <- x != 0
#     groupings2 <- groupings
#     if (!methods::is(groupings2, "data.frame"))
#         # groupings2 <- methods::as(groupings2, 'data.frame')
#     groupings2 <- as.data.frame(groupings2)
#     groupings2 <- data.frame(lapply(groupings2, as.factor))
#     groupings2 <- data.frame(interaction(groupings2, sep = "_"))
#     colnames(groupings2) <- "A"
#     if (is.null(form))
#         form <- stats::as.formula("~0+.")
#     form <- stats::as.formula(form)
#     mapping <- Matrix.utils::dMcast(groupings2, form, drop.unused.levels = drop.unused.levels)
#     colnames(mapping) <- substring(colnames(mapping), 2)
#     result <- t(mapping) %*% x
#     if (fun == "mean")
#         result@x <- result@x/(Matrix.utils::aggregate.Matrix(x, groupings2, fun = "count"))@x
#     attr(result, "crosswalk") <- grr::extract(groupings, match(rownames(result),
#         groupings2$A))
#     return(result)
# }

#### CTSSs (MOVED TO SEPARATE FILE) ####

gf_mapper <- function(range, file, seqinfo, strand = "*") {
    # Load and force seqlevels
    o <- import(file, which = range)
    seqlevels(o) <- seqlevels(seqinfo)
    # isCircular(o) <- isCircular(seqinfo) genome(o) <- genome(seqinfo)
    seqinfo(o) <- seqinfo
    strand(o) <- strand

    # Compress and rename scores
    score(o) <- as.integer(score(o))

    # Return (GPos in comments) methods::as(o, 'GPos') #
    o
}

#' @importClassesFrom Matrix dgCMatrix
gf_reducer <- function(mapped) {
    # Save names
    j_names <- names(mapped)

    # Add j mapped <- mapply(function(gp, j){gp$j <- j; gp}, mapped,
    # seq_along(mapped))#
    mapped <- mapply(function(gp, j) {
        mcols(gp)[, "j"] <- j
        gp
    }, mapped, seq_along(mapped))

    # Coerce to mat
    # mapped <- do.call(pryr::partial(c, x=GPos()), mapped)
    mapped <- do.call(pryr::partial(c, x = GRanges()), mapped)

    # Add i (erase mcols to save memory)
    # dj <- unique(granges(mapped)) # Old version, coerced to GRanges
    dj <- mapped
    mcols(dj) <- NULL
    dj <- unique(dj)
    dj <- sort(dj)

    mapped$i <- match(mapped, dj)

    # To sparse matrix
    if (length(mapped) > 0) {
        # Ensure that matrix has the right output format
        mapped <- Matrix::sparseMatrix(i = mapped$i,
                                       j = mapped$j,
                                       x = score(mapped),
                                       dims = c(max(mapped$i),
                                                length(j_names)),
                                       dimnames = list(NULL, j_names))
    } else {
        # Simply create an empty matrix
        mapped <- methods::as(matrix(nrow = 0,
                                     ncol = length(j_names),
                                     dimnames = list(NULL, j_names)),
                              "dgCMatrix")
    }

    # Assemble into summarized experiment
    mapped <- SummarizedExperiment(assays = SimpleList(counts = mapped),
                                   rowRanges = dj)

    # Return
    mapped
}

gf_wrapper <- function(files, ranges, seqinfo, strand) {
    # Run GenomicFiles
    o <- GenomicFiles::reduceByRange(ranges = ranges, files = files, MAP = pryr::partial(gf_mapper,
        seqinfo = seqinfo, strand = strand), REDUCE = gf_reducer, iterate = FALSE)

    # Merge output
    o <- do.call(rbind, o)

    # Return
    o
}

#' Quantify CAGE Transcriptions Start Sites (CTSSs)
#'
#' This function reads in CTSS count data from a series of BigWig-files and
#' returns a CTSS-by-library count matrix. For efficient processing, the count
#' matrix is stored as a sparse matrix (dgCMatrix).
#'
#' @param plusStrand BigWigFileList: BigWig files with plus-strand CTSS data.
#' @param minusStrand BigWigFileList: BigWig files with minus-strand CTSS data.
#' @param design DataFrame or data.frame: Additional information on samples.
#' @param genome Seqinfo: Genome information. If NULL the smallest common genome
#'   will be found using bwCommonGenome.
#' @param tileWidth integer: Size of tiles to parallelize over.
#'
#' @return RangedSummarizedExperiment, where assay is a sparse matrix
#'   (dgCMatrix) of CTSS counts..
#' @family Quantification functions
#' @importClassesFrom Matrix dgCMatrix
#' @examples
#' \dontrun{
#' # Load the example data
#' data('exampleDesign')
#' # Use the BigWig-files included with the package:
#' bw_plus <- system.file('extdata', exampleDesign$BigWigPlus,
#'                        package = 'CAGEfightR')
#' bw_minus <- system.file('extdata', exampleDesign$BigWigMinus,
#'                         package = 'CAGEfightR')
#'
#' # Create two named BigWigFileList-objects:
#' bw_plus <- BigWigFileList(bw_plus)
#' bw_minus <- BigWigFileList(bw_minus)
#' names(bw_plus) <- exampleDesign$Name
#' names(bw_minus) <- exampleDesign$Name
#'
#' # Quantify CTSSs, by default this will use the smallest common genome:
#' CTSSs <- quantifyCTSSs(plusStrand=bw_plus,
#'                        minusStrand=bw_minus,
#'                        design=exampleDesign)
#'
#' # Alternatively, a genome can be specified:
#' si <- seqinfo(bw_plus[[1]])
#' si <- si['chr18']
#' CTSSs <- quantifyCTSSs(plusStrand=bw_plus,
#'                        minusStrand=bw_minus,
#'                        design=exampleDesign,
#'                        genome=si)
#'
#' # Quantification can be speed up by using multiple cores:
#' library(BiocParallel)
#' register(MulticoreParam(workers=3))
#' CTSSs <- quantifyCTSSs(plusStrand=bw_plus,
#'                        minusStrand=bw_minus,
#'                        design=exampleDesign,
#'                        genome=si)
#' }
quantifyCTSSs2 <- function(plusStrand, minusStrand, design = NULL, genome = NULL,
    tileWidth = 100000000L) {
    # Pre-checks
    assert_that(methods::is(plusStrand, "BigWigFileList"),
    						methods::is(minusStrand, "BigWigFileList"),
    						length(plusStrand) == length(minusStrand),
    						bwValid(plusStrand),
    						bwValid(minusStrand),
    						all(names(plusStrand) == names(minusStrand)),
    						is.count(tileWidth))

    # Set design
    if (is.null(design)) {
        design <- DataFrame(row.names = names(plusStrand))
    } else if (methods::is(design, "DataFrame")) {
        assert_that(all(rownames(design) == names(plusStrand)))
    } else if (is.data.frame(design)) {
        assert_that(all(rownames(design) == names(plusStrand)))
        design <- methods::as(design, "DataFrame")
    } else {
        stop("design must either NULL or a DataFrame-/data.frame-object!")
    }

    # Aquire seqinfo if missing.
    if (is.null(genome)) {
        message("Finding common genome...")
        genome <- bwCommonGenome(plusStrand, minusStrand, method = "intersect")
    } else if (methods::is(genome, "Seqinfo")) {
        message("Checking supplied genome compatibility...")
        bwGenomeCompatibility(plusStrand, minusStrand, genome)
    } else {
        stop("genome must either NULL or a Seqinfo-object!")
    }

    # Setup tiles
    grl <- GenomicRanges::tileGenome(genome, tilewidth = tileWidth)
    message("Iterating over ", length(grl), " genomic tiles in ", length(plusStrand),
        " samples using ", BiocParallel::bpworkers(), " worker(s)...")

    # Load data
    message("Importing CTSSs from plus strand...")
    plus_strand <- gf_wrapper(files = plusStrand, ranges = grl, seqinfo = genome,
        strand = "+")

    message("Importing CTSSs from minus strand...")
    minus_strand <- gf_wrapper(files = minusStrand, ranges = grl, seqinfo = genome,
        strand = "-")

    # Merge
    message("Merging strands...")
    o <- rbind(plus_strand, minus_strand)
    rm(plus_strand, minus_strand)

    # Attach design
    colData(o) <- design

    # Convert to GPos if small
    if(length(o) < .Machine$integer.max){
    	rowRanges(o) <- methods::as(rowRanges(o), "GPos")
    }

    # Post-checks (GPos commented out)
    stopifnot(length(plusStrand) == ncol(o),
    					identical(seqinfo(o), genome))

    message("### CTSS summary ###")
    message("Number of samples: ", ncol(o))
    message("Number of CTSSs: ", format(nrow(o)/1000000L, digits = 4), " millions")
    message("Sparsity: ", format((1 - (Matrix::nnzero(assay(o))/length(assay(o)))) *
        100, digits = 4), " %")
    message("Final object size: ", utils::capture.output(pryr::object_size(o)))

    # Return
    o
}

#### TCs and Genes ####

#' Quantify expression of clusters (TSSs or enhancers) by summing CTSSs within
#' clusters.
#'
#' @param object RangedSummarizedExperiment: CTSSs.
#' @param clusters GRanges: Clusters to be quantified.
#' @param inputAssay character: Name of assay holding expression values to be
#'   quantified (usually counts).
#' @param sparse logical: If the input is a sparse matrix, TRUE will keep the
#'   output matrix sparse while FALSE will coerce it into a normal matrix.
#'
#' @return RangedSummarizedExperiment with row corresponding to clusters.
#'   seqinfo and colData is copied over from object.
#'
#' @family Quantification functions
#' @importClassesFrom Matrix dgCMatrix
#' @export
#' @examples
#' # CTSSs stored in a RangedSummarizedExperiment:
#' data(exampleCTSS)
#'
#' # Clusters to be quantified as a GRanges:
#' data(exampleUnidirectional)
#' clusters <- rowRanges(exampleUnidirectional)
#'
#' # Quantify clusters:
#' quantifyClusters(exampleCTSSs, clusters)
#'
#' # For exceptionally large datasets,
#' # the resulting count matrix can be left sparse:
#' quantifyClusters(exampleCTSSs, rowRanges(exampleUnidirectional), sparse=TRUE)
quantifyClusters <- function(object, clusters, inputAssay = "counts", sparse = FALSE) {
    # Pre-checks
    assert_that(methods::is(object, "RangedSummarizedExperiment"),
    						not_empty(object),
    						isDisjoint(object),
    						methods::is(clusters, "GRanges"),
    						not_empty(clusters),
    						isDisjoint(clusters),
    						identical(seqinfo(object), seqinfo(clusters)),
    						is.string(inputAssay),
    						inputAssay %in% assayNames(object),
    						is.flag(sparse))

    # Find overlaps
    message("Finding overlaps...")
    hits <- findOverlaps(query = object,
                         subject = clusters,
                         select = "arbitrary")
    hits <- factor(hits, levels = seq_along(clusters))
    missing_hits <- is.na(hits)

    # Warn if there is no overlap
    if (all(missing_hits)) {
        warning("The supplied clusters had no overlapping CTSSs!")
    }

    # Summarize
    message("Aggregating within clusters...")
    # mat <- rowsum2(x = assay(object, inputAssay),
    #                group = hits,
    #                drop = FALSE,
    #                sparse = sparse)
    mat <- utilsAggregateRows(x = assay(object, inputAssay),
                   group = hits,
                   drop = FALSE,
                   sparse = sparse)

    # Check output is the right format and assign names.
    stopifnot(nrow(mat) == length(clusters))
    rownames(mat) <- names(clusters)

    # Coerce to RSE
    o <- SummarizedExperiment(assays = SimpleList(mat),
                              rowRanges = clusters,
                              colData = colData(object))
    assayNames(o) <- inputAssay

    # Return
    o
}

#' Quantify expression of genes
#'
#' Obtain gene-level expression estimates by summing clusters annotated to the
#' same gene. Unannotated transcripts (NAs) are discarded.
#'
#' @param object RangedSummarizedExperiment: Cluster-level expression values.
#' @param genes character: Name of column in rowData holding gene IDs (NAs will
#'   be discarded).
#' @param inputAssay character: Name of assay holding values to be quantified,
#'   (usually counts).
#' @param sparse logical: If the input is a sparse matrix, TRUE will keep the
#'   output matrix sparse while FALSE will coerce it into a normal matrix.
#'
#' @return RangedSummarizedExperiment with rows corresponding to genes. Location
#'   of clusters within genes is stored as a GRangesList in rowRanges. seqinfo
#'   and colData is copied over from object.
#' @family Quantification functions
#' @export
#' @examples
#' data(exampleUnidirectional)
#'
#' # Annotate clusters with geneIDs:
#' library(TxDb.Mmusculus.UCSC.mm9.knownGene)
#' txdb <- TxDb.Mmusculus.UCSC.mm9.knownGene
#' exampleUnidirectional <- assignGeneID(exampleUnidirectional,
#'                                       geneModels=txdb,
#'                                       outputColumn='geneID')
#'
#' # Quantify counts within genes:
#' quantifyGenes(exampleUnidirectional, genes='geneID', inputAssay='counts')
#'
#' # For exceptionally large datasets,
#' # the resulting count matrix can be left sparse:
#' quantifyGenes(exampleUnidirectional,
#'               genes='geneID',
#'               inputAssay='counts',
#'               sparse=TRUE)
quantifyGenes <- function(object, genes, inputAssay = "counts", sparse = FALSE) {
    # Pre-checks
    assert_that(methods::is(object, "RangedSummarizedExperiment"),
                isDisjoint(object),
                is.string(genes),
                is.element(genes, colnames(rowData(object))),
                is.character(rowData(object)[,genes]),
                is.string(inputAssay),
                inputAssay %in% assayNames(object),
                is.flag(sparse))

    # Factor genes
    genes <- factor(rowData(object)[, genes])

    # Split ranges
    new_gr <- splitAsList(rowRanges(object), f = genes, drop = TRUE)
    message("Quantifying genes: ", length(new_gr))

    # Sum matrix
    # new_m <- rowsum2(assay(object, inputAssay),
    #                  group = genes,
    #                  drop = TRUE,
    #                  sparse = sparse)

    new_m <- utilsAggregateRows(assay(object, inputAssay),
                     group = genes,
                     drop = TRUE,
                     sparse = sparse)

    # Check that names match
    stopifnot(setequal(rownames(new_m), names(new_gr)))
    if (!all(rownames(new_m) == names(new_gr))) {
        new_m <- new_m[names(new_gr), ]
    }

    # Reassemble and copy over
    o <- SummarizedExperiment(assays = list(new_m),
                              rowRanges = new_gr,
                              colData = colData(object),
        metadata = metadata(object))
    assayNames(o) <- inputAssay

    # Calculate some stats
    rowData(o)[, "nClusters"] <- elementNROWS(new_gr)

    # Return
    o
}

#' Combine two CAGE experiments.
#'
#' This function can safely combine two CAGE experiments, for example TCs and
#' enhancers, for later analysis, by making sure no ranges in the final object
#' are overlapping.
#'
#' @param object1 RangedSummarizedExperiment: First experiment to be combined.
#' @param object2 RangedSummarizedExperiment: First experiment to be combined.
#' @param removeIfOverlapping character: Whether to keep overlapping ranges
#'   ('none') or discard from either the first ('object1') or second ('object2')
#'   experiment.
#' @param ... arguments passed to methods.
#'
#' @return RangedSummarizedExperiment with merged and sorted ranges (colData and
#'   metadata are carried over unchanged).
#' @export
#' @examples
#' data(exampleUnidirectional)
#' data(exampleBidirectional)
#'
#' # Clusters must have identical colData to be combined:
#' exampleUnidirectional$totalTags <- NULL
#'
#' # Combine, keeping potential overlaps
#' combineClusters(object1=exampleUnidirectional, object2=exampleBidirectional)
#'
#' # If features overlap, keep only from object1
#' combineClusters(object1=exampleUnidirectional, object2=exampleBidirectional,
#'    removeIfOverlapping='object2')
#'
#' # If features overlap, keep only from object2
#' combineClusters(object1=exampleUnidirectional, object2=exampleBidirectional,
#'    removeIfOverlapping='object1')
setGeneric("combineClusters", function(object1, object2, ...) {
    standardGeneric("combineClusters")
})

#' @rdname combineClusters
#' @export
setMethod("combineClusters", signature(object1 = "RangedSummarizedExperiment", "RangedSummarizedExperiment"),
    function(object1, object2, removeIfOverlapping = "none") {
        # Pre-checks
        assert_that(!is.null(rownames(object1)),
                    !is.null(rownames(object2)),
                    identical(seqinfo(object1), seqinfo(object2)),
                    identical(colData(object1), colData(object2)),
                    removeIfOverlapping %in% c("object1", "object2", "none"))

        # Remove overlapping features
        if (removeIfOverlapping == "object1") {
            # Find overlaps
            os <- overlapsAny(object1, object2)

            # Remove
            message("Removing overlapping features from object1: ", sum(os))
            object1 <- subset(object1, !os)
        } else if (removeIfOverlapping == "object2") {
            # Find overlaps
            os <- overlapsAny(object2, object1)

            # Remove
            message("Removing overlapping features from object2: ", sum(os))
            object2 <- subset(object2, !os)
        } else {
            os <- intersect(rowRanges(object1), rowRanges(object2))
            message("Overlapping features were not removed: ", length(os))
        }
        rm(os)

        # Only retain shared assays
        shared_assays <- intersect(assayNames(object1), assayNames(object2))
        message("Keeping assays: ", paste(shared_assays, collapse = ", "))
        assays(object1) <- assays(object1)[shared_assays]
        assays(object2) <- assays(object2)[shared_assays]
        rm(shared_assays)

        # Only retain shared rowcolumns
        shared_cols <- intersect(colnames(mcols(object1)), colnames(mcols(object2)))
        message("Keeping columns: ", paste(shared_cols, collapse = ", "))
        mcols(object1) <- mcols(object1)[, shared_cols]
        mcols(object2) <- mcols(object2)[, shared_cols]
        rm(shared_cols)

        # Attempt to merge metadata
        message("Merging metadata...")
        new_meta <- c(metadata(object1), metadata(object2))
        metadata(object1) <- list()
        metadata(object2) <- list()
        new_meta <- new_meta[!duplicated(new_meta)]

        # Bind, add meta and re-sort
        message("Stacking and re-sorting...")
        o <- rbind(object1, object2)
        metadata(o) <- new_meta
        rm(new_meta)
        o <- sort(o)

        # Return
        o
    })

---
title: "Introduction to CAGEfightR"
author: Malte Thodberg
package: CAGEfightR
abstract: >
  CAGEfightR is an R/Bioconductor for analyzing 5'-end data such as CAGE, PRO-Cap, START-Seq, TSS-Seq, etc. Functionality includes identification and quantification of both TSSs and enhancers, detailed annotation using transcript models, TSS-enhancer correlations, super enhancer identification, quantification of gene expression and visualizing it all in a genome browser.
output: 
  BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{Introduction to CAGEfightR}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}  
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

# Installation

Install the most recent stable version from Bioconductor:

```{r bioconductor, eval=FALSE}
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("CAGEfightR")
```

And load `CAGEfightR`:

```{r library, results='hide', message=FALSE}
library(CAGEfightR)
```

Alternatively, you can install the development version directly from GitHub using `devtools`:

```{r github, eval=FALSE}
devtools::install_github("MalteThodberg/CAGEfightR")
```

# Citation

If you use CAGEfightR, please cite the following article:

```{r citation, eval=TRUE}
citation("CAGEfightR")
```

# Getting help

For general questions about the usage of CAGEfightR, use the [official Bioconductor support forum](https://support.bioconductor.org) and tag your question "CAGEfightR". We strive to answer questions as quickly as possible.

For technical questions, bug reports and suggestions for new features, we refer to the [CAGEfightR github page](https://github.com/MalteThodberg/CAGEfightR/issues).

# Quick start for the impatient

A CAGEfightR anaysis usually starts with loading CAGE Transcription Start Sites (CTSSs) from BigWig-files, one for each strand (If you do not have CTSSs as BigWig-files, look at `convertBED2BigWig` for instructions on how to convert file  formats):

```{r BigWig_files, results="hide", tidy=FALSE}
# Load the example data
data("exampleDesign")
head(exampleDesign)

# Locate files on your harddrive
bw_plus <- system.file("extdata", 
                       exampleDesign$BigWigPlus, 
                       package = "CAGEfightR")
bw_minus <- system.file("extdata", 
                        exampleDesign$BigWigMinus,
                        package = "CAGEfightR")

# Create two named BigWigFileList-objects:
bw_plus <- BigWigFileList(bw_plus)
bw_minus <- BigWigFileList(bw_minus)
names(bw_plus) <- exampleDesign$Name
names(bw_minus) <- exampleDesign$Name
```

The first step is to quantify CTSSs across all samples using `quantifyCTSSs`, which will return the results as a `RangedSummarizedExperiment`:

```{r quickCTSSs, tidy=FALSE}
# Get genome information
genomeInfo <- SeqinfoForUCSCGenome("mm9")

# Quantify CTSSs
CTSSs <- quantifyCTSSs(plusStrand=bw_plus,
                       minusStrand=bw_minus,
                       design=exampleDesign,
                       genome=genomeInfo)
```

The wrapper function `quickTSSs` will automatically find and quantify candidate TSSs, returning the results as a `RangedSummarizedExperiment`:

```{r quickTSSs, tidy=FALSE}
TSSs <- quickTSSs(CTSSs)
```

Similarly, `quickEnhancers` will find and quantify candidate enhancers:

```{r quickEnhancers, tidy=FALSE}
enhancers <- quickEnhancers(CTSSs)
```

We can then use transcript models stored in a `TxDb`-object to annotate each candidate TSS and enhancer with their transcript context:

```{r quickAnnotate, tidy=FALSE}
# Use the built in annotation for mm9
library(TxDb.Mmusculus.UCSC.mm9.knownGene)
txdb <- TxDb.Mmusculus.UCSC.mm9.knownGene

# Annotate both TSSs and enhancers
TSSs <- assignTxType(TSSs, txModels=txdb)
enhancers <- assignTxType(enhancers, txModels=txdb)
```

Usually, candidate enhancers overlapping known transcripts are removed:

```{r quickFilter, tidy=FALSE}
enhancers <- subset(enhancers, txType %in% c("intergenic", "intron"))
```

For usage with other Bioconductor package, it can be useful to merge candidate TSSs and enhancers into a single object:

```{r quickCombine, tidy=FALSE}
# Add an identifier column
rowRanges(TSSs)$clusterType <- "TSS"
rowRanges(enhancers)$clusterType <- "enhancer"

# Combine TSSs and enhancers, discarding TSSs if they overlap enhancers
RSE <- combineClusters(TSSs, enhancers, removeIfOverlapping="object1")
```

For use with packages for calling differential expression (DESeq2, edgeR, limma, etc.) very lowly expressed features are removed:

```{r quickSupport, tidy=FALSE}
# Only keep features with more than 0 counts in more than 1 sample:
RSE <- subsetBySupport(RSE,
                       inputAssay = "counts",
                       outputColumn = "support",
                       unexpressed = 0,
                       minSamples = 1)
```

For interfacing with other tools for gene-level analysis, we can quantify gene expression:

```{r quickGenes, tidy=FALSE}
gene_level <- quickGenes(RSE, geneModels = txdb)
```

But it is much cooler to leverage some of the unique features of 5'-end methods, for example, we can calculate the correlation of expression of nearby TSSs and enhancers:

```{r quickLinks, tidy=FALSE}
# Set TSSs as reference points
rowRanges(RSE)$clusterType <- factor(rowRanges(RSE)$clusterType,
                                     levels=c("TSS", "enhancer"))

# Find pairs and calculate kendall correlation between them
links <- findLinks(RSE, 
                   inputAssay="counts", 
                   maxDist=5000, 
                   directional="clusterType",
                   method="kendall")
```

Other 5'-end analysis tasks include classifying TSSs based on shape, and identifying groups of closely space enhancers (super enhancers). This and more is described in more detail below!

# Introduction and overview

## Introduction to CAGE data

Cap Analysis of Gene Expression (CAGE) is one of the most popular 5'-end high-throughput assays for profiling Transcription Start Site (TSS) activity. CAGE is based on sequencing the first 20-30 basepairs of capped full-length RNAs, called CAGE-tags. When mapped to a reference genome, CAGE-tags can be used to identify both TSSs and enhancers. See the `CAGEfightR` paper for additional introduction.

CAGE-data is often represented as CAGE TSSs (CTSSs), which is the the number of CAGE-tag 5'-ends mapping to each genomic position. CTSSs thereby represent a genome-wide, basepair resolution, quantitative atlas of transcription. CTSSs are inherently sparse, as only very few genomic positions are CTSSs, and only very few CTSSs have a high number of CAGE-tags.

Analysis of CAGE data is often focused on identifying clusters of CTSSs that corresponds to activity of individual TSSs and enhancers. Having access to both TSSs and enhancers in a single experiment makes CAGE well suited for studying many aspects of transcriptional regulation, for example differential expression, motif analysis and alternative TSS usage.

While the examples in this vignette is based on CAGE, other 5'-end methods (PRO-Cap, START-Seq, TSS-Seq, etc.) can be analyzed in the same way.

## Central S4-classes

There are two key S4-classes to understand when using CAGEfightR:

The `GRanges`-class: Genomic locations or ranges are stored as `GRanges`-objects from the `r BiocStyle::Biocpkg("GenomicRanges")` package. `GRanges` contain chromosome (`seqnames`), start (`start`) and end (`end`) positions of ranges, along with chromosome lengths (`seqinfo`). An important additional feature is information on each range via metadata columns (`mcols`). These can be almost anything, as long as they can be put into a `DataFrame`. Some metadata columns have special meanings: the score column (accesible via the `score` function) and thick column, as these columns can be exported to a standard BED-format file via the `export` function from the `r BiocStyle::Biocpkg("rtracklayer")` package.

The `RangedSummarizedExperiment`-class: Complete experiments can be stored as `RangedSummarizedExperiment`-objects from the `r BiocStyle::Biocpkg("SummarizedExperiment")`, which implements the idea of the "three tables of genomics". A `RangedSummarizedExperiment` can store several matrices of the same shape, e.g. counts and normalized expression values (accesible via `assay` and `assays`), along with information about each sample as a `DataFrame`-object (accesible via `colData`) and about each feature as a `GRanges`-object like above (accesible via `rowRanges`). Many `GRanges` methods also work on`RangedSummarizedExperiment`-objects, like `sort`, `findOverlaps`, etc..  Storing all information as a single `RangedSummarizedExperiment` helps keeping data organized, for example when extracting subsets of the data, where `subset` can be used to simultaneously extract requested data from all three tables at once.

Other S4-classes includes `TxDb`-objects from `r BiocStyle::Biocpkg("GenomicFeatures")`, `GInteractions`-object from `r BiocStyle::Biocpkg("InteractionSet")` and various track-objects from `r BiocStyle::Biocpkg("Gviz")`. See [Annotation with transcript models], [Spatial analysis of clusters] and [Plotting CAGE data in a genome browser] for more details.

## Overview of functions

CAGEfightR conceptually analyses CAGE-data at 3 levels:

1) CTSS-level: Analysis at the level of number of CAGE tags per CTSS.
2) Cluster-level: Analysis at the level of clusters of CTSSs, usually TSSs and/or enhancers.
3) Gene-level: Analysis at the level of annotated genes.

For easier overview, functions in `CAGEfightR` are organized by prefixes. The most important groups are:

The `quantify*`-functions summarizes CAGE data to a higher level. In all cases, data is a stored as a `RangedSummarizedExperiment`:

- `quantifyCTSSs`: Quantify the number of CAGE-tags for each CTSSs from BigWig-files.
- `quantifyClusters`: Quantify the number of CAGE-tags within clusters of CTSSs, usually TSSs or enhancers.
- `quantifyGenes`: Quantify the number of CAGE-tags within annotated genes, by summing the number of CAGE-tags annotated clusters.

The `calc*`-functions modify data stored in a `RangedSummarizedExperiment`. The following `calc*` functions perform basic calculations applicable to all three levels:

- `calcTotalTags`: Calculate the total number of CAGE tags in a library.
- `calcTPM`: Calcuate Tags-Per-Million (TPM).
- `calcPooled`: Calculate a pooled signal across all samples.
- `calcSupport`: Count the number of samples expression a feature above some level. Useful for removing lowly expressed features via the `subsetBySupport` wrapper.

Some `calc*` functions only work for a specfic level:

- `calcShape`: Quantify the shape of TCs using `shape*`-functions.
- `calcBidirectionality`: Count the number of samples showing bidirectional transcription. Useful for finding candidate enhancers via the `subsetByBidirectionality` wrapper.
- `calcComposition`: Calculate how much each TSSs contribute to gene expression. Useful for removing lowly expressed TSSs via the `subsetByComposition` wrapper.

The `cluster*`-functions can cluster CTSSs to find TSSs or enhancers:

- `clusterUnidirectionally`: Find unidirectional or Tag Clusters (TCs). Search threshold can be be found using `tuneTagClustering`. TCs can be modified using the `trim*`-functions.
- `clusterBidirectionally`: Find bidirectional clusters (BCs) for enhancer identification.

The `assign*`-functions can annotate CTSSs and clusters with transcript and genes models:

- `assignTxID`: Annotate clusters with transcript IDs.
- `assignTxType`: Annotate clusters based on their overlap with known transcripts, for example to determine whether a TSS is known or novel.
- `assignGeneID`: Annotate with gene IDs, for example prior to running quantifyGenes.

The `find*`-functions perform spatial analysis of clusters:

- `findLinks`: Finds nearby pairs of clusters and calculates correlation of expression between them. This can be used to find nearby TSSs-enhancer pairs that show similar expression.
- `findStretches`: Find groups of clusters along the genome. This can be used to find tightly spaced groups of enhancers, often refered to as "super enhancers".

Other groups of functions are 

- `check*`-functions for making sure objects are correctly formatted.
- `convert*`-functions convert CTSSs between different file formats.
- `bw*`-functions for checking BigWig-files.
- `swap*`-functions for manipulating `GRanges`-objects.
- `track*`-functions for genome browser visualization.
- `combine*`-functions for safe merging of different types of clusters. 
- `quick*`-functions are high-level wrappers for many other functions, intended to be used as single-line execution of the standard pipeline. 
- `utils*`-functions expose some of the inner workings of `CAGEfightR` and are mainly intended for expert users and developers.

## Pipeability

The majority of functions in `CAGEfightR` are _endomorphisms_, meaning they returned modified versions of the input objects. This often works by adding calculated values as new metadata columns, accesible via `rowData` or `mcols`.

While not used in this vignette, this means that CAGEfightR is highly compatible with the pipes from the `r BiocStyle::CRANpkg("magrittr")` package.

The main exceptions to pipeable functions this are the `quantify*`-functions, that instead summarize data between different levels.

# Detailed Introduction

The following section contains a detailed walkthrough of most of the functions in `CAGEfightR`, using the built-in dataset. To keep this vignette compact, the example dataset is extremely small - for a more realistic analysis of a full CAGE dataset using both `CAGEfightR` and additional packages, see `r BiocStyle::Biocpkg("CAGEWorkflow")`.

## CAGE Transcription Start Site (CTSS) level analysis

As shown in the introduction [Quick start for the impatient], the first step of a `CAGEfightR` analysis is import of CTSSs from BigWig-files with the `quantifyCTSSs` function. Rather than repeating this, we use the built-in `exampleCTSSs` object:

```{r exampleCTSSs, tidy=FALSE}
data(exampleCTSSs)
exampleCTSSs
```

This is a somewhat special `RangedSummarizedExperiment`: The assay is not a normal `matrix`, but rather a _sparse matrix_ (`dgCMatrix` from the `r BiocStyle::CRANpkg("Matrix")` package). Since CAGE data is inherently sparse (vast majority sites in the genome have no counts), storing CTSSs as a sparse matrix allows for much faster and memory efficient processing of data:

```{r dgCMatrix, tidy=FALSE}
head(assay(exampleCTSSs))
```

The ranges are stored as `GPos`, where all ranges a one basepair wide. Again, this is much more memory-efficient way of storing CTSSs:

```{r GPos, tidy=FALSE}
rowRanges(exampleCTSSs)
```

### Calculating pooled CTSSs

For clustering CTSSs, we first want to calculate the the overall CTSSs signal across all samples, called _pooled_ CTSSs. However, since the different samples have different library sizes, CTSS counts must first be normalized. The simplest way of doing this is to use Tags-Per-Million (TPM, not to be confused with Transcripts-Per-Million or TxPM used in RNA-Seq):

```{r calc, tidy=FALSE}
exampleCTSSs <- calcTPM(exampleCTSSs, inputAssay="counts", outputAssay="TPM", outputColumn="subsetTags")
```

`calcTPM` will calculate the total number of tags for each sample and store them in colData, and then scale counts into TPM and add them as a new assay:

```{r libSizes, tidy=FALSE}
# Library sizes
colData(exampleCTSSs)

# TPM values
head(assay(exampleCTSSs, "TPM"))
```

As this is just a subset of the original dataset, we instead use the total number tags from the the complete dataset, by specifying the name of the column in colData (Note that a warning is passed that we are overwritting the previous TPM assay):

```{r preCalcTPM, tidy=FALSE}
exampleCTSSs <- calcTPM(exampleCTSSs, 
                        inputAssay="counts", 
                        totalTags="totalTags", 
                        outputAssay="TPM")
head(assay(exampleCTSSs, "TPM"))
```

`calcPooled` will calculate pooled CTSSs by summing up TPM across samples for each CTSS and store it in the score-column:

```{r pooled, tidy=FALSE}
# Library sizes
exampleCTSSs <- calcPooled(exampleCTSSs, inputAssay="TPM")
rowRanges(exampleCTSSs)
```

### Calculating CTSS support to remove excess noise

In some cases you might have a very large number of and/or very noisy samples (For example due to poor RNA quality), which can lead to an increase in the number of single tags spread across the genome. To alleviate this issue, CTSSs appearing in only a single or few samples can be discarded. We refer to this as calculating the _support_: the number of samples expressing a feature above some threshold:

```{r support, tidy=FALSE}
# Count number of samples with MORE ( > ) than 0 counts:
exampleCTSSs <- calcSupport(exampleCTSSs, 
                            inputAssay="counts", 
                            outputColumn="support", 
                            unexpressed=0)
table(rowRanges(exampleCTSSs)$support)
```

The majority of CTSSs are only expressed in a single sample. We can discard these sites using `subset`, and then recalculate TPM values:

```{r subset, tidy=FALSE}
supportedCTSSs <- subset(exampleCTSSs, support > 1)
supportedCTSSs <- calcTPM(supportedCTSSs, totalTags="totalTags")
supportedCTSSs <- calcPooled(supportedCTSSs)
```
Note, `CAGEfightR` warned that it was overwritting columns: Another option would be to save the output as new columns. The `subsetBySupport` function wraps the common task of calling `calcSupport` and `subset`.

### Unidirectional (tag) clustering: Finding Transcription Start Sites (TSSs)

Once we have obtained pooled CTSSs, we can identify various types of clusters: Transcripts are rarely transcribed from just a single CTSS, but rather from a collection or cluster of nearby CTSSs corresponding to a single TSS.

The simplest way of doing this is to group nearby CTSSs on the same strand into Tag Clusters (TCs), which are likely candidates for real TSSs (although some post-filtering is almost always a good idea, see next section). `CAGEfightR` does this by a slice-reduce approach: It finds sites above some value (slice) and then merges nearby sites (reduce). In the simplest form this can be run as:

```{r naiveTC, tidy=FALSE}
simple_TCs <- clusterUnidirectionally(exampleCTSSs, 
                                     pooledCutoff=0, 
                                     mergeDist=20)
```

`clusterUnidirectionally` find TCs and outputs some summary statistics. We see that we have some very wide TCs (> 100 bp wide, in real datasets it's not uncommon to see > 1000 bp wide). This is often the result of a just few spread-out tags that link several major TCs, which does not represent the TSS structure very well. One way of dealing with this is to increase the the pooled cutoff for calling clusters. Another way is to first filter the CTSSs based on support:

```{r tuning, tidy=FALSE}
# Use a higher cutoff for clustering
higher_TCs <- clusterUnidirectionally(exampleCTSSs, 
                                     pooledCutoff=0.1, 
                                     mergeDist=20)

# Use CTSSs pre-filtered on support. 
prefiltered_TCs <- clusterUnidirectionally(supportedCTSSs, 
                                     pooledCutoff=0, 
                                     mergeDist=20)
```

Both approaches reduces the overall width of the TCs identified, in particular the most wide TCs. In practice, whether or not a higher pooled cutoff and/or prefiltering is used depends on how noisy a given dataset is. A large number of very wide clusters (> 1000 bp wide) and unusual location of TCs relative to known genes (See [Annotation with transcript models] below) could indicate an unstable tag clustering.

Now let's take a closer look at what's returned:

```{r TCanatomy, tidy=FALSE}
simple_TCs
```
The `GRanges` includes the chromosome, start and end positions of each TCs, as well as two other key values: The TC peak in the thick column: This the single position within the TC with the highest pooled TPM, and the sum of pooled TPM within the TC in the score column. In case you want to save TCs to a bed file, you can use the `export` function from the `r BiocStyle::Biocpkg("rtracklayer")` package.

### Bidirectional clustering: Finding Enhancers

CAGE is a unique technology in that it allows for the robust identification of enhancers by transcription of enhancer RNAs (eRNAs). Active enhancers produce weak but consistent bidirectional transcription of capped eRNAs, resulting in a characteristic CTSS pattern of two diverging peaks approximally 400 basepairs apart. A similar approach can be used for other 5'-end methods such as PRO-Cap.

CAGEfightR can identify this pattern by calculating a balance score ranging from 0 to 1, where 1 corresponds to perfectly divergent site (Technically, the balance score is the _Bhattacharyya coefficient_ measuring agreement with the "ideal" divergent site, see the `CAGEfightR` paper). Again, a slice-reduce approach can be use to identify invidividual enhancers based on the balance scores. We refer to this approach as _bidirectional clustering_ as opposed to the conventional _unidirectional clustering_ used to identify TSSs: and hence the name of the cluster functions: `clusterBidirectionally` and `clusterUnidirectionally`:

```{r bidirectionalClustering, tidy=FALSE}
BCs <- clusterBidirectionally(exampleCTSSs, balanceThreshold=0.95)
```

Let's look closer at the returned `GRanges`:

```{r enhancerAnatomy, tidy=FALSE}
BCs
```

The `GRanges` includes the chromosome, start and end positions of each Bidirectional Cluster (BC), as well as two other key values: the score column holds the sum of pooled CTSSs of the BC (on both strands) and the BC midpoint in the thick column: This is the maximally balanced site in the BC Again, the `export` function from the `r BiocStyle::Biocpkg("rtracklayer")` package can be used to export enhancers to a BED-file.

As balance here is solely defined on the pooled CTSSs, a useful filter is to make sure the BC is observed to be bidirectional in at least a single sample. Similarly to how we calculated support, we can calculate the sample-wise _bidirectionality_ of BCs:

```{r bidirectionality, tidy=FALSE}
# Calculate number of bidirectional samples
BCs <- calcBidirectionality(BCs, samples=exampleCTSSs)

# Summarize
table(BCs$bidirectionality)
```

Many BCs are not observed to be bidirectional in one or more samples. We can remove these using `subset` (The `subsetBySupport` function wraps the common task of calling `calcBidirectionality` and `subset`):

```{r subsetBidirectionality, tidy=FALSE}
enhancers <- subset(enhancers, bidirectionality > 0)
```

This bidirectional clustering approach identifies _any_ bidirectional site in the genome. This means that for example bidirectional promoters will also detected (given that they are sufficiently balanced). To remove these cases, annotation with transcript models can be used to remove bidirectional clusters overlapping known promoters and exons. This is described in the next section.

## Cluster level analysis

Once interesting clusters (unidirectional TSSs candidates and bidirectional enhancer candidates) have been identified, they can be quantified and annotated with transcript models. We show this functionality using the built-in example data:

```{r exampleClusters, tidy=FALSE}
# Load the example datasets
data(exampleCTSSs)
data(exampleUnidirectional)
data(exampleBidirectional)
```

### Quantifying expression at cluster level

To look at differential expression, we must quantify the expression of each TC in each sample (in almost all cases you want to quantify the raw CTSS counts). This can be done using the `quantifyClusters` function (The example datasets have already been quantified, so here we will re-quantify the clusters):

```{r quantifyClusters, tidy=FALSE}
requantified_TSSs <- quantifyClusters(exampleCTSSs,
                                      clusters=rowRanges(exampleUnidirectional),
                                      inputAssay="counts")
requantified_enhancers <- quantifyClusters(exampleCTSSs,
                                           clusters=rowRanges(exampleBidirectional),
                                           inputAssay="counts")
```

This returns a RangedSummarizedExperiment with clusters in rowRanges and a count matrix in assays.

### Removing weakly expressed clusters

We often wish to remove weakly expressed clusters. Similarly to CTSSs, a simple approach is to remove cluster based on counts using the `subsetBySupport` function:

```{r supportOnCounts, tidy=FALSE}
# Only keep BCs expressed in more than one sample
supported_enhancers <- subsetBySupport(exampleBidirectional,
                                       inputAssay="counts",
                                       unexpressed=0,
                                       minSamples=1)
```

Similarly, we can also first calculate TPM values for clusters, and then filter on TPM values:
```{r supportOnTPM, tidy=FALSE}
# Calculate TPM using pre-calculated total tags:
exampleUnidirectional <- calcTPM(exampleUnidirectional, 
                                 totalTags = "totalTags")

# Only TSSs expressed at more than 1 TPM in more than 2 samples
exampleUnidirectional <- subsetBySupport(exampleUnidirectional,
                                         inputAssay="TPM",
                                         unexpressed=1,
                                         minSamples=2)
```

### Annotation with transcript models

While CAGE can identify TSSs and enhancers completely independent of annotation, it is often useful to compare these to existing annotations. Bioconductor stores transcript models using the `TxDb` class from the `r BiocStyle::Biocpkg("GenomicFeatures")` package. There are multiple ways to obtain a `TxDb` object:

- Use the `TxDb`-objects included as Bioconductor packages: For this vignette we use the `r BiocStyle::Biocpkg("TxDb.Mmusculus.UCSC.mm9.knownGene")` package.
- Import a GTF or GFF3 file using the `makeTxDbFromGFF` function from `r BiocStyle::Biocpkg("GenomicFeatures")`.
- Use the `r BiocStyle::Biocpkg("AnnotationHub")` package to directly download `TxDb` objects for a wide range of organisms.
- Use `makeTxDbFromBiomart`,  `makeTxDbFromUCSC` or `makeTxDbFromEnsembl` from `r BiocStyle::Biocpkg("GenomicFeatures")` to create `TxDb`-objects from various online sources.

In case you really do not want to use a `TxDb` object, all annotation functions in `CAGEfightR` also accepts `GRanges` or `GRangesList` as input.

```{r txdb, tidy=FALSE}
library(TxDb.Mmusculus.UCSC.mm9.knownGene)
txdb <- TxDb.Mmusculus.UCSC.mm9.knownGene
txdb
```

First, we might simply inquire as to what transcripts overlaps our clusters, which is done via the `assignTxID` function:

```{r assignTxID, tidy=FALSE}
exampleUnidirectional <- assignTxID(exampleUnidirectional,
                                    txModels=txdb,
                                    outputColumn="txID")
```

Note, that a single TC can overlap multiple transcripts (names are separated with a `;`):

```{r multipleTxs, tidy=FALSE}
rowRanges(exampleUnidirectional)[5:6]
```

In many cases, we are not so much interested in what specific transcripts a cluster overlaps, but rather _where_ in a transcript a cluster lies - for example whether it is located at the annotated TSSs, in the 5'-UTR or in the CDS region. However, due to overlapping transcripts, these categories might overlap, for example a region might be an exon in one transcripts, but skipped in another due to alternative splicing. To get around this, `CAGEfightR` implements a hierachical annotation scheme (See the `CAGEfightR` paper for a detailed description), implemented in the `assignTxType` function:

```{r assignTxType, tidy=FALSE}
exampleUnidirectional <- assignTxType(exampleUnidirectional,
                                      txModels=txdb,
                                      outputColumn="txType")
```

The function returns a small summary of the annotation: At the top of the hierachy we have overlap with annotated promoter (+/- 100 basepairs from the annotated TSSs, with this distance being changeable when running the function), followed by proximal (-1000 upstream of the annotated TSS). Coding transcripts can be annotated as 5'-UTR, 3-'UTR, CDS and intron, while non-coding transcripts are simply annotated as exon or intron. At the bottom of the hierachy, clusters overlapping genes on the opposite strand are annotated as antisense. Finally, in case a cluster does not overlap any transcript, it is annotated as intergenic.

Highly expressed TSSs can be quite wide, and overlap many different categories. It can be useful to only annotate the TSSs peak rather than the the entire TSSs to obtain more representative annotations:

```{r swappedTxType, tidy=FALSE}
exampleUnidirectional <- assignTxType(exampleUnidirectional,
                                      txModels=txdb,
                                      outputColumn="peakTxType",
                                      swap="thick")
```

Annotation with transcript models are particular useful for enhancer detecting, since BCs might in some cases be very balanced bidirectional promoters. We can remove BCs overlapping known transcripts:

```{r enhancerTxType, tidy=FALSE}
# Annotate with TxTypes
exampleBidirectional <- assignTxType(exampleBidirectional,
                                     txModels=txdb,
                                     outputColumn="txType")

# Only keep intronic and intergenic enhancers
exampleBidirectional <- subset(exampleBidirectional,
                               txType %in% c("intron", "intergenic"))
```

Of course, this way of filtering relies on having accurate transcript models!

### Quantifying shape of Tag Clusters

We have already looked at two characteristics of Tag Clusters (TCs) in addition their genomic location: the expression level (score column) and TSSs peak (thick column). One can further describe TCs beyond these two measures. For example, it was found that mammalian TSSs can be divided into "sharp" or "broad" TSSs, by comparing the Interquartile Range (IQR). We refer to such a measure as a _shape statistic_ and `CAGEfightR` includes a few built-in functions for shape statistics (IQR, entropy) as well as an easy framework for implementing your own.

Let's see how this works by calculating the IQR for TSSs. First, we need to calculate pooled CTSS:
```{r calcIQR, tidy=FALSE}
# Recalculate pooled signal
exampleCTSSs <- calcTPM(exampleCTSSs, totalTags = "totalTags")
exampleCTSSs <- calcPooled(exampleCTSSs)

# Calculate shape
exampleUnidirectional <- calcShape(exampleUnidirectional,
                                   pooled=exampleCTSSs,
                                   outputColumn = "IQR",
                                   shapeFunction = shapeIQR,
                                   lower=0.25, upper=0.75)
```
A plot of the distribution of IQR values reveals the distinction between broad and sharp TSSs:
```{r histIQR, tidy=FALSE}
hist(rowRanges(exampleUnidirectional)$IQR,
     breaks=max(rowRanges(exampleUnidirectional)$IQR),
     xlim=c(0,100), 
     xlab = "IQR", 
     col="red")
```

`shapeEntropy` works in the same way. Advanced users may implement their own shape statistic by writing a new function:

```{r customShape, tidy=FALSE}
# Write a function that quantifies the lean of a TSS
shapeLean <- function(x, direction){
	# Coerce to normal vector
	x <- as.vector(x)
	
	# Find highest position:
	i <- which.max(x)
	
	# Calculate sum
	i_total <- sum(x)
	
	# Calculate lean fraction
	if(direction == "right"){
		i_lean <- sum(x[i:length(x)])
	}else if(direction == "left"){
		i_lean <- sum(x[1:i])
	}else{
		stop("direction must be left or right!")
	}
	
	# Calculate lean
	o <- i_lean / i_total
	
	# Return
	o
}

# Calculate lean statistics, 
# additional arguments can be passed to calcShape via "..."
exampleUnidirectional <- calcShape(exampleUnidirectional, 
                                   exampleCTSSs,
                                   outputColumn="leanRight", 
                                   shapeFunction=shapeLean,
                                   direction="right")

exampleUnidirectional <- calcShape(exampleUnidirectional, 
                                   exampleCTSSs,
                                   outputColumn="leanLeft", 
                                   shapeFunction=shapeLean,
                                   direction="left")
```

### Spatial analysis of clusters

Since CAGE provides both the precise location and expression of clusters, one can analyze how these two are related: Do features that are adjacent in genomic space also show the same expression patterns? The classic example is finding likely TSS-enhancer interaction candidates by looking for closely spaced TSSs and enhancers that have highly correlated expression. Another example is finding stretches of closely spaced enhancers called "super enhancers" that often behave differently that solitary enhancers.

The `findLinks`-function finds nearby pairs and calculates the correlation of their expression. In the simple case, all possible links (or pairs) between TCs can be found:

```{r naiveLinks, tidy=FALSE}
library(InteractionSet)
TC_pairs <- findLinks(exampleUnidirectional, 
                      inputAssay="TPM", 
                      maxDist=10000, 
                      method="kendall")

TC_pairs
```

The results are returned as a `GInteractions`-object from the `r BiocStyle::Biocpkg("InteractionSet")` package. In addition to the links themselves, the distance, correlation estimate and correlation p-value is calculated. The `findLinks`-function is fairly flexible and can be used to calculate other correlation measures (see the `?findLinks` help page for how to do this). For example, one might want to calculate Pearson correlations on log TPM values instead of Kendall correlations.

Instead of simply finding all links, one can only look at links connecting TSSs and enhancers, e.g. nearby TCs and BCs. To find these, we must first merge the two sets of clusters and mark that we consider the TCs the reference points:

```{r TCBClinks, tidy=FALSE}
# Mark the type of cluster
rowRanges(exampleUnidirectional)$clusterType <- "TSS"
rowRanges(exampleBidirectional)$clusterType <- "enhancer"

# Merge the dataset
colData(exampleBidirectional) <- colData(exampleUnidirectional)
SE <- combineClusters(object1=exampleUnidirectional, 
                      object2=exampleBidirectional,
                      removeIfOverlapping="object1")

# Mark that we consider TSSs as the reference points
rowRanges(SE)$clusterType <- factor(rowRanges(SE)$clusterType,
                                    levels=c("TSS", "enhancer"))

# Recalculate TPM values
SE <- calcTPM(SE, totalTags="totalTags")

# Find link between the groups:
TCBC_pairs <- findLinks(SE, 
                      inputAssay="TPM",
                      maxDist=10000, 
                      directional="clusterType",
                      method="kendall")

TCBC_pairs
```

When performing a directional analysis like this, the orientation between links is also calculated: In this case it is whether the enhancer is upstream or downstream of the TSS.

The `findStretches`-function can identify groups of closely spaced clusters, where all clusters are within a certain distance of another member. For example, to find super enhancer candidates, one can find stretches of closely spaced BCs:

```{r superEnhancersGR, tidy=FALSE}
stretches <- findStretches(exampleBidirectional, 
              inputAssay="counts",
              minSize=3,
              mergeDist=10000,
              method="spearman")
stretches
```

The location of all stretches with a minimum number of BCs (in this case 3) is returned as a `GRanges`. The number of clusters within the stretch and the average pairwise correlation (Spearman correlation of counts in this example) in the stretch is also returned. The revmap column can be used to extract the resulting stretches as a `GRangesList`:

```{r superEnhancersGRL, tidy=FALSE}
extractList(rowRanges(exampleBidirectional), stretches$revmap)
```

## Gene level analysis

CAGE can detect TSSs and enhancers completely independent of existing gene models. However many databases of functional annotation, such as GO and KEGG terms, are only available at gene level. One might need to compare CAGE data to existing RNA-Seq or Microarray data only available at the level of genes.

Another typical analysis is to look at Differential TSS Usage (DTU), sometimes refered to as alternative TSSs or promoter switches. Here the aim is to identify if genes utilize different TSSs under different conditions, independently of whether the overall gene expression changes.

### Annotation with gene models

In a similar fashion to transcript annotation described above [Annotation with transcript models], gene models are obtained via `TxDb` objects:

```{r geneSetup, tidy=FALSE}
# Load example TSS 
data(exampleUnidirectional)

# Keep only TCs expressed at more than 1 TPM in more than 2 samples:
exampleUnidirectional <- calcTPM(exampleUnidirectional, 
                                 totalTags = "totalTags")
exampleUnidirectional <- subsetBySupport(exampleUnidirectional,
                                         inputAssay="TPM",
                                         unexpressed=1,
                                         minSamples=2)

# Use the Bioconductor mm9 UCSC TxXb 
library(TxDb.Mmusculus.UCSC.mm9.knownGene)
txdb <- TxDb.Mmusculus.UCSC.mm9.knownGene
```

The `assignGeneID` function annotate ranges with gene IDs:

```{r geneModels, tidy=FALSE}
exampleUnidirectional <- assignGeneID(exampleUnidirectional,
                                      geneModels=txdb,
                                      outputColumn="geneID")
```

TSSs not overlappping any genes receive NA, and in the (usually rare) case of a TC overlapping multiple genes, the gene with the closest annotated TSS is chosen:

What type of gene ID is returned of course depends on the source of the `TxDb` object supplied. In this case, it is Entrez IDs, the most commonly used ID system in Bioconductor. Entrez IDs can be used to find the corresponding gene symbols using an `OrgDb` object:

```{r symbols, tidy=FALSE}
# Use Bioconductor OrgDb package
library(org.Mm.eg.db)
odb <- org.Mm.eg.db

# Match IDs to symbols
symbols <- mapIds(odb,
                  keys=rowRanges(exampleUnidirectional)$geneID,
                  keytype="ENTREZID",
                  column="SYMBOL")

# Add to object
rowRanges(exampleUnidirectional)$symbol <- as.character(symbols)
```

For most gene-level operations in `CAGEfightR` NAs (TCs not overlapping genes) are simply removed. If you wish to keep these TCs, you can relabel them as "Novel" genes via the `assignMissingID` function:

```{r assignMissing, tidy=FALSE}
exampleUnidirectional <- assignMissingID(exampleUnidirectional,
                                         outputColumn="symbol")
```

### Quantify expression at gene-level

Once TCs have been assigned to genes, TC expression can be summed up within genes to obtain a gene-level expression matrix via the `quantifyGenes` function:

```{r quantifyGenes, tidy=FALSE}
genelevel <- quantifyGenes(exampleUnidirectional, 
                           genes="geneID", 
                           inputAssay="counts")
```

This returns a `RangedSummarizedExperiment` with the same number of rows as genes. The ranges are returned as a `GRangesList` of the individual TSSs making up the expression of the genes:

```{r geneGRangesList, tidy=FALSE}
rowRanges(genelevel)
```

Gene-level values are accesible via the `rowData` function:

```{r rowData, tidy=FALSE}
rowData(genelevel)
```

The gene-level expression matrix can now be supplied to many other Bioconductor packages, including DESeq2, edgeR, limma, etc.

### Filtering clusters based on gene composition

When looking at Differential TSS Usage (DTU) we are interested in changes in the contribution of individual TCs to overall gene expression. Since CAGE can detect even very lowly expressed TSSs, it is common to see TSSs making up only a very small fraction of the total gene expression. Removing these TSSs can improve power and clarity of downstream analyses.

`CAGEfightR` can calculate the _composition_ value of intragenic TCs, defined as the number of samples expressing a TC at more than a certain fraction of total gene expression. This is implemented in the `calcComposition` function:

```{r calcComposition, tidy=FALSE}
# Remove TSSs not belonging to any genes
intragenicTSSs <- subset(exampleUnidirectional, !is.na(geneID))

# Calculate composition: 
# The number of samples expressing TSSs above 10% of the total gene expression.
intragenicTSSs <- calcComposition(intragenicTSSs,
                                  outputColumn="composition",
                                  unexpressed=0.1,
                                  genes="geneID")

# Overview of composition values:
table(rowRanges(intragenicTSSs)$composition)
```
We can see that many TCs makes up less than 10% in all samples. These can be removed with `subset`:

```{r subsetComposition, tidy=FALSE}
# Remove TSSs with a composition score less than 3
intragenicTSSs <- subset(intragenicTSSs, composition > 2)
```

The `subsetByComposition` function wraps the common task of calling `calcComposition` and `subset`. After filtering, the resulting expression matrix can be used with popular Bioconductor packages for DTU calling, such as DEXSeq, DRIMSeq, edgeR, limma, etc.

## Plotting CAGE data in a genome browser

[Zenbu](http://fantom.gsc.riken.jp/zenbu/) is an excellent online genome browser for visualizing CAGE data in relation to annotation in an interative manner. For producing figures (or possibly a very large number of figures) of specific genomic regions, it can be useful to use R to generate genome browser-like plots.

`CAGEfightR` can produce genome browser plots via the popular and extensive `r BiocStyle::Biocpkg("Gviz")` package. `CAGEfightR` provides functions for generating genome browser tracks for both CTSSs and clusters. For general generation and customization of `Gviz` plots we refer to the extensive `r BiocStyle::Biocpkg("Gviz")` manual. Below we include some basic examples of visualizing CAGE data.

First we load use the built-in datasets:

```{r GViz, tidy=FALSE}
library(Gviz)

data("exampleCTSSs")
data("exampleUnidirectional")
data("exampleBidirectional")
```

First we make a track of pooled CTSSs:

```{r builtCTSStrack, tidy=FALSE}
# Calculate pooled CTSSs
exampleCTSSs <- calcTPM(exampleCTSSs, totalTags="totalTags")
exampleCTSSs <- calcPooled(exampleCTSSs)

# Built the track
pooled_track <- trackCTSS(exampleCTSSs, name="CTSSs")
```
The returned object is a `DataTrack`, which we can plot a specific genomic region of:

```{r plotCTSStrack, tidy=FALSE}
# Plot the main TSS of the myob gene
plotTracks(pooled_track, from=74601950, to=74602100, chromosome="chr18")
```

Secondly, we make a track of clusters: This function can handle both TSSs and enhancers, so we first merge them into a single object:

```{r clusterTrack, tidy=FALSE}
# Remove columns
exampleUnidirectional$totalTags <- NULL
exampleBidirectional$totalTags <- NULL

# Combine TSSs and enhancers, discarding TSSs if they overlap enhancers
CAGEclusters <- combineClusters(object1=exampleUnidirectional, 
                                object2=exampleBidirectional, 
                                removeIfOverlapping="object1")

# Only keep features with more than 0 counts in more than 2 samples
CAGEclusters <- subsetBySupport(CAGEclusters, 
                                inputAssay = "counts", 
                                unexpressed=0, 
                                minSamples=2)

# Build track
cluster_track <- trackClusters(CAGEclusters, name="Clusters", col=NA)
```

The returned object is a `GeneRegionTrack`, which we can plot the same genomic region of:

```{r plotClustertrack, tidy=FALSE}
# Plot the main TSS of the myob gene
plotTracks(cluster_track, from=74601950, to=74602100, chromosome="chr18")
```

Of course, we want to combine several different tracks into a single overview. There is multiple ways of doing this, and the code below is just one such way:

```{r prettybrowser, tidy=FALSE}
# Genome axis tracks
axis_track <- GenomeAxisTrack()

# Transcript model track
library(TxDb.Mmusculus.UCSC.mm9.knownGene)
txdb <- TxDb.Mmusculus.UCSC.mm9.knownGene
tx_track <- GeneRegionTrack(txdb,
                            chromosome = "chr18",
                            name="Gene Models", 
                            col=NA, 
                            fill="bisque4", 
                            shape="arrow")

# Merge all tracks
all_tracks <- list(axis_track, tx_track, cluster_track, pooled_track)

# Plot the Hdhd2 gene
plotTracks(all_tracks, from=77182700, to=77184000, chromosome="chr18")

# Plot an intergenic enhancer
plotTracks(all_tracks, from=75582473, to=75582897, chromosome="chr18")
```

Finally we might one to zoom out even further and look at TSS-enhancer correlations across large distances in the genome. First we find links between TSSs and enhancers:

```{r prepareLinks, tidy=FALSE}
# Unstranded clusters are enhancers
rowRanges(CAGEclusters)$clusterType <- factor(ifelse(strand(CAGEclusters)=="*",
                                              "enhancer", "TSS"),
                                              levels=c("TSS", "enhancer"))

# Find links
links <- findLinks(CAGEclusters, 
                   inputAssay="counts", 
                   directional="clusterType",
                   method="kendall")

# Only look at positive correlation
links <- subset(links, estimate > 0)
```

Then we can plot the links using arches, scaling the height of the arches according to p-values:
```{r plotLinks, tidy=FALSE}
# Save as a track
all_tracks$links_track <- trackLinks(links, 
                          name="TSS-enhancer", 
                          col.interactions="black",
                          col.anchors.fill ="dimgray",
                          col.anchors.line = NA,
                          interaction.measure="p.value",
                          interaction.dimension.transform="log",
                          col.outside="grey")

# Plot region around 
plotTracks(all_tracks, 
           from=84255991-1000, 
           to=84255991+1000, 
           chromosome="chr18",
           sizes=c(1, 1, 1, 1, 2))
```

In this case, the upstream enhancer has similar expression to two intronic TSSs, but not the annotated TSS.

## Parallel execution

Currently, two functions can utilize multiple cores for computation, `quantifyCTSSs` and `findLinks`. The central one is `quantifyCTSSs`, which is usually the slowest and most memory consuming step of a `CAGEfightR` analysis. `quantifyCTSSs` automatically uses the default backend registered with the `r BiocStyle::Biocpkg("BiocParallel")` package. This can be changed in the following way:

```{r parallel, tidy=FALSE, eval=FALSE}
library(BiocParallel)

# Setup for parallel execution with 3 threads:
register(MulticoreParam(workers=3))

# Disable parallel execution
register(SerialParam())
```

# Session Info

```{r sessionInfo, tidy=FALSE}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/assign.R
\name{assignTxID}
\alias{assignTxID}
\alias{assignTxID,GenomicRanges,GenomicRanges-method}
\alias{assignTxID,RangedSummarizedExperiment,GenomicRanges-method}
\alias{assignTxID,GenomicRanges,TxDb-method}
\alias{assignTxID,RangedSummarizedExperiment,TxDb-method}
\title{Annotate ranges with transcript ID.}
\usage{
assignTxID(object, txModels, ...)

\S4method{assignTxID}{GenomicRanges,GenomicRanges}(object, txModels, outputColumn = "txID", swap = NULL)

\S4method{assignTxID}{RangedSummarizedExperiment,GenomicRanges}(object, txModels, ...)

\S4method{assignTxID}{GenomicRanges,TxDb}(
  object,
  txModels,
  outputColumn = "txID",
  swap = NULL,
  upstream = 1000,
  downstream = 0
)

\S4method{assignTxID}{RangedSummarizedExperiment,TxDb}(object, txModels, ...)
}
\arguments{
\item{object}{GRanges or RangedSummarizedExperiment: Ranges to be annotated.}

\item{txModels}{TxDb or GRanges: Transcript models via a TxDb, or manually
specified as a GRanges.}

\item{...}{additional arguments passed to methods.}

\item{outputColumn}{character: Name of column to hold txID values.}

\item{swap}{character or NULL: If not NULL, use another set of ranges
contained in object to calculate overlaps, for example peaks in the thick
column.}

\item{upstream}{integer: Distance to extend annotated promoter upstream.}

\item{downstream}{integer: Distance to extend annotated promoter downstream.}
}
\value{
object with txID added as a column in rowData (or mcols)
}
\description{
Annotate a set of ranges in a GRanges object with transcript IDs based on
their genic context. All overlapping transcripts are returned. Transcripts
are obtained from a TxDb object, or can manually supplied as a GRanges.
}
\examples{
data(exampleUnidirectional)

# Obtain transcript models from a TxDb-object:
library(TxDb.Mmusculus.UCSC.mm9.knownGene)
txdb <- TxDb.Mmusculus.UCSC.mm9.knownGene

# Assign txIDs
assignTxID(exampleUnidirectional,
           txModels=txdb,
           outputColumn='geneID')

# Assign txIDs using only TC peaks:
assignTxID(exampleUnidirectional,
             txModels=txdb,
             outputColumn='geneID',
             swap='thick')
}
\seealso{
Other Annotation functions: 
\code{\link{assignGeneID}()},
\code{\link{assignMissingID}()},
\code{\link{assignTxType}()}
}
\concept{Annotation functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/find.R
\name{findLinks}
\alias{findLinks}
\alias{findLinks,GRanges-method}
\alias{findLinks,RangedSummarizedExperiment-method}
\title{Find nearby pairs of clusters and calculate pairwise correlations.}
\usage{
findLinks(object, ...)

\S4method{findLinks}{GRanges}(object, maxDist = 10000L, directional = NULL)

\S4method{findLinks}{RangedSummarizedExperiment}(
  object,
  inputAssay,
  maxDist = 10000L,
  directional = NULL,
  corFun = stats::cor.test,
  vals = c("estimate", "p.value"),
  ...
)
}
\arguments{
\item{object}{GRanges or RangedSummarizedExperiment: Clusters, possibly with
expression for calculating correlations.}

\item{...}{additional arguments passed to methods or ultimately corFun.}

\item{maxDist}{integer: Maximum distance between links.}

\item{directional}{character: Name of a column in object holding a grouping
of the clusters. This must be a factor with two levels. The first level is
used as the basis for calculating orientation (see below).}

\item{inputAssay}{character: Name of assay holding expression values (if
object is a RangedSummarizedExperiment)}

\item{corFun}{function: Function for calculating pairwise correlations. See
notes for supplying custom functions.}

\item{vals}{character: Statistics extracted from the results produced by
corFun. See notes for supplying custom functions.}
}
\value{
A GInteractions holding the links, along with the distance between
  them and correlation estimate and p-value calculated from their expression.
  If a directional analysis was performed, the two anchors are always
  connecting members of the two classes and the orientation of the second
  anchor relative to the first is additionaly calculated (e.g. whether an
  enhancers is upstream or downstream of the TSS).
}
\description{
Finds all links or pairs of clusters within a certain distance of each other
and then calculates the correlation between them. The links found can be
restricted to only be between two classes, for example TSSs to enhancers.
}
\details{
A custom function for calculation correlations can be supplied by
  the user. The output of this function must be a named list or vector of
  numeric values. The names of the vals to be extracted should be supplied to
  vals.
}
\examples{
library(InteractionSet)

# Subset to highly expressed unidirectional clusters
TCs <- subset(exampleUnidirectional, score > 10)

# Find links within a certain distance
findLinks(TCs, inputAssay="counts", maxDist=10000L)

# To find TSS-to-enhancer type links, first merge the clusters:
colData(exampleBidirectional) <- colData(TCs)
rowRanges(TCs)$clusterType <- "TSS"
rowRanges(exampleBidirectional)$clusterType <- "Enhancer"
SE <- combineClusters(TCs, exampleBidirectional, removeIfOverlapping="object1")
rowRanges(SE)$clusterType <- factor(rowRanges(SE)$clusterType, levels=c("TSS", "Enhancer"))

# Calculate kendall correlations of TPM values:
SE <- calcTPM(SE, totalTags="totalTags")
findLinks(SE, inputAssay="TPM", maxDist=10000L, directional="clusterType", method="kendall")
}
\seealso{
Other Spatial functions: 
\code{\link{findStretches}()},
\code{\link{trackLinks}()}
}
\concept{Spatial functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/track.R
\name{trackClusters}
\alias{trackClusters}
\alias{trackClusters,GRanges-method}
\alias{trackClusters,RangedSummarizedExperiment-method}
\title{Create genome browser track of clusters.}
\usage{
trackClusters(object, ...)

\S4method{trackClusters}{GRanges}(
  object,
  plusColor = "cornflowerblue",
  minusColor = "tomato",
  unstrandedColor = "hotpink",
  ...
)

\S4method{trackClusters}{RangedSummarizedExperiment}(object, ...)
}
\arguments{
\item{object}{GRanges: GRanges with peaks in the thick-column.}

\item{...}{additional arguments passed on to GeneRegionTrack.}

\item{plusColor}{character: Color for plus-strand features.}

\item{minusColor}{character: Color for minus-strand features.}

\item{unstrandedColor}{character: Color for unstranded features.}
}
\value{
GeneRegionTrack-object.
}
\description{
Create a Gviz-track of clusters (unidirectional TCs or bidirectional
enhancers), where cluster strand and peak is indicated.
}
\examples{
library(Gviz)
data(exampleUnidirectional)

# Find some wide unidirectional clusters:
TCs <- subset(exampleUnidirectional, width >= 100)

# Create track
clusters_track <- trackClusters(TCs[1:2,], name='Tag clusters', col=NULL)

# Plot
plotTracks(clusters_track)

# See vignette for examples on how to combine multiple Gviz tracks
}
\seealso{
Other Genome Browser functions: 
\code{\link{trackBalance}()},
\code{\link{trackCTSS}()},
\code{\link{trackLinks}()}
}
\concept{Genome Browser functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/quantify.R
\name{quantifyClusters}
\alias{quantifyClusters}
\title{Quantify expression of clusters (TSSs or enhancers) by summing CTSSs within
clusters.}
\usage{
quantifyClusters(object, clusters, inputAssay = "counts", sparse = FALSE)
}
\arguments{
\item{object}{RangedSummarizedExperiment: CTSSs.}

\item{clusters}{GRanges: Clusters to be quantified.}

\item{inputAssay}{character: Name of assay holding expression values to be
quantified (usually counts).}

\item{sparse}{logical: If the input is a sparse matrix, TRUE will keep the
output matrix sparse while FALSE will coerce it into a normal matrix.}
}
\value{
RangedSummarizedExperiment with row corresponding to clusters.
  seqinfo and colData is copied over from object.
}
\description{
Quantify expression of clusters (TSSs or enhancers) by summing CTSSs within
clusters.
}
\examples{
# CTSSs stored in a RangedSummarizedExperiment:
data(exampleCTSS)

# Clusters to be quantified as a GRanges:
data(exampleUnidirectional)
clusters <- rowRanges(exampleUnidirectional)

# Quantify clusters:
quantifyClusters(exampleCTSSs, clusters)

# For exceptionally large datasets,
# the resulting count matrix can be left sparse:
quantifyClusters(exampleCTSSs, rowRanges(exampleUnidirectional), sparse=TRUE)
}
\seealso{
Other Quantification functions: 
\code{\link{quantifyCTSSs2}()},
\code{\link{quantifyCTSSs}()},
\code{\link{quantifyGenes}()}
}
\concept{Quantification functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/swap.R
\name{swapScores}
\alias{swapScores}
\title{Swap scores in SummarizedExperiment}
\usage{
swapScores(object, outputColumn = "score", inputAssay, sample)
}
\arguments{
\item{object}{SummarizedExperiment: CAGE-data}

\item{outputColumn}{character: Column in rowData to to hold swapped in
scores.}

\item{inputAssay}{character: Name of assay to take scores from.}

\item{sample}{character: Name of sample to take scores from.}
}
\value{
SummarizedExperiment with sample scores from inputAssay in rowRata.
}
\description{
Take scores for a specific sample and a specific assay and put them into
rowData.
}
\examples{
data(exampleCTSSs)
sample_names <- colnames(exampleCTSSs)

# Replace scores with values from the first sample:
x <- swapScores(exampleCTSSs, inputAssay='counts', sample=sample_names[1])
rowRanges(x)
}
\seealso{
Other Swapping functions: 
\code{\link{swapRanges}()}
}
\concept{Swapping functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/quick.R
\name{quickTSSs}
\alias{quickTSSs}
\title{Identify and quantify Transcription Start Sites (TSSs).}
\usage{
quickTSSs(object)
}
\arguments{
\item{object}{RangedSummarizedExperiment: Location and counts of CTSSs,
usually found by calling quantifyCTSSs.}
}
\value{
RangedSummarizedExperiment containing location and counts of TSSs
}
\description{
A convienient wrapper around calcTPM, calcPooled, tuneTagClustering,
clusterUnidirectionally and quantifyClusters.
}
\examples{
# See the CAGEfightR vignette for an overview!
}
\seealso{
Other Wrapper functions: 
\code{\link{quickEnhancers}()},
\code{\link{quickGenes}()}
}
\concept{Wrapper functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check.R
\name{checkCTSSs}
\alias{checkCTSSs}
\alias{checkCTSSs,ANY-method}
\alias{checkCTSSs,GRanges-method}
\alias{checkCTSSs,character-method}
\alias{checkCTSSs,GPos-method}
\alias{checkCTSSs,BigWigFile-method}
\title{Helper for checking files containing CTSSs}
\usage{
checkCTSSs(object)

\S4method{checkCTSSs}{ANY}(object)

\S4method{checkCTSSs}{GRanges}(object)

\S4method{checkCTSSs}{character}(object)

\S4method{checkCTSSs}{GPos}(object)

\S4method{checkCTSSs}{BigWigFile}(object)
}
\arguments{
\item{object}{BigWigFile, character, GRanges or GPos: Path to the file
storing CTSSs, or an already improted GRanges/GPos.}
}
\value{
TRUE if CTSSs are correctly  formatted, otherwise a (hopefully)
  informative error is thrown.
}
\description{
Checks whether a file (or GRanges/GPos) contains data formatted in the same
manner as CAGE Transcription Start Sites (CTSSs): Each basepair of the genome
is associated with a single integer count.
}
\note{
In the case that a character is supplied pointing to a file, checkCTSSs
  will not check any extensions, but simply try to read it using
  rtracklayer::import. This means that checkCTSSs can technically analyze
  BED-files, although CAGEfightR can only import CTSSs from BigWig or
  bedGraph files.
}
\examples{
if (.Platform$OS.type != "windows") {
# Load example data
data('exampleDesign')
bw_plus <- system.file('extdata',
                       exampleDesign$BigWigPlus,
                       package = 'CAGEfightR')
bw_plus <- BigWigFileList(bw_plus)

# Check raw file
checkCTSSs(bw_plus[[1]])

# Import first, then check
gr  <- import(bw_plus[[1]])
checkCTSSs(gr)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/swap.R
\name{swapRanges}
\alias{swapRanges}
\alias{swapRanges,GenomicRanges-method}
\alias{swapRanges,RangedSummarizedExperiment-method}
\title{Swap ranges in a GRanges.}
\usage{
swapRanges(object, ...)

\S4method{swapRanges}{GenomicRanges}(object, inputColumn = "thick", outputColumn = NULL)

\S4method{swapRanges}{RangedSummarizedExperiment}(object, ...)
}
\arguments{
\item{object}{GRanges or RangedSummarizedExperiment: Primary ranges to be
swapped out.}

\item{...}{additional arguments passed to methods.}

\item{inputColumn}{character: Name of column holding IRanges to be swapped
in.}

\item{outputColumn}{character or NULL: Name of column to hold swapped out
ranges, if NULL original ranges are not saved.}
}
\value{
GRanges with inputColumn swapped in as ranges.
}
\description{
Swap out the range of a GRanges-object with another IRanges-object stored
inside the same object. I.e., swapping cluster widths with cluster peaks.
}
\examples{
data(exampleUnidirectional)
gr <- rowRanges(exampleUnidirectional)

# Swap in peaks as main ranges
peaks <- swapRanges(gr)
head(width(gr))
head(width(peaks))

# swapRanges() can also be directly called on a RangedSummarizedExperiment:
swapRanges(exampleUnidirectional)

# The original can optionally be saved in the output object
swapRanges(gr, outputColumn = 'swapped')
}
\seealso{
Other Swapping functions: 
\code{\link{swapScores}()}
}
\concept{Swapping functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{utilsAggregateRows}
\alias{utilsAggregateRows}
\alias{utilsAggregateRows,matrix-method}
\alias{utilsAggregateRows,dgCMatrix-method}
\title{Utility: Aggregate rows}
\usage{
utilsAggregateRows(x, group, drop = TRUE, sparse = FALSE)

\S4method{utilsAggregateRows}{matrix}(x, group, drop = TRUE, sparse = FALSE)

\S4method{utilsAggregateRows}{dgCMatrix}(x, group, drop = TRUE, sparse = FALSE)
}
\arguments{
\item{x}{matrix or dgCMatrix: Matrix to be aggregated.}

\item{group}{factor: Grouping, can cannot NAs which will be discarded.}

\item{drop}{logical: Whether to drop unused levels (TRUE) or keep assign them
0 (FALSE).}

\item{sparse}{logical: Whether output should be coerced to a dense matrix.}
}
\value{
matrix (or dgCMatrix if sparse=TRUE)
}
\description{
Used by quantifyClusters and quantifyGenes. Wrapper around rowsum with a few
improvements: 1) Handles dgCMatrix 2) Suppresses warnings from and discards
NAs in grouping 3) Checks if output can be coerced to integer (useful when
aggregating a dgCMatrix), 4) For the dgCMatrix case, has the option to keep
unused levels and output a sparse matrix.
}
\examples{
library(Matrix)
data("exampleCTSSs")
data("exampleUnidirectional")

# Sparse and dense examples
sparse_matrix <- assay(exampleCTSSs)
dense_matrix <- as(sparse_matrix, "matrix")

# Groupings
grp <- findOverlaps(query = exampleCTSSs,
                  subject = exampleUnidirectional,
                  select="arbitrary")

# Aggregate rows and compare
sparse_res <- utilsAggregateRows(sparse_matrix, grp)
dense_res <- utilsAggregateRows(dense_matrix, grp)
all(sparse_res == dense_res)

# Note that storage type was converted to integers!
storage.mode(sparse_res)
storage.mode(dense_res)

# You can also elect to keep a sparse representation
utilsAggregateRows(sparse_matrix, grp, sparse = TRUE)

#### Examples with unused levels ####

# Silly example
dense_mat <- replicate(5, runif(10))
sparse_mat <- as(dense_mat, "dgCMatrix")
fct_unused <- factor(c(1, 1, NA, NA, 3, 3, NA, NA, 5, 5), levels=1:5)

# The default is to drop unused levels
utilsAggregateRows(dense_mat, fct_unused, drop=TRUE)
utilsAggregateRows(sparse_mat, fct_unused, drop=TRUE)

# For dgCMatrix, one can elect to retain these:
utilsAggregateRows(sparse_mat, fct_unused, drop=FALSE)

# For matrix, a warning is produced if either drop or sparse is requested
utilsAggregateRows(dense_mat, fct_unused, drop=FALSE)
utilsAggregateRows(dense_mat, fct_unused, sparse=TRUE)
}
\seealso{
Other Utility functions: 
\code{\link{utilsDeStrand}()},
\code{\link{utilsScoreOverlaps}()},
\code{\link{utilsSimplifyTxDb}()}
}
\concept{Utility functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/quick.R
\name{quickEnhancers}
\alias{quickEnhancers}
\title{Identify and quantify enhancers.}
\usage{
quickEnhancers(object)
}
\arguments{
\item{object}{RangedSummarizedExperiment: Location and counts of CTSSs,
usually found by calling quantifyCTSSs.}
}
\value{
RangedSummarizedExperiment containing location and counts of
  enhancers.
}
\description{
A convienient wrapper around clusterBidirectionally, subsetByBidirectionality
and quantifyClusters.
}
\examples{
# See the CAGEfightR vignette for an overview!
}
\seealso{
Other Wrapper functions: 
\code{\link{quickGenes}()},
\code{\link{quickTSSs}()}
}
\concept{Wrapper functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bw.R
\name{bwValid}
\alias{bwValid}
\alias{bwValid,BigWigFile-method}
\alias{bwValid,BigWigFileList-method}
\title{Check if BigWig-files are valid.}
\usage{
bwValid(object)

\S4method{bwValid}{BigWigFile}(object)

\S4method{bwValid}{BigWigFileList}(object)
}
\arguments{
\item{object}{BigWigFile or BigWigFileList}
}
\value{
TRUE, if any tests fails an error is raised.
}
\description{
Checks if a BigWigFile or BigWigFileList is composed of readable files with
the proper .bw extension.
}
\examples{
# Use the BigWig-files included with the package:
data('exampleDesign')
bw_plus <- system.file('extdata', exampleDesign$BigWigPlus,
                       package = 'CAGEfightR')

# Create a named BigWigFileList-object with names
bw_plus <- BigWigFileList(bw_plus)
names(bw_plus) <- exampleDesign$Name

# Check a single BigWigFile:
bwValid(bw_plus[[1]])

# Check the entire BigWigFileList:
bwValid(bw_plus)
}
\seealso{
Other BigWig functions: 
\code{\link{bwCommonGenome}()},
\code{\link{bwGenomeCompatibility}()}
}
\concept{BigWig functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/example.R
\docType{data}
\name{exampleDesign}
\alias{exampleDesign}
\alias{exampleCTSSs}
\alias{exampleUnidirectional}
\alias{exampleBidirectional}
\alias{exampleGenes}
\title{Example CAGE Data}
\format{
Example data from various stages of CAGEfightR: \describe{
  \item{exampleDesign}{DataFrame: Description of samples, including .bw
  filenames} \item{exampleCTSS}{RangedSummarizedExperiment: CTSSs}
  \item{exampleUnidirectional}{RangedSummarizedExperiment: Unidirectional or
  Tag Clusters}
  \item{exampleBidirectionalCluster}{RangedSummarizedExperiment:
  Bidirectional clusters} \item{exampleGenes}{RangedSummarizedExperiment:
  Genes} }

An object of class \code{RangedSummarizedExperiment} with 41256 rows and 3 columns.

An object of class \code{RangedSummarizedExperiment} with 21008 rows and 3 columns.

An object of class \code{RangedSummarizedExperiment} with 377 rows and 3 columns.

An object of class \code{RangedSummarizedExperiment} with 127 rows and 3 columns.
}
\source{
\url{http://pubs.acs.org/doi/abs/10.1021/acsnano.6b07533}
}
\usage{
exampleDesign

exampleCTSSs

exampleUnidirectional

exampleBidirectional

exampleGenes
}
\description{
Subset of the CAGE dataset from the paper 'Identification of Gene
Transcription Start Sites and Enhancers Responding to Pulmonary Carbon
Nanotube Exposure in Vivo'. CTSS data from subsets of chr18 and chr19 across
3 mouse (mm9 ) samples are included. Datasets can be loaded with the data
function.
}
\examples{
data(exampleDesign)
data(exampleCTSSs)
data(exampleUnidirectional)
data(exampleBidirectional)
data(exampleGenes)
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bam.R
\name{convertBAM2BigWig}
\alias{convertBAM2BigWig}
\title{Extract CTSSs from BAM-files (EXPERIMENTAL)}
\usage{
convertBAM2BigWig(input, outputPlus, outputMinus, minLength = 1L, ...)
}
\arguments{
\item{input}{character: Path to input BAM-file}

\item{outputPlus}{character: Path to output BigWig-file holding CTSSs on the
plus strand.}

\item{outputMinus}{character: Path to output BigWig-file holding CTSSs on the
minus strand.}

\item{minLength}{integer: Minimum length of mapped reads.}

\item{...}{Additional arguments passed to rtracklayer::import. This will
often include a ScanBamParam}
}
\value{
Number of CTSSs/Tags returned invisibly.
}
\description{
Function for converting mapped reads in BAM-files to CAGE Transcription Start
Sites (CTSSs) in BigWig-files. Currently, this function will simply load a
(single-end) BAM-file (respecting a supplied ScanBamParam), optionally remove
short tags, and count the number of 5'-ends at each bp. Note, the BAM-file is
loaded as a single object, so you must be able to keep at least one complete
BAM-file in RAM.
}
\note{
WARNING: This function is experimental, has not been thoroughly tested,
  and will most likely significantly change in upcoming CAGEfightR version.
  For comments/question please go to  the CAGEfightR github page.
}
\examples{
# TBA
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/calc.R
\name{calcTotalTags}
\alias{calcTotalTags}
\title{Calculate the total number of CAGE tags across samples.}
\usage{
calcTotalTags(object, inputAssay = "counts", outputColumn = "totalTags")
}
\arguments{
\item{object}{RangedSummarizedExperiment: CAGE data quantified at CTSS,
cluster or gene-level.}

\item{inputAssay}{character: Name of assay holding input expression values.}

\item{outputColumn}{character: Name of column in colData to hold number of
total tags.}
}
\value{
object with total tags per library added as a column in
  colData.
}
\description{
For each CAGE library, calculate the total number of tags.
}
\examples{
data(exampleUnidirectional)
calcTotalTags(exampleUnidirectional)
}
\seealso{
Other Calculation functions: 
\code{\link{calcBidirectionality}()},
\code{\link{calcComposition}()},
\code{\link{calcPooled}()},
\code{\link{calcShape}()},
\code{\link{calcSupport}()},
\code{\link{calcTPM}()},
\code{\link{subsetByBidirectionality}()},
\code{\link{subsetByComposition}()},
\code{\link{subsetBySupport}()}
}
\concept{Calculation functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/subsetBy.R
\name{subsetBySupport}
\alias{subsetBySupport}
\title{Subset by support across samples}
\usage{
subsetBySupport(
  object,
  inputAssay = "counts",
  outputColumn = "support",
  unexpressed = 0,
  minSamples = 1
)
}
\arguments{
\item{object}{RangedSummarizedExperiment: CAGE data quantified at CTSS,
cluster or gene-level.}

\item{inputAssay}{character: Name of assay holding input expression values.}

\item{outputColumn}{character: Name of column in rowRanges to hold support
values.}

\item{unexpressed}{numeric: Support will be calculated based on features
larger than this cutoff.}

\item{minSamples}{numeric: Only features with support in more than this
number of samples will be kept.}
}
\value{
RangedSummarizedExperiment with support added as a column in
  rowRanges and features with less support than minSamples removed.
}
\description{
A convienient wrapper around calcSupport and subset.
}
\examples{
data(exampleBidirectional)

# Keep clusters with at least one tag in two samples
subsetBySupport(exampleBidirectional)

# Keep clusters with at least two tags in four samples
subsetBySupport(exampleBidirectional, unexpressed=1, minSamples=2)
}
\seealso{
Other Subsetting functions: 
\code{\link{subsetByBidirectionality}()},
\code{\link{subsetByComposition}()}

Other Calculation functions: 
\code{\link{calcBidirectionality}()},
\code{\link{calcComposition}()},
\code{\link{calcPooled}()},
\code{\link{calcShape}()},
\code{\link{calcSupport}()},
\code{\link{calcTPM}()},
\code{\link{calcTotalTags}()},
\code{\link{subsetByBidirectionality}()},
\code{\link{subsetByComposition}()}
}
\concept{Calculation functions}
\concept{Subsetting functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/track.R
\name{trackCTSS}
\alias{trackCTSS}
\alias{trackCTSS,GRanges-method}
\alias{trackCTSS,RangedSummarizedExperiment-method}
\alias{trackCTSS,GPos-method}
\title{Create Genome Browser track of CTSSs.}
\usage{
trackCTSS(object, ...)

\S4method{trackCTSS}{GRanges}(object, plusColor = "cornflowerblue", minusColor = "tomato", ...)

\S4method{trackCTSS}{RangedSummarizedExperiment}(object, ...)

\S4method{trackCTSS}{GPos}(object, ...)
}
\arguments{
\item{object}{GenomicRanges or RangedSummarizedExperiment: Ranges with CTSSs
in the score column.}

\item{...}{additional arguments passed on to DataTrack.}

\item{plusColor}{character: Color for plus-strand coverage.}

\item{minusColor}{character: Color for minus-strand coverage.}
}
\value{
DataTrack-object.
}
\description{
Create a Gviz-track of CTSSs, where Plus/minus strand signal is shown
positive/negative. This representation makes it easy to identify
bidirectional peaks.
}
\examples{
library(Gviz)
data(exampleCTSSs)
data(exampleUnidirectional)
data(exampleBidirectional)

# Example uni- and bidirectional clusters
TC <- rowRanges(subset(exampleUnidirectional, width>=100)[3,])
BC <- rowRanges(exampleBidirectional[3,])

# Create pooled track
subsetOfCTSSs <- subsetByOverlaps(rowRanges(exampleCTSSs), c(BC, TC, ignore.mcols=TRUE))
pooledTrack <- trackCTSS(subsetOfCTSSs)

# Plot
plotTracks(pooledTrack, from=start(TC)-100, to=end(TC)+100,
           chromosome=seqnames(TC), name='TC')
plotTracks(pooledTrack, from=start(BC)-100, to=end(BC)+100,
           chromosome=seqnames(BC), name='BC')

# See vignette for examples on how to combine multiple Gviz tracks
}
\seealso{
Other Genome Browser functions: 
\code{\link{trackBalance}()},
\code{\link{trackClusters}()},
\code{\link{trackLinks}()}
}
\concept{Genome Browser functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/convert.R
\name{convertGRanges2GPos}
\alias{convertGRanges2GPos}
\title{Convert GRanges with scores to GPos}
\usage{
convertGRanges2GPos(object)
}
\arguments{
\item{object}{GRanges object with a score column}
}
\value{
GPos with score column
}
\description{
Converts a GRanges to a GPos, correctly expanding the score column. This is
useful is nearby CTSSs with the same count are grouped in the same range (see
example).
}
\examples{
# Example GRanges
gr <- GRanges(Rle(c("chr2", "chr2", "chr3", "chr4")),
              IRanges(start=c(1, 10, 5, 3),
              end=c(5L, 10L, 5L, 4L)),
              strand="+",
              score=c(2, 1, 3, 11))

# Expand to proper GPos / CTSS format:
gp <- convertGRanges2GPos(gr)

# Double check that the total number of counts remains the same
stopifnot(sum(score(gr) * width(gr)) == sum(score(gp)))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/trimTo.R
\name{trimToPercentiles}
\alias{trimToPercentiles}
\alias{trimToPercentiles,GRanges,GRanges-method}
\alias{trimToPercentiles,GRanges,GPos-method}
\alias{trimToPercentiles,RangedSummarizedExperiment,GenomicRanges-method}
\alias{trimToPercentiles,GRanges,RangedSummarizedExperiment-method}
\alias{trimToPercentiles,RangedSummarizedExperiment,RangedSummarizedExperiment-method}
\title{Trim width of TCs to expression percentiles}
\usage{
trimToPercentiles(object, pooled, ...)

\S4method{trimToPercentiles}{GRanges,GRanges}(object, pooled, percentile = 0.1, symmetric = FALSE)

\S4method{trimToPercentiles}{GRanges,GPos}(object, pooled, ...)

\S4method{trimToPercentiles}{RangedSummarizedExperiment,GenomicRanges}(object, pooled, ...)

\S4method{trimToPercentiles}{GRanges,RangedSummarizedExperiment}(object, pooled, ...)

\S4method{trimToPercentiles}{RangedSummarizedExperiment,RangedSummarizedExperiment}(object, pooled, ...)
}
\arguments{
\item{object}{GenomicRanges or RangedSummarizedExperiment: TCs to be trimmed.}

\item{pooled}{GenomicRanges or RangedSummarizedExperiment: CTSS coverage.}

\item{...}{additional arguments passed to methods.}

\item{percentile}{numeric: Fraction of expression to remove from TCs.}

\item{symmetric}{logical: Whether to trim the same amount from both edges of
the TC (TRUE) or always trim from the least expressed end (FALSE).}
}
\value{
GRanges with trimmed TCs, including recalculated peaks and scores.
}
\description{
Given a set of TCs and genome-wide CTSS coverage, reduce the width of TC
until a certain amount of expression has been removed.
}
\examples{
data(exampleCTSSs)
data(exampleBidirectional)

# Calculate pooled CTSSs
exampleCTSSs <- calcTPM(exampleCTSSs, totalTags='totalTags')
exampleCTSSs <- calcPooled(exampleCTSSs)

# Choose a few wide clusters:
TCs <- subset(exampleUnidirectional, width >= 100)

# Symmetric trimming (same percentage from each side):
TCs_sym <- trimToPercentiles(TCs, pooled=exampleCTSSs, symmetric=FALSE)

# Assymmetric trimming (always trim from lowest side):
TCs_asym <- trimToPercentiles(TCs, pooled=exampleCTSSs, symmetric=TRUE)

# Compare the two results sets of widths:
summary(width(TCs_sym) - width(TCs_asym))
}
\seealso{
Other Clustering functions: 
\code{\link{clusterBidirectionally}()},
\code{\link{clusterUnidirectionally}()},
\code{\link{trimToPeak}()},
\code{\link{tuneTagClustering}()}

Other Trimming functions: 
\code{\link{trimToPeak}()}
}
\concept{Clustering functions}
\concept{Trimming functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/enhancers.R
\name{clusterBidirectionally}
\alias{clusterBidirectionally}
\alias{clusterBidirectionally,GRanges-method}
\alias{clusterBidirectionally,GPos-method}
\alias{clusterBidirectionally,RangedSummarizedExperiment-method}
\title{Bidirectional clustering of pooled CTSSs.}
\usage{
clusterBidirectionally(object, ...)

\S4method{clusterBidirectionally}{GRanges}(
  object,
  window = 201,
  balanceThreshold = 0.95,
  balanceFun = balanceBC
)

\S4method{clusterBidirectionally}{GPos}(object, ...)

\S4method{clusterBidirectionally}{RangedSummarizedExperiment}(object, ...)
}
\arguments{
\item{object}{GenomicRanges or RangedSummarizedExperiment: Pooled CTSSs
stored in the score column.}

\item{...}{additional arguments passed to methods.}

\item{window}{integer: Width of sliding window used for calculating window
sums.}

\item{balanceThreshold}{numeric: Minimum value of the BC to use for
slice-reduce, a value of 1 corresponds to perfectly balanced sites.}

\item{balanceFun}{function: Advanced users may supply their own function for
calculating the balance score instead of the the default balanceBC. See
details for instructions.}
}
\value{
GRanges with bidirectional sites: Minimum width is 1 + 2*window, TPM
  sum (on both strands) in the score column, maximal bidirectional site in
  the thick column and maximum balance in the balance column.
}
\description{
Finds sites with (balanced and divergent) bidirectional transcription using
sliding windows of summed coverage: The Bhattacharyya coefficient (BC) is
used to quantify depature from a perfectly balanced site, and a slice-reduce
is used to identify sites.
}
\examples{
\dontrun{
data(exampleCTSSs)

# Calculate pooledTPM, using supplied number of total tags
exampleCTSSs <- calcTPM(exampleCTSSs,
                        inputAssay='counts',
                        outputAssay='TPM',
                        totalTags='totalTags')
exampleCTSSs <- calcPooled(exampleCTSSs, inputAssay='TPM')

# Cluster using defaults: balance-treshold of 199 and window of 199 bp:
clusterBidirectionally(exampleCTSSs)

# Use custom thresholds:
clusterBidirectionally(exampleCTSSs, balanceThreshold=0.99, window=101)
}
}
\seealso{
Other Clustering functions: 
\code{\link{clusterUnidirectionally}()},
\code{\link{trimToPeak}()},
\code{\link{trimToPercentiles}()},
\code{\link{tuneTagClustering}()}
}
\concept{Clustering functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/subsetBy.R
\name{subsetByComposition}
\alias{subsetByComposition}
\title{Subset by composition across samples}
\usage{
subsetByComposition(
  object,
  inputAssay = "counts",
  outputColumn = "composition",
  unexpressed = 0.1,
  genes = "geneID",
  minSamples = 1
)
}
\arguments{
\item{object}{RangedSummarizedExperiment: CAGE data quantified at CTSS,
cluster or gene-level.}

\item{inputAssay}{character: Name of assay holding input expression values.}

\item{outputColumn}{character: Name of column in rowRanges to hold
composition values.}

\item{unexpressed}{numeric: Composition will be calculated based on features
larger than this cutoff.}

\item{genes}{character: Name of column in rowData holding genes (NAs are not
allowed.)}

\item{minSamples}{numeric: Only features with composition in more than this
number of samples will be kept.}
}
\value{
RangedSummarizedExperiment with composition values added as a column
  in rowData and features with less composition than minSamples removed.
}
\description{
A convenient wrapper around calcComposition and subset.
}
\examples{
data(exampleUnidirectional)

# Annotate clusters with geneIDs:
library(TxDb.Mmusculus.UCSC.mm9.knownGene)
txdb <- TxDb.Mmusculus.UCSC.mm9.knownGene

exampleUnidirectional <- assignGeneID(exampleUnidirectional,
                                      geneModels=txdb,
                                      outputColumn='geneID')
exampleUnidirectional <- subset(exampleUnidirectional, !is.na(geneID))

# Keep only clusters more than 10\% in more than one sample:
calcComposition(exampleUnidirectional)

# Keep only clusters more than 5\% in more than 2 samples:
subsetByComposition(exampleUnidirectional, unexpressed = 0.05, minSamples=2)
}
\seealso{
Other Subsetting functions: 
\code{\link{subsetByBidirectionality}()},
\code{\link{subsetBySupport}()}

Other Calculation functions: 
\code{\link{calcBidirectionality}()},
\code{\link{calcComposition}()},
\code{\link{calcPooled}()},
\code{\link{calcShape}()},
\code{\link{calcSupport}()},
\code{\link{calcTPM}()},
\code{\link{calcTotalTags}()},
\code{\link{subsetByBidirectionality}()},
\code{\link{subsetBySupport}()}
}
\concept{Calculation functions}
\concept{Subsetting functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/shape.R
\name{shapeMean}
\alias{shapeMean}
\title{Shape statistic: Mean}
\usage{
shapeMean(x)
}
\arguments{
\item{x}{numeric Rle vector: Coverage series.}
}
\value{
Numeric
}
\description{
Calculates the mean of a vector.
}
\examples{
# Hypothetical shard/broad clusters:
x_sharp <- Rle(c(1,1,1,4,5,2,1,1))
x_broad <- Rle(c(1,2,3,5,4,3,2,1))

# Calculate mean
shapeMean(x_sharp)
shapeMean(x_broad)

# See calcShape for more usage examples
}
\seealso{
Other Shape functions: 
\code{\link{calcShape}()},
\code{\link{shapeEntropy}()},
\code{\link{shapeIQR}()}
}
\concept{Shape functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/quantify.R
\name{quantifyCTSSs2}
\alias{quantifyCTSSs2}
\title{Quantify CAGE Transcriptions Start Sites (CTSSs)}
\usage{
quantifyCTSSs2(
  plusStrand,
  minusStrand,
  design = NULL,
  genome = NULL,
  tileWidth = 100000000L
)
}
\arguments{
\item{plusStrand}{BigWigFileList: BigWig files with plus-strand CTSS data.}

\item{minusStrand}{BigWigFileList: BigWig files with minus-strand CTSS data.}

\item{design}{DataFrame or data.frame: Additional information on samples.}

\item{genome}{Seqinfo: Genome information. If NULL the smallest common genome
will be found using bwCommonGenome.}

\item{tileWidth}{integer: Size of tiles to parallelize over.}
}
\value{
RangedSummarizedExperiment, where assay is a sparse matrix
  (dgCMatrix) of CTSS counts..
}
\description{
This function reads in CTSS count data from a series of BigWig-files and
returns a CTSS-by-library count matrix. For efficient processing, the count
matrix is stored as a sparse matrix (dgCMatrix).
}
\examples{
\dontrun{
# Load the example data
data('exampleDesign')
# Use the BigWig-files included with the package:
bw_plus <- system.file('extdata', exampleDesign$BigWigPlus,
                       package = 'CAGEfightR')
bw_minus <- system.file('extdata', exampleDesign$BigWigMinus,
                        package = 'CAGEfightR')

# Create two named BigWigFileList-objects:
bw_plus <- BigWigFileList(bw_plus)
bw_minus <- BigWigFileList(bw_minus)
names(bw_plus) <- exampleDesign$Name
names(bw_minus) <- exampleDesign$Name

# Quantify CTSSs, by default this will use the smallest common genome:
CTSSs <- quantifyCTSSs(plusStrand=bw_plus,
                       minusStrand=bw_minus,
                       design=exampleDesign)

# Alternatively, a genome can be specified:
si <- seqinfo(bw_plus[[1]])
si <- si['chr18']
CTSSs <- quantifyCTSSs(plusStrand=bw_plus,
                       minusStrand=bw_minus,
                       design=exampleDesign,
                       genome=si)

# Quantification can be speed up by using multiple cores:
library(BiocParallel)
register(MulticoreParam(workers=3))
CTSSs <- quantifyCTSSs(plusStrand=bw_plus,
                       minusStrand=bw_minus,
                       design=exampleDesign,
                       genome=si)
}
}
\seealso{
Other Quantification functions: 
\code{\link{quantifyCTSSs}()},
\code{\link{quantifyClusters}()},
\code{\link{quantifyGenes}()}
}
\concept{Quantification functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/combine.R
\name{combineClusters}
\alias{combineClusters}
\alias{combineClusters,RangedSummarizedExperiment,RangedSummarizedExperiment-method}
\title{Combine two CAGE experiments.}
\usage{
combineClusters(object1, object2, ...)

\S4method{combineClusters}{RangedSummarizedExperiment,RangedSummarizedExperiment}(object1, object2, removeIfOverlapping = "none")
}
\arguments{
\item{object1}{RangedSummarizedExperiment: First experiment to be combined.}

\item{object2}{RangedSummarizedExperiment: First experiment to be combined.}

\item{...}{arguments passed to methods.}

\item{removeIfOverlapping}{character: Whether to keep overlapping ranges
('none') or discard from either the first ('object1') or second ('object2')
experiment.}
}
\value{
RangedSummarizedExperiment with merged and sorted ranges (colData and
  metadata are carried over unchanged).
}
\description{
This function can safely combine two CAGE experiments, for example TCs and
enhancers, for later analysis, by making sure no ranges in the final object
are overlapping.
}
\examples{
data(exampleUnidirectional)
data(exampleBidirectional)

# Clusters must have identical colData to be combined:
exampleUnidirectional$totalTags <- NULL

# Combine, keeping potential overlaps
combineClusters(object1=exampleUnidirectional, object2=exampleBidirectional)

# If features overlap, keep only from object1
combineClusters(object1=exampleUnidirectional, object2=exampleBidirectional,
   removeIfOverlapping='object2')

# If features overlap, keep only from object2
combineClusters(object1=exampleUnidirectional, object2=exampleBidirectional,
   removeIfOverlapping='object1')
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{utilsScoreOverlaps}
\alias{utilsScoreOverlaps}
\title{Utility: Counting overlaps taking into account scores}
\usage{
utilsScoreOverlaps(query, subject, ...)
}
\arguments{
\item{query}{same as findOverlaps/countOverlaps}

\item{subject}{same as findOverlaps/countOverlaps}

\item{...}{additional arguments passed to findOverlaps}
}
\value{
vector of number of overlaps weigthed by score column.
}
\description{
Similar to countOverlaps, but takes the score column into account.
}
\examples{
gr1 <- GRanges(seqnames="chr1",
               ranges=IRanges(start = c(4, 9, 10, 30),
                              end = c(4, 15, 20, 31)),
               strand="+")
gr2 <- GRanges(seqnames="chr1",
               ranges=IRanges(start = c(1, 4, 15, 25),
                              end = c(2, 4, 20, 26)),
               strand=c("+"),
               score=c(10, 20, 15, 5))
countOverlaps(gr1, gr2)
utilsScoreOverlaps(gr1, gr2)
}
\seealso{
\url{https://support.bioconductor.org/p/87736/#87758}

Other Utility functions: 
\code{\link{utilsAggregateRows}()},
\code{\link{utilsDeStrand}()},
\code{\link{utilsSimplifyTxDb}()}
}
\concept{Utility functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/shape.R
\name{shapeMultimodality}
\alias{shapeMultimodality}
\title{Shape statistic: Multimodality}
\usage{
shapeMultimodality(x)
}
\arguments{
\item{x}{numeric Rle vector: Coverage series.}
}
\value{
Numeric.
}
\description{
Shape statistic: Multimodality
}
\examples{
# See calcShape for usage examples
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cluster.R
\name{clusterUnidirectionally}
\alias{clusterUnidirectionally}
\alias{clusterUnidirectionally,GRanges-method}
\alias{clusterUnidirectionally,RangedSummarizedExperiment-method}
\alias{clusterUnidirectionally,GPos-method}
\title{Unidirectional Clustering (Tag Clustering) of pooled CTSSs.}
\usage{
clusterUnidirectionally(object, ...)

\S4method{clusterUnidirectionally}{GRanges}(object, pooledCutoff = 0, mergeDist = 20L)

\S4method{clusterUnidirectionally}{RangedSummarizedExperiment}(object, ...)

\S4method{clusterUnidirectionally}{GPos}(object, ...)
}
\arguments{
\item{object}{GRanges or RangedSummarizedExperiment: Basepair-wise pooled
CTSS.}

\item{...}{additional arguments passed to methods.}

\item{pooledCutoff}{numeric: Minimum pooled value to be considered as TC.}

\item{mergeDist}{integer: Merge TCs within this distance.}
}
\value{
GRanges with TPM sum as the score column, and TC peak as the thick
  column.
}
\description{
Finds unidirectional Tag Clusters (TCs) with a pooled TPM above a certain
threshold using a slice-reduce approach. Addtionally calculates the sum and
peak position of the TCs.
}
\examples{
data(exampleCTSSs)

# Calculate pooledTPM, using supplied number of total tags
exampleCTSSs <- calcTPM(exampleCTSSs,
                        inputAssay='counts',
                        outputAssay='TPM',
                        totalTags='totalTags')
exampleCTSSs <- calcPooled(exampleCTSSs, inputAssay='TPM')

# Cluster using defaults: slice-threshold of 0 and reduce-distance of 20
clusterUnidirectionally(exampleCTSSs)

# Use custom thresholds:
clusterUnidirectionally(exampleCTSSs, pooledCutoff=1, mergeDist=25)
}
\seealso{
Other Clustering functions: 
\code{\link{clusterBidirectionally}()},
\code{\link{trimToPeak}()},
\code{\link{trimToPercentiles}()},
\code{\link{tuneTagClustering}()}
}
\concept{Clustering functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{utilsDeStrand}
\alias{utilsDeStrand}
\title{Utility: Split Genomic Ranges by strand}
\usage{
utilsDeStrand(object)
}
\arguments{
\item{object}{Any object with a split and strand method, e.g. GRanges/GPos}
}
\value{
Object split by strand, e.g. GRangesList.
}
\description{
Utility function that attemps to split genomic ranges by strand with split(object, strand(object))
}
\examples{
gp <- GPos(seqnames=Rle(c("chr1", "chr2", "chr1"), c(10, 6, 4)),
            pos=c(44:53, 5:10, 2:5),
            strand=c(rep("+", 10), rep("-", 10)))
gr <- as(gp, "GRanges")
utilsDeStrand(gp)
utilsDeStrand(gr)
}
\seealso{
Other Utility functions: 
\code{\link{utilsAggregateRows}()},
\code{\link{utilsScoreOverlaps}()},
\code{\link{utilsSimplifyTxDb}()}
}
\concept{Utility functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/track.R
\name{trackBalance}
\alias{trackBalance}
\alias{trackBalance,GRanges-method}
\alias{trackBalance,GPos-method}
\alias{trackBalance,RangedSummarizedExperiment-method}
\title{Create Genome Browser Track of bidirectional balance scores}
\usage{
trackBalance(object, ...)

\S4method{trackBalance}{GRanges}(
  object,
  window = 199,
  plusColor = "cornflowerblue",
  minusColor = "tomato",
  balanceColor = "forestgreen",
  ...
)

\S4method{trackBalance}{GPos}(object, ...)

\S4method{trackBalance}{RangedSummarizedExperiment}(object, ...)
}
\arguments{
\item{object}{GenomicRanges or RangedSummarizedExperiment: Ranges with CTSSs
in the score column.}

\item{...}{additional arguments passed to DataTrack.}

\item{window}{integer: Width of sliding window used for calculating windowed
sums.}

\item{plusColor}{character: Color for plus-strand coverage.}

\item{minusColor}{character: Color for minus-strand coverage.}

\item{balanceColor}{character: Color for bidirectional balance.}
}
\value{
list of 3 DataTracks for upstream, downstream and balance.
}
\description{
Visualize balance scores used for detectiong of bidirectional sites. Mainly
intended as diagnostic tools for expert user.
}
\note{
Potentially consumes a large amount of memory!
}
\examples{
\dontrun{
library(Gviz)
data(exampleCTSSs)
data(exampleBidirectional)

# Calculate pooled CTSSs
exampleCTSSs <- calcTPM(exampleCTSSs, totalTags='totalTags')
exampleCTSSs <- calcPooled(exampleCTSSs)

# Find a bidirectional cluster to plot:
BC <- rowRanges(exampleBidirectional[10,])
start(BC) <- start(BC) - 250
end(BC) <- end(BC) + 250
subsetOfCTSSs <- subsetByOverlaps(exampleCTSSs, BC)

# Build balance track
balance_track <- trackBalance(subsetOfCTSSs)

# Plot
plotTracks(balance_track, from=start(BC), to=end(BC),
           chromosome=seqnames(BC))
}
}
\seealso{
Other Genome Browser functions: 
\code{\link{trackCTSS}()},
\code{\link{trackClusters}()},
\code{\link{trackLinks}()}
}
\concept{Genome Browser functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/track.R
\name{trackLinks}
\alias{trackLinks}
\title{Create a genome browser track of links.}
\usage{
trackLinks(object, ...)
}
\arguments{
\item{object}{GInteractions: Links or pairs between clusters.}

\item{...}{additional arguments passed to InteractionTrack via displayPars.}
}
\value{
InteractionTrack-object from the GenomicInteractions package.
}
\description{
Create a Gviz-track of links (e.g. between TSSs and enhancers), where arches connect the different pairs of clusters. The height of arches can be set to scale the strength of the interaction (for example indicating higher correlation). This function is a thin wrapper around the InteractionTrack-class from the GenomicInteractions package. Currently, only scaling arch height by p-value is supported.
}
\examples{
library(InteractionSet)
library(Gviz)
library(GenomicInteractions)

# Links between highly expressed unidirectional clusters
TCs <- subset(exampleUnidirectional, score > 10)
TC_links <- findLinks(TCs, inputAssay="counts", maxDist=10000L)
link_track <- trackLinks(TC_links, name="TSS links", interaction.measure="p.value")

# Plot region
plot_region <- GRanges(seqnames="chr18",
                       ranges = IRanges(start=start(anchors(TC_links[1],
                                                            "first")),
                                        end=end(anchors(TC_links[1],
                                                        "second"))))
# Plot using Gviz
plotTracks(link_track,
           from=start(plot_region),
           to=end(plot_region),
           chromosome = as.character(seqnames(plot_region)))
# See vignette for examples on how to combine multiple Gviz tracks
}
\seealso{
Other Genome Browser functions: 
\code{\link{trackBalance}()},
\code{\link{trackCTSS}()},
\code{\link{trackClusters}()}

Other Spatial functions: 
\code{\link{findLinks}()},
\code{\link{findStretches}()}
}
\concept{Genome Browser functions}
\concept{Spatial functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/assign.R
\name{assignTxType}
\alias{assignTxType}
\alias{assignTxType,GenomicRanges,GenomicRangesList-method}
\alias{assignTxType,RangedSummarizedExperiment,GenomicRangesList-method}
\alias{assignTxType,GenomicRanges,TxDb-method}
\alias{assignTxType,RangedSummarizedExperiment,TxDb-method}
\title{Annotate ranges with transcript type.}
\usage{
assignTxType(object, txModels, ...)

\S4method{assignTxType}{GenomicRanges,GenomicRangesList}(
  object,
  txModels,
  outputColumn = "txType",
  swap = NULL,
  noOverlap = "intergenic"
)

\S4method{assignTxType}{RangedSummarizedExperiment,GenomicRangesList}(object, txModels, ...)

\S4method{assignTxType}{GenomicRanges,TxDb}(
  object,
  txModels,
  outputColumn = "txType",
  swap = NULL,
  tssUpstream = 100,
  tssDownstream = 100,
  proximalUpstream = 1000,
  detailedAntisense = FALSE
)

\S4method{assignTxType}{RangedSummarizedExperiment,TxDb}(object, txModels, ...)
}
\arguments{
\item{object}{GRanges or RangedSummarizedExperiment: Ranges to be annotated.}

\item{txModels}{TxDb or GRangesList: Transcript models via a TxDb, or
manually specified as a GRangesList.}

\item{...}{additional arguments passed to methods.}

\item{outputColumn}{character: Name of column to hold txType values.}

\item{swap}{character or NULL: If not NULL, use another set of ranges
contained in object to calculate overlaps, for example peaks in the thick
column.}

\item{noOverlap}{character: In case categories are manually supplied with as
a GRangesList, what to call regions with no overlap.}

\item{tssUpstream}{integer: Distance to extend annotated promoter upstream.}

\item{tssDownstream}{integer: Distance to extend annotated promoter
downstream.}

\item{proximalUpstream}{integer: Maximum distance upstream of promoter to be
considered proximal.}

\item{detailedAntisense}{logical: Wether to mirror all txType categories in
the antisense direction (TRUE) or lump them all together (FALSE).}
}
\value{
object with txType added as factor column in rowData (or mcols)
}
\description{
Annotate a set of ranges in a GRanges object with transcript type (txType)
based on their genic context. Transcripts are obtained from a TxDb object,
but can alternatively be specified manually as a GRangesList.
}
\examples{
\dontrun{
data(exampleUnidirectional)

# Obtain transcript models from a TxDb-object:
library(TxDb.Mmusculus.UCSC.mm9.knownGene)
txdb <- TxDb.Mmusculus.UCSC.mm9.knownGene

# Assign txIDs
assignTxType(exampleUnidirectional,
             txModels=txdb)

# Assign txIDs using only TC peaks:
exampleUnidirectional <- assignTxType(exampleUnidirectional,
                                      txModels=txdb,
                                      swap='thick')

# The 'promoter' and 'proximal' category boundaries can be changed:
assignTxType(exampleUnidirectional,
             txModels=txdb,
             swap='thick',
             tssUpstream=50,
             tssDownstream=50,
             proximalUpstream=100)

# Annotation using complete antisense categories:
exampleUnidirectional <- assignTxType(exampleUnidirectional,
                                    txModels=txdb,
                                    outputColumn='txTypeExtended',
                                    swap='thick',
                                    detailedAntisense=TRUE)

# The output is always a factor added as a column:
summary(rowRanges(exampleUnidirectional)$txType)
summary(rowRanges(exampleUnidirectional)$txTypeExtended)

# To avoid using a TxDb-object, a GRangesList can be supplied:
custom_hierarchy <- GRangesList(promoters=granges(promoters(txdb)),
                                exons=granges(exons(txdb)))
assignTxType(exampleUnidirectional,
             txModels=custom_hierarchy,
             outputColumn='customType',
             swap='thick',
             noOverlap = 'intergenic')
}
}
\seealso{
Other Annotation functions: 
\code{\link{assignGeneID}()},
\code{\link{assignMissingID}()},
\code{\link{assignTxID}()}
}
\concept{Annotation functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/enhancers.R
\name{calcBidirectionality}
\alias{calcBidirectionality}
\alias{calcBidirectionality,GRanges-method}
\alias{calcBidirectionality,GPos-method}
\alias{calcBidirectionality,RangedSummarizedExperiment-method}
\title{Calculate sample-wise bidirectionally of clusters.}
\usage{
calcBidirectionality(object, ...)

\S4method{calcBidirectionality}{GRanges}(
  object,
  samples,
  inputAssay = "counts",
  outputColumn = "bidirectionality"
)

\S4method{calcBidirectionality}{GPos}(object, ...)

\S4method{calcBidirectionality}{RangedSummarizedExperiment}(object, ...)
}
\arguments{
\item{object}{GenomicRanges or RangedSummarizedExperiment: Unstranded
clusters with midpoints stored in the 'thick' column.}

\item{...}{additional arguments passed to methods.}

\item{samples}{RangedSummarizedExperiment: Sample-wise CTSSs stored as an
assay.}

\item{inputAssay}{character: Name of assay in samples holding input CTSS
values.}

\item{outputColumn}{character: Name of column in object to hold
bidirectionality values.}
}
\value{
object returned with bidirectionality scores added in rowData (or
  mcols).
}
\description{
For each cluster, calculate how many individual samples shows transcription
in both directions. This is refered to as the 'bidirectionality'. Clusters
must be unstranded (*) and have a midpoint stored in the thick column
}
\examples{
data(exampleCTSSs)
data(exampleBidirectional)

calcBidirectionality(exampleBidirectional, samples=exampleCTSSs)
}
\seealso{
Other Calculation functions: 
\code{\link{calcComposition}()},
\code{\link{calcPooled}()},
\code{\link{calcShape}()},
\code{\link{calcSupport}()},
\code{\link{calcTPM}()},
\code{\link{calcTotalTags}()},
\code{\link{subsetByBidirectionality}()},
\code{\link{subsetByComposition}()},
\code{\link{subsetBySupport}()}
}
\concept{Calculation functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/enhancers.R
\name{balanceD}
\alias{balanceD}
\title{Balance statistic: Andersson's D.}
\usage{
balanceD(PD, MD, PU, MU)
}
\arguments{
\item{PD}{Plus-Downstream signal}

\item{MD}{Minus-Downstream signal}

\item{PU}{Plus-Upstream signal}

\item{MU}{Plus-Upstream signal}
}
\value{
Balance score of the same class as inputs.
}
\description{
Calculates the D-statistics from Andersson et al the observed plus/minus
downstream signals. The D statistics is rescaled from -1:1 to 0:1 so it can
be used for slice-reduce identification of bidirectional sites.
}
\examples{
# Unbalanced
balanceD(2, 3, 1, 0)

# Balanced
balanceD(3, 3, 0, 0)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/quantify.R
\name{quantifyGenes}
\alias{quantifyGenes}
\title{Quantify expression of genes}
\usage{
quantifyGenes(object, genes, inputAssay = "counts", sparse = FALSE)
}
\arguments{
\item{object}{RangedSummarizedExperiment: Cluster-level expression values.}

\item{genes}{character: Name of column in rowData holding gene IDs (NAs will
be discarded).}

\item{inputAssay}{character: Name of assay holding values to be quantified,
(usually counts).}

\item{sparse}{logical: If the input is a sparse matrix, TRUE will keep the
output matrix sparse while FALSE will coerce it into a normal matrix.}
}
\value{
RangedSummarizedExperiment with rows corresponding to genes. Location
  of clusters within genes is stored as a GRangesList in rowRanges. seqinfo
  and colData is copied over from object.
}
\description{
Obtain gene-level expression estimates by summing clusters annotated to the
same gene. Unannotated transcripts (NAs) are discarded.
}
\examples{
data(exampleUnidirectional)

# Annotate clusters with geneIDs:
library(TxDb.Mmusculus.UCSC.mm9.knownGene)
txdb <- TxDb.Mmusculus.UCSC.mm9.knownGene
exampleUnidirectional <- assignGeneID(exampleUnidirectional,
                                      geneModels=txdb,
                                      outputColumn='geneID')

# Quantify counts within genes:
quantifyGenes(exampleUnidirectional, genes='geneID', inputAssay='counts')

# For exceptionally large datasets,
# the resulting count matrix can be left sparse:
quantifyGenes(exampleUnidirectional,
              genes='geneID',
              inputAssay='counts',
              sparse=TRUE)
}
\seealso{
Other Quantification functions: 
\code{\link{quantifyCTSSs2}()},
\code{\link{quantifyCTSSs}()},
\code{\link{quantifyClusters}()}
}
\concept{Quantification functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bw.R
\name{bwCommonGenome}
\alias{bwCommonGenome}
\title{Find a common genome for a series of BigWig files.}
\usage{
bwCommonGenome(plusStrand, minusStrand, method = "intersect")
}
\arguments{
\item{plusStrand}{BigWigFileList: BigWig files with plus-strand CTSS data.}

\item{minusStrand}{BigWigFileList: BigWig files with minus-strand CTSS data.}

\item{method}{character: Either 'intersect' or 'union'.}
}
\value{
Sorted Seqinfo-object.
}
\description{
Finds a common genome for a series of BigWig-files, either using only levels
present in all files (intersect) or in any file (union).
}
\examples{
if (.Platform$OS.type != "windows") {
# Use the BigWig-files included with the package:
data('exampleDesign')
bw_plus <- system.file('extdata', exampleDesign$BigWigPlus,
                       package = 'CAGEfightR')
bw_minus <- system.file('extdata', exampleDesign$BigWigMinus,
                        package = 'CAGEfightR')

# Create two named BigWigFileList-objects:
bw_plus <- BigWigFileList(bw_plus)
bw_minus <- BigWigFileList(bw_minus)
names(bw_plus) <- exampleDesign$Name
names(bw_minus) <- exampleDesign$Name

# Find the smallest common genome (intersect) across the BigWigList-objects:
bwCommonGenome(plusStrand=bw_plus, minusStrand=bw_minus, method='intersect')

# Find the most inclusive genome (union) across the BigWigList-objects:
bwCommonGenome(plusStrand=bw_plus, minusStrand=bw_minus, method='union')
}
}
\seealso{
Other BigWig functions: 
\code{\link{bwGenomeCompatibility}()},
\code{\link{bwValid}()}
}
\concept{BigWig functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/calc.R
\name{calcComposition}
\alias{calcComposition}
\title{Calculate composition of CAGE data.}
\usage{
calcComposition(
  object,
  inputAssay = "counts",
  outputColumn = "composition",
  unexpressed = 0.1,
  genes = "geneID"
)
}
\arguments{
\item{object}{RangedSummarizedExperiment: CAGE data quantified at CTSS,
cluster or gene-level.}

\item{inputAssay}{character: Name of assay holding input expression values.}

\item{outputColumn}{character: Name of column in rowRanges to hold
composition values.}

\item{unexpressed}{numeric: Composition will be calculated based on features
larger than this cutoff.}

\item{genes}{character: Name of column in rowData holding genes (NAs are not
currently allowed.)}
}
\value{
object with composition added as a column in rowData.
}
\description{
For every feature, count in how many samples it is expressed above a certain
fraction (e.g. 10 percent) within a grouping, usually genes. This count is
refered to as the 'composition' value.
}
\examples{
data(exampleUnidirectional)

# Annotate clusters with geneIDs:
library(TxDb.Mmusculus.UCSC.mm9.knownGene)
txdb <- TxDb.Mmusculus.UCSC.mm9.knownGene
exampleUnidirectional <- assignGeneID(exampleUnidirectional,
                                      geneModels=txdb,
                                      outputColumn='geneID',
                                      swap='thick')

# Calculate composition values:
exampleUnidirectional <- subset(exampleUnidirectional, !is.na(geneID))
calcComposition(exampleUnidirectional)

# Use a lower threshold
calcComposition(exampleUnidirectional,
                unexpressed=0.05,
                outputColumn='lenientComposition')
}
\seealso{
Other Calculation functions: 
\code{\link{calcBidirectionality}()},
\code{\link{calcPooled}()},
\code{\link{calcShape}()},
\code{\link{calcSupport}()},
\code{\link{calcTPM}()},
\code{\link{calcTotalTags}()},
\code{\link{subsetByBidirectionality}()},
\code{\link{subsetByComposition}()},
\code{\link{subsetBySupport}()}
}
\concept{Calculation functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tune.R
\name{tuneTagClustering}
\alias{tuneTagClustering}
\alias{tuneTagClustering,GRanges-method}
\alias{tuneTagClustering,RangedSummarizedExperiment-method}
\alias{tuneTagClustering,GPos-method}
\title{Determine the optimal pooled threshold for unidirectional tag clustering.}
\usage{
tuneTagClustering(object, ...)

\S4method{tuneTagClustering}{GRanges}(
  object,
  steps = 10L,
  mergeDist = 20L,
  searchMethod = "minUnique",
  maxExponent = 1
)

\S4method{tuneTagClustering}{RangedSummarizedExperiment}(object, ...)

\S4method{tuneTagClustering}{GPos}(object, ...)
}
\arguments{
\item{object}{GenomicRanges or RangedSummarizedExperiment: Pooled CTSS.}

\item{...}{additional arguments passed to methods.}

\item{steps}{integer: Number of thresholds to analyze (in addition to
treshold=0).}

\item{mergeDist}{integer: Merge TCs within this distance.}

\item{searchMethod}{character: For advanced user only, see details.}

\item{maxExponent}{numeric: The maximal threshold to analyse is obtained as
min(score)*2^maxExponent (only used if searchMethod='exponential').}
}
\value{
data.frame with two columns: threshold and nTCs (number of Tag
  Clusters)
}
\description{
This function counts the number of Tag Clusters (TCs) for an series of small
incremental pooled cutoffs
}
\examples{
\dontrun{
data(exampleCTSSs)

# Calculate pooledTPM, using supplied number of total tags
exampleCTSSs <- calcTPM(exampleCTSSs,
                        inputAssay='counts',
                        outputAssay='TPM',
                        totalTags='totalTags')
exampleCTSSs <- calcPooled(exampleCTSSs, inputAssay='TPM')

# Set backend
library(BiocParallel)
register(SerialParam())

# Find optimal slice-threshold for reduce distance of 20:
tuneTagClustering(object=exampleCTSSs)
}
}
\seealso{
Other Clustering functions: 
\code{\link{clusterBidirectionally}()},
\code{\link{clusterUnidirectionally}()},
\code{\link{trimToPeak}()},
\code{\link{trimToPercentiles}()}
}
\concept{Clustering functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check.R
\name{checkPooled}
\alias{checkPooled}
\title{Helper for checking pooled signal}
\usage{
checkPooled(object)
}
\arguments{
\item{object}{GRanges or GPos: Pooled signal to be checked}
}
\value{
TRUE if object is correct format, otherwise an error is thrown
}
\description{
Checks whether a supplied pooled signal is valid: Single bp disjoint with
signal in the score column with supplied genome information.
}
\examples{
data(exampleCTSSs)
checkPooled(rowRanges(exampleCTSSs))
}
\seealso{
Other Checking functions: 
\code{\link{checkPeaked}()}
}
\concept{Checking functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/calc.R
\name{calcTPM}
\alias{calcTPM}
\title{Calculate CAGE Tags-Per-Million (TPM)}
\usage{
calcTPM(
  object,
  inputAssay = "counts",
  outputAssay = "TPM",
  totalTags = NULL,
  outputColumn = "totalTags"
)
}
\arguments{
\item{object}{RangedSummarizedExperiment: CAGE data quantified at CTSS,
cluster or gene-level.}

\item{inputAssay}{character: Name of assay holding input expression values.}

\item{outputAssay}{character: Name of assay to hold TPM values.}

\item{totalTags}{character or NULL: Column in colData holding the total
number of tags for each samples. If NULL, this will be calculated using
calcTotalTags.}

\item{outputColumn}{character: Name of column in colData to hold number of
total tags, only used if totalTags is NULL.}
}
\value{
object with TPM-values added as a new assay. If totalTags is NULL,
  total tags added as a column in colData.
}
\description{
Normalize CAGE-tag counts into TPM values.
}
\examples{
data(exampleUnidirectional)

# Calculate TPM:
calcTPM(exampleUnidirectional)

# Use pre-calculated total number of tags:
calcTPM(exampleUnidirectional,
        outputAssay='TPMsupplied',
        totalTags='totalTags')
}
\seealso{
Other Calculation functions: 
\code{\link{calcBidirectionality}()},
\code{\link{calcComposition}()},
\code{\link{calcPooled}()},
\code{\link{calcShape}()},
\code{\link{calcSupport}()},
\code{\link{calcTotalTags}()},
\code{\link{subsetByBidirectionality}()},
\code{\link{subsetByComposition}()},
\code{\link{subsetBySupport}()}
}
\concept{Calculation functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/CTSSs.R
\name{quantifyCTSSs}
\alias{quantifyCTSSs}
\alias{quantifyCTSSs,BigWigFileList,BigWigFileList-method}
\alias{quantifyCTSSs,character,character-method}
\title{Quantify CAGE Transcriptions Start Sites (CTSSs)}
\usage{
quantifyCTSSs(plusStrand, minusStrand, design = NULL, genome = NULL, ...)

\S4method{quantifyCTSSs}{BigWigFileList,BigWigFileList}(
  plusStrand,
  minusStrand,
  design = NULL,
  genome = NULL,
  nTiles = 1L
)

\S4method{quantifyCTSSs}{character,character}(plusStrand, minusStrand, design = NULL, genome = NULL)
}
\arguments{
\item{plusStrand}{BigWigFileList or character: BigWig/bedGraph files with plus-strand CTSS data.}

\item{minusStrand}{BigWigFileList or character: BigWig/bedGraph files with minus-strand CTSS data.}

\item{design}{DataFrame or data.frame: Additional information on samples which will be added to the ouput}

\item{genome}{Seqinfo: Genome information. If NULL the smallest common genome
will be found using bwCommonGenome when BigWig-files are analyzed.}

\item{...}{additional arguments passed to methods.}

\item{nTiles}{integer: Number of genomic tiles to parallelize over.}
}
\value{
RangedSummarizedExperiment, where assay is a sparse matrix
  (dgCMatrix) of CTSS counts and design stored in colData.
}
\description{
This function reads in CTSS count data from a series of BigWig-files (or bedGraph-files) and
returns a CTSS-by-library count matrix. For efficient processing, the count
matrix is stored as a sparse matrix (dgCMatrix from the Matrix package), and CTSSs are compressed to a GPos object if possible.
}
\examples{
\dontrun{
# Load the example data
data('exampleDesign')
# Use the BigWig-files included with the package:
bw_plus <- system.file('extdata', exampleDesign$BigWigPlus,
                       package = 'CAGEfightR')
bw_minus <- system.file('extdata', exampleDesign$BigWigMinus,
                        package = 'CAGEfightR')

# Create two named BigWigFileList-objects:
bw_plus <- BigWigFileList(bw_plus)
bw_minus <- BigWigFileList(bw_minus)
names(bw_plus) <- exampleDesign$Name
names(bw_minus) <- exampleDesign$Name

# Quantify CTSSs, by default this will use the smallest common genome:
CTSSs <- quantifyCTSSs(plusStrand=bw_plus,
                       minusStrand=bw_minus,
                       design=exampleDesign)

# Alternatively, a genome can be specified:
si <- seqinfo(bw_plus[[1]])
si <- si['chr18']
CTSSs_subset <- quantifyCTSSs(plusStrand=bw_plus,
                       minusStrand=bw_minus,
                       design=exampleDesign,
                       genome=si)

# Quantification can be speed up by using multiple cores:
library(BiocParallel)
register(MulticoreParam(workers=3))
CTSSs_subset <- quantifyCTSSs(plusStrand=bw_plus,
                       minusStrand=bw_minus,
                       design=exampleDesign,
                       genome=si)

# CAGEfightR also support bedGraph files, first BigWig is converted
bg_plus <- replicate(n=length(bw_plus), tempfile(fileext="_plus.bedGraph"))
bg_minus <- replicate(n=length(bw_minus), tempfile(fileext="_minus.bedGraph"))
names(bg_plus) <- names(bw_plus)
names(bg_minus) <- names(bw_minus)

convertBigWig2BedGraph(input=sapply(bw_plus, resource), output=bg_plus)
convertBigWig2BedGraph(input=sapply(bw_minus, resource), output=bg_minus)

# Then analyze: Note a genome MUST be supplied here!
si <- bwCommonGenome(bw_plus, bw_minus)
CTSSs_via_bg <- quantifyCTSSs(plusStrand=bg_plus,
                        minusStrand=bg_minus,
                        design=exampleDesign,
                        genome=si)

# Confirm that the two approaches yield the same results
all(assay(CTSSs_via_bg) == assay(CTSSs))
}
}
\seealso{
Other Quantification functions: 
\code{\link{quantifyCTSSs2}()},
\code{\link{quantifyClusters}()},
\code{\link{quantifyGenes}()}
}
\concept{Quantification functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/assign.R
\name{assignMissingID}
\alias{assignMissingID}
\alias{assignMissingID,character-method}
\alias{assignMissingID,GenomicRanges-method}
\alias{assignMissingID,RangedSummarizedExperiment-method}
\title{Annotate ranges with missing IDs.}
\usage{
assignMissingID(object, ...)

\S4method{assignMissingID}{character}(object, prefix = "Novel")

\S4method{assignMissingID}{GenomicRanges}(object, outputColumn = "geneID", prefix = "Novel")

\S4method{assignMissingID}{RangedSummarizedExperiment}(object, outputColumn = "geneID", prefix = "Novel")
}
\arguments{
\item{object}{character, GRanges or RangedSummarizedExperiment: IDs to have
NAs replaces with new IDs.}

\item{...}{additional arguments passed to methods.}

\item{prefix}{character: New name to assign to ranges with missing IDs, in
the style prefix1, prefix2, etc.}

\item{outputColumn}{character: Name of column to hold txID values.}
}
\value{
object with NAs replaced in outputColumn
}
\description{
This function can relabel ranges with missing IDs (i.e. returned by
assignTxID and assignGeneID), in case they need to be retained for further
analysis.
}
\examples{
data(exampleUnidirectional)

# Obtain gene models from a TxDb-object:
library(TxDb.Mmusculus.UCSC.mm9.knownGene)
txdb <- TxDb.Mmusculus.UCSC.mm9.knownGene

# Assign geneIDs using only TC peaks:
exampleUnidirectional <- assignGeneID(exampleUnidirectional,
                                      geneModels=txdb,
                                      outputColumn='geneID',
                                      swap='thick')

# Replace NAs with 'Novel'
assignMissingID(exampleUnidirectional)

# Replace NAs with 'NovelTSS'
assignMissingID(exampleUnidirectional, prefix = 'NovelTSS')
}
\seealso{
Other Annotation functions: 
\code{\link{assignGeneID}()},
\code{\link{assignTxID}()},
\code{\link{assignTxType}()}
}
\concept{Annotation functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/trimTo.R
\name{trimToPeak}
\alias{trimToPeak}
\alias{trimToPeak,GRanges,GRanges-method}
\alias{trimToPeak,GRanges,GPos-method}
\alias{trimToPeak,RangedSummarizedExperiment,GenomicRanges-method}
\alias{trimToPeak,GRanges,RangedSummarizedExperiment-method}
\alias{trimToPeak,RangedSummarizedExperiment,RangedSummarizedExperiment-method}
\title{Trim width of TCs by distance from TC peak}
\usage{
trimToPeak(object, pooled, ...)

\S4method{trimToPeak}{GRanges,GRanges}(object, pooled, upstream, downstream)

\S4method{trimToPeak}{GRanges,GPos}(object, pooled, ...)

\S4method{trimToPeak}{RangedSummarizedExperiment,GenomicRanges}(object, pooled, ...)

\S4method{trimToPeak}{GRanges,RangedSummarizedExperiment}(object, pooled, ...)

\S4method{trimToPeak}{RangedSummarizedExperiment,RangedSummarizedExperiment}(object, pooled, ...)
}
\arguments{
\item{object}{GenomicRanges or RangedSummarizedExperiment: Tag clusters.}

\item{pooled}{GenomicRanges or RangedSummarizedExperiment: Basepair-wise
pooled CTSS (stored in the score column).}

\item{...}{additional arguments passed to methods.}

\item{upstream}{integer: Maximum upstream distance from TC peak.}

\item{downstream}{integer: Maximum downstream distance from TC peak.}
}
\value{
data.frame with two columns: threshold and nTCs (number of Tag
  Clusters)
}
\description{
Trim the width of TCs by distance from the TC peaks.
}
\examples{
data(exampleCTSSs)
data(exampleBidirectional)

# Calculate pooled CTSSs
exampleCTSSs <- calcTPM(exampleCTSSs, totalTags='totalTags')
exampleCTSSs <- calcPooled(exampleCTSSs)

# Choose a few wide clusters:
TCs <- subset(exampleUnidirectional, width >= 100)

# Trim to +/- 10 bp of TC peak
trimToPeak(TCs, pooled=exampleCTSSs, upstream=10, downstream=10)
}
\seealso{
Other Clustering functions: 
\code{\link{clusterBidirectionally}()},
\code{\link{clusterUnidirectionally}()},
\code{\link{trimToPercentiles}()},
\code{\link{tuneTagClustering}()}

Other Trimming functions: 
\code{\link{trimToPercentiles}()}
}
\concept{Clustering functions}
\concept{Trimming functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/assign.R
\name{assignGeneID}
\alias{assignGeneID}
\alias{assignGeneID,GenomicRanges,GenomicRanges-method}
\alias{assignGeneID,RangedSummarizedExperiment,GenomicRanges-method}
\alias{assignGeneID,GenomicRanges,TxDb-method}
\alias{assignGeneID,RangedSummarizedExperiment,TxDb-method}
\title{Annotate ranges with gene ID.}
\usage{
assignGeneID(object, geneModels, ...)

\S4method{assignGeneID}{GenomicRanges,GenomicRanges}(
  object,
  geneModels,
  outputColumn = "geneID",
  swap = NULL,
  upstream = 1000,
  downstream = 100
)

\S4method{assignGeneID}{RangedSummarizedExperiment,GenomicRanges}(object, geneModels, ...)

\S4method{assignGeneID}{GenomicRanges,TxDb}(
  object,
  geneModels,
  outputColumn = "geneID",
  swap = NULL,
  upstream = 1000,
  downstream = 100
)

\S4method{assignGeneID}{RangedSummarizedExperiment,TxDb}(object, geneModels, ...)
}
\arguments{
\item{object}{GRanges or RangedSummarizedExperiment: Ranges to be annotated.}

\item{geneModels}{TxDb or GRanges: Gene models via a TxDb, or manually
specified as a GRangesList.}

\item{...}{additional arguments passed to methods.}

\item{outputColumn}{character: Name of column to hold geneID values.}

\item{swap}{character or NULL: If not NULL, use another set of ranges
contained in object to calculate overlaps, for example peaks in the thick
column.}

\item{upstream}{integer: Distance to extend annotated promoter upstream.}

\item{downstream}{integer: Distance to extend annotated promoter downstream.}
}
\value{
object with geneID added as a column in rowData (or mcols).
}
\description{
Annotate a set of ranges in a GRanges object with gene IDs (i.e. Entrez Gene
Identifiers) based on their genic context. Features overlapping multiple
genes are resolved by distance to the nearest TSS. Genes are obtained from a
TxDb object, or can manually supplied as a GRanges.
}
\examples{
data(exampleUnidirectional)

# Obtain gene models from a TxDb-object:
library(TxDb.Mmusculus.UCSC.mm9.knownGene)
txdb <- TxDb.Mmusculus.UCSC.mm9.knownGene

# Assign geneIDs
assignGeneID(exampleUnidirectional,
             geneModels=txdb,
             outputColumn='geneID')

# Assign geneIDs using only TC peaks:
assignGeneID(exampleUnidirectional,
             geneModels=txdb,
             outputColumn='geneID',
             swap='thick')
}
\seealso{
Other Annotation functions: 
\code{\link{assignMissingID}()},
\code{\link{assignTxID}()},
\code{\link{assignTxType}()}
}
\concept{Annotation functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/convert.R
\name{convertBED2BigWig}
\alias{convertBED2BigWig}
\alias{convertBED2BedGraph}
\alias{convertBedGraph2BigWig}
\alias{convertBigWig2BedGraph}
\alias{convertBigWig2BED}
\alias{convertBedGraph2BED}
\title{Convert CTSSs stored in different file formats.}
\usage{
convertBED2BigWig(input, outputPlus, outputMinus, genome)

convertBED2BedGraph(input, outputPlus, outputMinus)

convertBedGraph2BigWig(input, output, genome)

convertBigWig2BedGraph(input, output)

convertBigWig2BED(inputPlus, inputMinus, output)

convertBedGraph2BED(inputPlus, inputMinus, output)
}
\arguments{
\item{input}{charater: Path to input files holding CTSSs on both strands.}

\item{outputPlus}{character: Path to output files holding CTSSs on plus strand.}

\item{outputMinus}{character: Path to output files holding CTSSs on minus strand.}

\item{genome}{Seqinfo or character: Genome info passed to rtracklayer::import  (see note).}

\item{output}{charater: Path to output files holding CTSSs on both strands.}

\item{inputPlus}{character: Path to input files holding CTSSs on plus strand.}

\item{inputMinus}{character: Path to input files holding CTSSs on minus strand.}
}
\value{
TRUE returned invisibly if conversion(s) was succesful, otherwise an error is raised.
}
\description{
Collection of functions for converting CTSSs/CTSSs-like data stored in
BigWig, bedGraph or BED file formats. BigWig and bedGraph files use a file
for each strand, while BED-files stores both strands in a single file. As
BigWig files stores info about the chromosome lenghts, conversion from
bedGraph/BED to BigWig requires a genome. Note that CAGEfightR will only
import BigWig or bedGraph files!
}
\note{
These functions will warn if input files do not have the correct
  extensions (.bw, .bedGraph, .bed), but otherwise simply pass input to
  rtracklayer::import. This makes them able to handle compressed files (like
  .gz). The same applies to the genome argument, which can also be the name
  of a UCSC genome.
}
\examples{
\dontrun{
# Find paths to BigWig files
data('exampleDesign')
bw_plus <- system.file('extdata', exampleDesign$BigWigPlus,
                       package = 'CAGEfightR')
bw_minus <- system.file('extdata', exampleDesign$BigWigMinus,
                        package = 'CAGEfightR')

# Designate paths to new files
n_samples <- length(bw_plus)
beds <- replicate(n=n_samples, tempfile(fileext=".bed"))
bg_plus <- replicate(n=n_samples, tempfile(fileext="_plus.bedGraph"))
bg_minus <- replicate(n=n_samples, tempfile(fileext="_minus.bedGraph"))
conv_plus <- replicate(n=n_samples, tempfile(fileext="_plus.bw"))
conv_minus <- replicate(n=n_samples, tempfile(fileext="_minus.bw"))

# Convert BigWig to BED
convertBigWig2BED(inputPlus=bw_plus,
                  inputMinus=bw_minus,
                  output=beds)

# Convert BED to bedGraph
convertBED2BedGraph(input=beds,
                    outputPlus=bg_plus,
                    outputMinus=bg_minus)

# Convert BED to bedGraph
mm9 <- SeqinfoForUCSCGenome("mm9")
convertBED2BigWig(input=beds,
                  outputPlus=conv_plus,
                  outputMinus=conv_minus,
                  genome=mm9)

# Check it's still the same data
x <- import(bw_plus[1])
y <- import(bg_plus[1])
z <- import(conv_plus[1])
all(x == y)
all(x == z)
sum(score(x)) ==  sum(score(y))
sum(score(x)) ==  sum(score(z))
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/shape.R
\name{calcShape}
\alias{calcShape}
\alias{calcShape,GRanges,GRanges-method}
\alias{calcShape,RangedSummarizedExperiment,GRanges-method}
\alias{calcShape,GRanges,RangedSummarizedExperiment-method}
\alias{calcShape,GRanges,GPos-method}
\alias{calcShape,RangedSummarizedExperiment,RangedSummarizedExperiment-method}
\title{Calculate Tag Cluster shapes}
\usage{
calcShape(object, pooled, ...)

\S4method{calcShape}{GRanges,GRanges}(object, pooled, outputColumn = "IQR", shapeFunction = shapeIQR, ...)

\S4method{calcShape}{RangedSummarizedExperiment,GRanges}(object, pooled, ...)

\S4method{calcShape}{GRanges,RangedSummarizedExperiment}(object, pooled, ...)

\S4method{calcShape}{GRanges,GPos}(object, pooled, ...)

\S4method{calcShape}{RangedSummarizedExperiment,RangedSummarizedExperiment}(object, pooled, ...)
}
\arguments{
\item{object}{GenomicRanges or RangedSummarizedExperiment: TCs.}

\item{pooled}{GenomicRanges or RangedSummarizedExperiment: Pooled CTSS as the
score column.}

\item{...}{additional arguments passed to shapeFunction.}

\item{outputColumn}{character: Name of column to hold shape statistics.}

\item{shapeFunction}{function: Function to apply to each TC (See details).}
}
\value{
object with calculated shape statistics added as a column in rowData
  (or mcols).
}
\description{
Apply a shape-function to the pooled CTSS signal of every Tag Cluster (TC).
}
\examples{
data(exampleCTSSs)
data(exampleUnidirectional)

# Calculate pooled CTSSs using pre-calculated number of total tags:
exampleCTSSs <- calcTPM(exampleCTSSs, totalTags='totalTags')
exampleCTSSs <- calcPooled(exampleCTSSs)

# Calculate shape statistics
calcShape(exampleUnidirectional, pooled=exampleCTSSs,
    outputColumn='entropy', shapeFunction=shapeEntropy)
calcShape(exampleUnidirectional, pooled=exampleCTSSs, outputColumn='IQR',
    shapeFunction=shapeIQR, lower=0.2, upper=0.8)

# See the vignette for how to implement custom shape functions!
}
\seealso{
Other Calculation functions: 
\code{\link{calcBidirectionality}()},
\code{\link{calcComposition}()},
\code{\link{calcPooled}()},
\code{\link{calcSupport}()},
\code{\link{calcTPM}()},
\code{\link{calcTotalTags}()},
\code{\link{subsetByBidirectionality}()},
\code{\link{subsetByComposition}()},
\code{\link{subsetBySupport}()}

Other Shape functions: 
\code{\link{shapeEntropy}()},
\code{\link{shapeIQR}()},
\code{\link{shapeMean}()}
}
\concept{Calculation functions}
\concept{Shape functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/shape.R
\name{shapeIQR}
\alias{shapeIQR}
\title{Shape statitic: Interquartile range}
\usage{
shapeIQR(x, lower = 0.25, upper = 0.75)
}
\arguments{
\item{x}{numeric Rle vector: Coverage series.}

\item{lower}{numeric: Lower quartile.}

\item{upper}{numeric: Upper quartile.}
}
\value{
Numeric
}
\description{
Calculates the interquartile range of a vector.
}
\examples{
# Hypothetical shard/broad clusters:
x_sharp <- Rle(c(1,1,1,4,5,2,1,1))
x_broad <- Rle(c(1,2,3,5,4,3,2,1))

# Calculate IQR
shapeIQR(x_sharp)
shapeIQR(x_broad)

# See calcShape for more usage examples
}
\seealso{
Other Shape functions: 
\code{\link{calcShape}()},
\code{\link{shapeEntropy}()},
\code{\link{shapeMean}()}
}
\concept{Shape functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/enhancers.R
\name{subsetByBidirectionality}
\alias{subsetByBidirectionality}
\alias{subsetByBidirectionality,GRanges-method}
\alias{subsetByBidirectionality,GPos-method}
\alias{subsetByBidirectionality,RangedSummarizedExperiment-method}
\title{Subset by sample-wise bidirectionality of clusters.}
\usage{
subsetByBidirectionality(object, ...)

\S4method{subsetByBidirectionality}{GRanges}(
  object,
  samples,
  inputAssay = "counts",
  outputColumn = "bidirectionality",
  minSamples = 0
)

\S4method{subsetByBidirectionality}{GPos}(object, ...)

\S4method{subsetByBidirectionality}{RangedSummarizedExperiment}(object, ...)
}
\arguments{
\item{object}{GRanges or RangedSummarizedExperiment: Unstranded clusters with
peaks stored in the 'thick' column.}

\item{...}{additional arguments passed to methods.}

\item{samples}{RangedSummarizedExperiment: Sample-wise CTSSs stored as an
assay.}

\item{inputAssay}{character: Name of assay in samples holding input CTSS
values.}

\item{outputColumn}{character: Name of column in object to hold
bidirectionality values.}

\item{minSamples}{integer: Only regions with bidirectionality above this
value are retained.}
}
\value{
object with bidirectionality values added as a column, and low
  bidirectionaly regions removed.
}
\description{
A convenient wrapper around calcBidirectionality and subset.
}
\examples{
data(exampleCTSSs)
data(exampleBidirectional)

# Keep only clusters that are bidirectional in at least one sample:
subsetByBidirectionality(exampleBidirectional, samples=exampleCTSSs)
}
\seealso{
Other Subsetting functions: 
\code{\link{subsetByComposition}()},
\code{\link{subsetBySupport}()}

Other Calculation functions: 
\code{\link{calcBidirectionality}()},
\code{\link{calcComposition}()},
\code{\link{calcPooled}()},
\code{\link{calcShape}()},
\code{\link{calcSupport}()},
\code{\link{calcTPM}()},
\code{\link{calcTotalTags}()},
\code{\link{subsetByComposition}()},
\code{\link{subsetBySupport}()}
}
\concept{Calculation functions}
\concept{Subsetting functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/calc.R
\name{calcPooled}
\alias{calcPooled}
\title{Calculate pooled expression across all samples.}
\usage{
calcPooled(object, inputAssay = "TPM", outputColumn = "score")
}
\arguments{
\item{object}{RangedSummarizedExperiment: CAGE data quantified at CTSS,
cluster or gene-level.}

\item{inputAssay}{character: Name of assay holding input expression values.}

\item{outputColumn}{character: Name of column in rowRanges to hold pooled
expression.}
}
\value{
object with pooled expression added as a column
  in rowRanges.
}
\description{
Sum expression of features across all samples to obtain a 'pooled' signal.
}
\examples{
data(exampleCTSSs)

# Calculate TPM using supplied total number of tags:
exampleCTSSs <- calcTPM(exampleCTSSs, totalTags='totalTags')

# Sum TPM values over samples:
calcPooled(exampleCTSSs)
}
\seealso{
Other Calculation functions: 
\code{\link{calcBidirectionality}()},
\code{\link{calcComposition}()},
\code{\link{calcShape}()},
\code{\link{calcSupport}()},
\code{\link{calcTPM}()},
\code{\link{calcTotalTags}()},
\code{\link{subsetByBidirectionality}()},
\code{\link{subsetByComposition}()},
\code{\link{subsetBySupport}()}
}
\concept{Calculation functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/check.R
\name{checkPeaked}
\alias{checkPeaked}
\title{Helper for checking cluster with peaks}
\usage{
checkPeaked(object)
}
\arguments{
\item{object}{GRanges or GPos: Clusters with peaks to be checked.}
}
\value{
TRUE if object is correct format, otherwise an error is thrown
}
\description{
Checks whether a supplied set of cluster have valid peaks: Whether the thick
column contains IRanges all contained within the main ranges.
}
\examples{
data(exampleUnidirectional)
checkPeaked(rowRanges(exampleUnidirectional))
}
\seealso{
Other Checking functions: 
\code{\link{checkPooled}()}
}
\concept{Checking functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{utilsSimplifyTxDb}
\alias{utilsSimplifyTxDb}
\title{Utility: Extract annotation hierachy from a TxDb.}
\usage{
utilsSimplifyTxDb(
  object,
  tssUpstream = 100,
  tssDownstream = 100,
  proximalUpstream = 1000,
  detailedAntisense = FALSE
)
}
\arguments{
\item{object}{TxDb: Transcript database}

\item{tssUpstream}{integer: Distance to extend annotated promoter upstream.}

\item{tssDownstream}{integer: Distance to extend annotated promoter
downstream.}

\item{proximalUpstream}{integer: Maximum distance upstream of promoter to be
considered proximal.}

\item{detailedAntisense}{logical: Wether to mirror all txType categories in
the antisense direction (TRUE) or lump them all together (FALSE).}
}
\value{
GRangesList of annotation hierachy
}
\description{
Used by assignTxType. This function extracts the hierachical annotations used
by assignTxType from a TxDb object. If you are annotating many ranges, it can
be time saving to built the hierachy first, to avoid processing the TxDb for
every assignTxDb call.
}
\examples{
\dontrun{
data(exampleUnidirectional)

# Obtain transcript models from a TxDb-object:
library(TxDb.Mmusculus.UCSC.mm9.knownGene)
txdb <- TxDb.Mmusculus.UCSC.mm9.knownGene

# Simplify txdb
hierachy <- utilsSimplifyTxDb(txdb)

# Standard way of calling
x <- assignTxType(exampleUnidirectional,
                  txModels=txdb)

# Calling with premade hierachy
y <- assignTxType(exampleUnidirectional, txModels=hierachy)

# These are identical
stopifnot(all(rowRanges(x)$txType == rowRanges(y)$txType))
}
}
\seealso{
assignTxType

Other Utility functions: 
\code{\link{utilsAggregateRows}()},
\code{\link{utilsDeStrand}()},
\code{\link{utilsScoreOverlaps}()}
}
\concept{Utility functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/quick.R
\name{quickGenes}
\alias{quickGenes}
\title{Identify and quantify genes.}
\usage{
quickGenes(object, geneModels = NULL, ...)
}
\arguments{
\item{object}{RangedSummarizedExperiment: Location and counts of clusters,
usually found by calling quantifyClusters.}

\item{geneModels}{TxDb or GRanges: Gene models via a TxDb, or manually
specified as a GRangesList.}

\item{...}{additional arguments passed to assignGeneID.}
}
\value{
RangedSummarizedExperiment containing gene expression and clusters
  assigned within each gene.
}
\description{
A convienient wrapper around assignGeneID, and quantifyGenes. Also removes
unstranded features
}
\examples{
# See the CAGEfightR vignette for an overview!
}
\seealso{
Other Wrapper functions: 
\code{\link{quickEnhancers}()},
\code{\link{quickTSSs}()}
}
\concept{Wrapper functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/calc.R
\name{calcSupport}
\alias{calcSupport}
\title{Calculate support of CAGE data.}
\usage{
calcSupport(
  object,
  inputAssay = "counts",
  outputColumn = "support",
  unexpressed = 0
)
}
\arguments{
\item{object}{RangedSummarizedExperiment: CAGE data quantified at CTSS,
cluster or gene-level.}

\item{inputAssay}{character: Name of assay holding input expression values.}

\item{outputColumn}{character: Name of column in rowRanges to hold support
values.}

\item{unexpressed}{numeric: Support will be calculated based on features
larger than this cutoff.}
}
\value{
object with support added as a column in rowRanges.
}
\description{
Calculate the number of samples expression a feature above a certain level.
This number is refered to as the 'support'.
}
\examples{
data(exampleUnidirectional)

# Count samples with at at least a single tags
exampleUnidirectional <- calcSupport(exampleUnidirectional,
                                     inputAssay='counts',
                                     unexpressed=0)

# Count number of samples with more than 1 TPM and save as a new column.
exampleUnidirectional <- calcTPM(exampleUnidirectional,
                                 totalTags = 'totalTags')
exampleUnidirectional <- calcSupport(exampleUnidirectional,
                                     inputAssay='TPM',
                                     unexpressed=1,
                                     outputColumn='TPMsupport')
}
\seealso{
Other Calculation functions: 
\code{\link{calcBidirectionality}()},
\code{\link{calcComposition}()},
\code{\link{calcPooled}()},
\code{\link{calcShape}()},
\code{\link{calcTPM}()},
\code{\link{calcTotalTags}()},
\code{\link{subsetByBidirectionality}()},
\code{\link{subsetByComposition}()},
\code{\link{subsetBySupport}()}
}
\concept{Calculation functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/find.R
\name{findStretches}
\alias{findStretches}
\alias{findStretches,GRanges-method}
\alias{findStretches,RangedSummarizedExperiment-method}
\title{Find stretches of clusters}
\usage{
findStretches(object, ...)

\S4method{findStretches}{GRanges}(object, mergeDist = 10000L, minSize = 3L)

\S4method{findStretches}{RangedSummarizedExperiment}(
  object,
  inputAssay,
  mergeDist = 10000L,
  minSize = 3L,
  corFun = cor,
  ...
)
}
\arguments{
\item{object}{GRanges or RangedSummarizedExperiment: Clusters, possibly with
expression for calculating correlations.}

\item{...}{additional arguments passed to methods or ultimately corFun.}

\item{mergeDist}{integer: Maximum distance between clusters to be merged into
stretches.}

\item{minSize}{integer: Minimum number of clusters in stretches.}

\item{inputAssay}{character: Name of assay holding expression values (if
object is a RangedSummarizedExperiment)}

\item{corFun}{function: Function for calculating correlations. Should behave
and produce output similar to cor().}
}
\value{
A GRanges containing stretches with number of clusters and average
  pairwise correlations calculated. The revmap can be used to retrieve the
  original clusters (see example below.)
}
\description{
Finds stretches or groups of clusters along the genome, where each cluster is
within a certain distance of the next. Once stretches have been identified,
the average pairwise correlation between all clusters in the stretch is
calculated. A typical use case is to look for stretches of enhancers, often
refered to as "super enhancers".
}
\examples{
# Calculate TPM values for bidirectional clusters
data(exampleBidirectional)
BCs <- calcTPM(exampleBidirectional)

# Find stretches
pearson_stretches <- findStretches(BCs, inputAssay="TPM")

# Use Kendall instead of pearson and require bigger stretches
kendall_stretches <- findStretches(BCs, inputAssay="TPM",
                                   minSize=5, method="kendall")

# Use the revmap to get stretches as a GRangesList
grl <- extractList(rowRanges(BCs), kendall_stretches$revmap)
names(grl) <- names(kendall_stretches)
}
\seealso{
Other Spatial functions: 
\code{\link{findLinks}()},
\code{\link{trackLinks}()}
}
\concept{Spatial functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bw.R
\name{bwGenomeCompatibility}
\alias{bwGenomeCompatibility}
\title{Check if BigWig-files are compatible with a given genome.}
\usage{
bwGenomeCompatibility(plusStrand, minusStrand, genome)
}
\arguments{
\item{plusStrand}{BigWigFileList: BigWig files with plus-strand CTSS data.}

\item{minusStrand}{BigWigFileList: BigWig files with minus-strand CTSS data.}

\item{genome}{Seqinfo: Genome information.}
}
\value{
TRUE, raises an error if the supplied genome is incompabtible.
}
\description{
Given a genome, checks whether a series of BigWig-files are compatible by
checking if all common seqlevels have equal seqlengths.
}
\examples{
if (.Platform$OS.type != "windows") {
# Use the BigWig-files included with the package:
data('exampleDesign')
bw_plus <- system.file('extdata', exampleDesign$BigWigPlus,
                       package = 'CAGEfightR')
bw_minus <- system.file('extdata', exampleDesign$BigWigMinus,
                        package = 'CAGEfightR')

# Create two named BigWigFileList-objects:
bw_plus <- BigWigFileList(bw_plus)
bw_minus <- BigWigFileList(bw_minus)
names(bw_plus) <- exampleDesign$Name
names(bw_minus) <- exampleDesign$Name

# Make a smaller genome:
si <- seqinfo(bw_plus[[1]])
si <- si['chr18']

# Check if it is still compatible:
bwGenomeCompatibility(plusStrand=bw_plus, minusStrand=bw_minus, genome=si)
}
}
\seealso{
Other BigWig functions: 
\code{\link{bwCommonGenome}()},
\code{\link{bwValid}()}
}
\concept{BigWig functions}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/enhancers.R
\name{balanceBC}
\alias{balanceBC}
\title{Balance statistic: Bhattacharyya coefficient (BC)}
\usage{
balanceBC(PD, MD, PU, MU)
}
\arguments{
\item{PD}{Plus-Downstream signal}

\item{MD}{Minus-Downstream signal}

\item{PU}{Plus-Upstream signal}

\item{MU}{Plus-Upstream signal}
}
\value{
Balance score of the same class as inputs.
}
\description{
Calculates the Bhattacharyya coefficient from observed plus/minus
upstream/downstream signals to a perfect bidirectional site, where
plus-downstream = 50% and minus-downstream = 50%
}
\examples{
# Unbalanced
balanceBC(2, 3, 1, 0)

# Balanced
balanceBC(3, 3, 0, 0)
}
